/*
 * Test program for CLOCK_TRAP and INTERRUPT_TRAP
 *
 * To compile:
 *
 *      xpl test-traps.xpl
 *
 * To run:
 *
 *      xplsm -p test-traps [--trace] [trace]
 */

DECLARE (I, J, K, BC, TC, DELTA) FIXED;
DECLARE trace BIT(8);

IF PARMSTRING = 'trace' THEN
  trace = 1;
ELSE
  trace = 0;


 Hex:
    PROCEDURE(INTEGER) CHARACTER ;
       DECLARE (I,K,INTEGER) FIXED, T CHARACTER INITIAL('        ');
       IF INTEGER = 0 THEN
          RETURN '0';
       K = 7;
       DO WHILE (INTEGER ~= 0) & (K >= 0);
          I = BYTE('0123456789ABCDEF',INTEGER&"0F");
          BYTE(T,K) = I;
          K = K - 1;
          INTEGER = SHR(INTEGER, 4);
       END;
       RETURN SUBSTR(T,K+1);
    END  Hex  ;


IF 0 THEN
   DO;
CTRET:
      IF trace THEN
         CALL UNTRACE;
      K = TIME;
      OUTPUT = 'Clock trap hit!  TIME=' || K || ', ELAPSED=' || (K - J) || ', I=' || I;
      I = MONITOR_LINK(0) - INLINE(mov,r32,r32,none, 5, 5);
      OUTPUT = 'MONITOR_LINK() = ' || Hex(MONITOR_LINK(0)) ||
                        ' [offset ' || Hex(I) || '], ' || MONITOR_LINK(1);
   END;
ELSE
   DO;
      // This may need to be adjusted based on the speed of your system
      IF trace THEN
         CALL CLOCK_TRAP( 40, ADDR(CTRET) );
      ELSE
         CALL CLOCK_TRAP( 10, ADDR(CTRET) );

      J = TIME;
      OUTPUT = 'PBR = ' || INLINE(mov,r32,r32,none, 5, 5);
      OUTPUT = 'Clock trap enabled.  TIME=' || J;
      IF trace THEN
         DO;
            CALL TRACE;

            // This may need to be adjusted based on the speed of your system
            DO I = 0 TO 1000;
            END;
         END;
      ELSE
         // This may need to be adjusted based on the speed of your system
         DO I = 0 TO 1000000;
         END;
   END;

K = 0;
IF 0 THEN
   DO;
ITRET:IF trace THEN
         CALL UNTRACE;
      OUTPUT = 'Interrupt trap hit!' || '  K=' || K;
      I = MONITOR_LINK(0) - INLINE(mov,r32,r32,none, 5, 5);
      OUTPUT = 'MONITOR_LINK() = ' || Hex(MONITOR_LINK(0)) ||
                        ' [offset ' || Hex(I) || '], ' || MONITOR_LINK(1);
      K = K + 1;
      IF K < 5 THEN
         GOTO AGAIN;
   END;
ELSE
   DO;
      CALL INTERRUPT_TRAP( SHL(1,8), ADDR(ITRET) );
      OUTPUT = 'PBR = ' || INLINE(mov,r32,r32,none, 5, 5);
      OUTPUT = 'Interrupt trap enabled.';
AGAIN:IF trace THEN
         CALL TRACE;
      I = 0;
      K = K / I;
   END;

RETURN 0;

/* vi: set sw=3 ai sm expandtab: */
