.TH XPL 1 \" -*- nroff -*-
.SH NAME
xpl \- Compile an XPL program
.SH SYNOPSIS
.B xpl
[\-Dname[=value]]
[\-Uname]
[\-\-mmap]
[\-\-nommap]
[{-z | \-\-zip\}]
[{\-m | \-\-maxcore} memorysize]
[{\-l | \-\-lines\-per\-page} linesperpage]
[\-o filename]
[\-x]
[flagon=C]
[flagoff=C]
file...
.SH DESCRIPTION
.B xpl
compiles an XPL program.
For each source
.I file
(which must have
.B .xpl
as a suffix), the XPL compiler is executed to produce
the resulting listing file
.IB file .list
and the load file
.IR file .
The
.IR xplsm (1)
command may be used to execute the resulting load file.
.PP
.B xpl
takes the following arguments:
.TP
\fB\-D\fIname\fR[=\fIvalue\fR]
.nr dp \n(PD
.nr PD 0
.TP
.BI \-U name
.nr PD \n(dp
.br
These arguments are passed to the C preprocessor which is used to process the
XPL program source.
.TP
.IR \-z ,\   \-\-zip
The load file will be compressed with
.IR gzip (1).
.TP
.I \-\-mmap
If
.B xplsm
was compiled with support for
.IR mmap (2),
then mmap will be used to map the code section of the XPL compiler.
This is the default.
.TP
.I \-\-nommap
Mmap will not be used to map the code section of the XPL compiler.
.TP
.IR \-m ,\  \-\-maxcore \  size
The size of the dynamic string area used by the compiler is set to
.I size.
It defaults to 65K.
.TP
.IR \-l ,\  \-\-lines\-per\-page \  lines
A form feed character (^L) is inserted automatically into the listing file after
.I lines
lines have been written.
If
.I lines
is zero, then no form feed characters are automatically inserted.
The default is 60 lines.
.TP
.IR \-o \  filename
If a single XPL program is being compiled, the load file will be
named
.I filename
rather than being derived from the name of the XPL source file.
.TP
.I \-x
The load file will be made executable by prepending
.BR #!xplsm\ -p .
.TP
.BI flagon= C
.nr PD 0
.TP
.BI flagoff= C
.nr PD \n(dp
The compiler toggle
.RI $ C
can be either turned on or off, and takes effect as soon as the
first statement of the XPL program is read.
.TP
.IB file .xpl
Each file with a suffix of
.B .xpl
is taken to be an XPL program source file.
It is compiled by
.BR xcom ,
the XPL compiler.
.SH ENVIRONMENT
The environment variable
.BR COMPACTIFY ,
if set, specifies the name of the XPL dynamic string area compaction
library routine.
.P
The environment variable
.BR XCOM ,
if set, specifies the name of the load file for the XPL compiler.
.SH FILES
.TP
$PREFIX/xpl/compactify.xpl
The XPL dynamic string area compaction library routine.
.TP
$PREFIX/xpl/xcom
The load file for the XPL compiler.
.TP
.I file
The load file for the XPL program source
.IB file .xpl\fR.
.TP
.IR file .list
The listing file for the XPL program source
.IB file .xpl\fR.
.SH "SEE ALSO"
.IR xplsm (1)
.SH AUTHOR
David E. Bodenstab (imdave@mcs.net)
