                                                                              /*
   ooooooo  ooooo   .oooooo.     .oooooo.   ooo        ooooo
    `8888    d8'   d8P'  `Y8b   d8P'  `Y8b  `88.       .888'
      Y888..8P    888          888      888  888b     d'888
       `8888'     888          888      888  8 Y88. .P  888
      .8PY888.    888          888      888  8  `888'   888
     d8'  `888b   `88b    ooo  `88b    d88'  8    Y     888
   o888o  o88888o  `Y8bood8P'   `Y8bood8P'  o8o        o888o


                       THE COMPILER FOR   X P L


W. M. MCKEEMAN         J. J. HORNING           D. B. WORTMAN

INFORMATION &          DEPARTMENT OF           DEPARTMENT OF
COMPUTER SCIENCE,      COMPUTER SCIENCE,       COMPUTER SCIENCE,

UNIVERSITY OF          UNIVERSITY OF           UNIVERSITY OF
CALIFORNIA AT          TORONTO                 TORONTO

SANTA CRUZ,            TORONTO 181,            TORONTO 181,
CALIFORNIA             ONTARIO                 ONTARIO
95060                  CANADA                  CANADA

DEVELOPED AT THE STANFORD COMPUTATION CENTER, CAMPUS FACILITY,   1966-69
AND THE UNIVERSITY OF CALIFORNIA COMPUTATION CENTER, SANTA CRUZ, 1968-69.

FURTHER REFINED AT THE UNIVERSITY OF TORONTO    1969-1972

DISTRIBUTED BY THE SHARE-COSMIC ORGANIZATION AS PROGRAM 360D-03.2.015
                                                                              */
//
// $Id: xcom.xpl,v 4.1.2.27 1996/09/22 01:35:15 DaveBodenstab Exp $
//
// All modifications copyright 1996, David E. Bodenstab
// All rights reserved.
//
// $Log: xcom.xpl,v $
// Revision 4.1.2.27  1996/09/22 01:35:15  DaveBodenstab
// Used GNU's superopt to determine length() code sequence: it's longer,
//     but there are no jumps
// Test bit 0 with AND =1 for booleans, not BT
// Use NOT for ~ operator, not XOR
//
// Revision 4.1.2.26  1996/07/12 04:14:22  DaveBodenstab
// Change everything to lower case -- I got tired of holding the shift key...
//
// Revision 4.1.2.25  1996/07/12  03:19:56  DaveBodenstab
// Reserved words can now be either upper or lower case
// Initialize the symbol table with lower case versions of builtin
//     functions/variables
// Accept lower case hexadecimal digits in bit strings
// Optimize BYTE() further for constant arguments and fix possible reference
//     of uninitialized variables
// The emitted code for BYTE() now checks for the nul string before attempting
//     an access
// Use jsr for the mnemonic for call since CALL is a reserved word
// Use sll for the mnemonic for shl since SHL is a reserved word
// Use slr for the mnemonic for shr since SHR is a reserved word
//
// Revision 4.1.2.24  1996/07/06  00:47:03  DaveBodenstab
// Report compilation rate in cards per second
//
// Revision 4.1.2.23  1996/07/04  05:56:22  DaveBodenstab
// Use constants for references to compiler work files
//
// Revision 4.1.2.22  1996/07/04  05:49:03  DaveBodenstab
// Fix code generation bug for FILE/INPUT/OUTPUT using a constant greater than 2
//
// Revision 4.1.2.21  1996/07/03  04:41:32  DaveBodenstab
// Use '=' to indicate immediate operand for CONTROL('E') toggle
// Issue an error if attempt is made to reference FILE(0,*)
//
// Revision 4.1.2.20  1996/07/02  04:42:31  DaveBodenstab
// Optimize assignments where right hand side is a constant
// Optimize assignment where right hand side is a constant and left side
//     is BYTE()
// Take advantage of constant folding to initialize the globals containing
//     the INST() calls used
//
// Revision 4.1.2.19  1996/07/01  00:52:21  DaveBodenstab
// Incorporate the latest output from ANALYZER; the only difference seems
//     to be C1(<PROGRAM>,_|_) = N (both the original ANAL and a newly
//     compiled analyzer.xpl produce the same output, but the source
//     published in the book has ILLEGAL SYMBOL PAIR!)
// Shorten some lines for readability
//
// Revision 4.1.2.18  1996/06/29  21:37:38  DaveBodenstab
// Use new template tables generated by template.xpl
// Use index register to compute service code for FILE() I/O
// Print all numeric values in hex for CONTROL('E') output
// Optimize constant "subscripts" for INPUT, OUTPUT and FILE
// Specify a prefered register to load non-constant "subscripts" for INPUT,
//     OUTPUT and FILE
// Do some minor code optimizations
//
// Revision 4.1.2.17  1996/06/29  01:21:42  DaveBodenstab
// Trace resume entry must call xplsm to provide the values of DBR and SBR
//
// Revision 4.1.2.16  1996/06/28  07:57:33  DaveBodenstab
// Use the ability to specify relative jumps in INLINE code
// Do some minor code optimization and cleanup
// Remove leftover debugging code
//
// Revision 4.1.2.15  1996/06/27  06:51:27  DaveBodenstab
// Add flag from EMIT_INLINE to let emit() know that a rel8/rel32 operand
//     is absolute, not relative
// Reposition comment for resume entry
//
// Revision 4.1.2.14  1996/06/27  04:22:46  DaveBodenstab
// Fix code generation bug for 16-bit immediate values:
//     Remove OPSZ opcode
//     Add 'b' and 'w' suffix to opcodes so we know what instruction is used
//     Add opcode index to the template() value
//     Add m16 and imm16 operand types
//     Change emit() to support m16 and imm16 operand types
// Change EMIT_INLINE() to support new template encoding
// The instruction codes (such as 'mov') no longer can be used to index into
//     the iAPX486 opcode table; the TEMPLATE array must be used to cross
//     reference the instruction code to the opcode
// Change code generation to use the new movw instructions to fetch/store
//     BIT(16) values
// Use C preprocessor to enable or disable the use of INLINE in xcom
//     itself; since the template table and operand values changed, INLINE
//     will not work for a self-compile
// Add entry point for TRACE to resume when the XPL program calls UNTRACE
//     if tracing was enabled (via xplsm --trace) at initial entry
// Remove initial 'cld' instruction since each routine dependent on the
//     DF issues the 'cld' itself
// Remove templates for 'lea' with operands other than m32; they are all
//     equivalent, so why waste the space
// Use the singular 'time' in the symbol dump when a symbol has only been
//     referenced one time
//
// Revision 4.1.2.13  1996/06/19  07:20:40  DaveBodenstab
// Use INLINE to speed up code to skip blanks in SCAN()
// Use INLINE to pack the top four bytes of PARSE_STACK in REDUCE()
//
// Revision 4.1.2.12  1996/06/19  06:46:01  DaveBodenstab
// Restore use of INLINE in ERROR() to compute xcom offset
// Support single, constant argument to INLINE() to emit an arbitrary byte
//
// Revision 4.1.2.11  1996/06/19  04:53:17  DaveBodenstab
// Support the INLINE builtin function
// Have emit() return a success code so EMIT_INLINE() can tell if there was
//     an error
// Add $I compiler toggle to print emit debugging info
// Allow symbolic names for the first four arguments to INLINE
// If the third argument to SUBSTR is zero, the result is the null string
// Remove EMITCODEBYTES() since it is no longer being used
// Set the base register in the symbol table for procedure names
// Print the number of string collections done by COMPACTIFY
// When printing opcodes, tack on 'cc' to 'j' and 'set'
// Cleanup some code for efficiency
// Add comment showing the initial symbol table
//
// Revision 4.1.2.10  1996/06/18  08:04:12  DaveBodenstab
// Initialize global variables one time with all INST() calls used
// Declare arguments of INST() as BIT(8) to make move of immediate constants
//     use imm8 rather than imm32
// Rearrange order of startup code
// Use a compare instruction to set condition codes in string compare builtin
// For debugging, print labels of startup and builtin functions if CONTROL('E')
//     is true
// Tell PRINT_TIME whether to format the time as AM/PM or as absolute value
// Set multiply commutative since the imul instruction is not funny on Intel
// Do constant folding for divide and MOD
// Use parenthesis to take advantage of constant folding
// Do some general code optimizations:
//     use constants instead of variables if possible
//     use temporarys rather than constantly dereferencing subscripted variables
// Fix inadvertant omission of left padding for CONTROL('E') output
// Use index registers for references to subscripted variables
// Use index register for DO CASE
// Use index register for BYTE()
// Use index register in RELOCATE_DESCRIPTORS_CODE
// Optimize constant subscripts
// Optimize BYTE(*,N) where N is a constant
// Fix assignment to BYTE(*,N) where N is a constant
// Do constant folding for SHL and SHR
//
// Revision 4.1.2.9  1996/06/17  04:04:56  DaveBodenstab
// Added additional toggle controls: >$X saves the value of code X
//                                   <$X restores the value of code X
//                                   ?$X toggles the value of code X
// Added most all remaining iAPX486 instructions to the instruction template
// Modified emit() to support index registers and omitted base register
// Use NUMOPCODES to size tables dependent on number of opcodes
// Since MONITOR_LINK(1) is at PBR,0 then ADDR(MONITOR_LINK) is equal to PBR
//     so we do not need INLINE to get the value of PBR in ERROR()
// Do not mask off the high order bits of the instruction address when
//     computing the offset of the error
// Use parenthesis to take advantage of new constant folding
// Rearrange code to take advantage of new register reuse which allows more
//     complicated expressions before running out of accumulators
// Fix ADDR() for built-in functions
// Use NOP/OPSZ opcodes instead of XCHG/call Emit1CodeByte()
// Fix unconditional branch when constant is used in an IF statement
// Generate instructions to call xplsm to provide the values of DBR and SBR
//     at program startup
// Use AM or PM when printing the time
//
// Revision 4.1.2.8  1996/06/15  05:20:49  DaveBodenstab
// Fix logic to place pointer on source line under error/resume point
// Add new 48-bit template in anticipation of supporting index registers and
//     more instructions
// Re-use index register on fetching byte variables rather than allocating a
//     new accumulator
// Do constant folding for arithmetic ops and unary ~
// Convert numeric constants to strings at compile time
// Remove incorrect compare for S/360 op code for SHL/SHR builtin's
// Add $X compiler toggle to print macro expansions
// Add counter for GETSTRINGS
// Group similar statistics together on listing
// Replace all remaining #define's with DECLARE LITERALLY's
//
// Revision 4.1.2.7  1996/06/14  07:02:46  DaveBodenstab
// Increase SYTSIZE in anticipation of additional code changes
// Increase MACRO_LIMIT in anticipation of converting #define's to LITERAL's
// Convert instruction template to a BIT(48) array
// Convert opcode table to an array
// Remove trim() since it was no longer being used
//
// Revision 4.1.2.6  1996/06/14  02:43:59  DaveBodenstab
// Change long character strings to arrays where appropriate
// Reset SEVERITY to 0 at end of ERROR()
// Remove a SEVERITY argument of 0 from calls to ERROR()
// Store constant arguments directly into parameter rather than loading a
//     register and then doing a store
// Align builtin function entry points to a word boundry
// When printing the date, print the weekday also
//
// Revision 4.1.2.5  1996/06/13  23:30:41  DaveBodenstab
// Increase MACRO_LIMIT to 50 macros
// Increase SYTSIZE to 500 symbols
// Remove error message for missing EOF
// Fix COREHALFWORD()
// Fix DIVIDE_CODE() to temporarily save edx if possible before giving up
// Do not emit useless "or reg,0" instruction for builtin SUBSTR
// Do not commute an operation if the right hand side is a constant
// Change Iformat() to left-pad with a caller specified character
// Always print hour/minute/second as two decimal digits
// Correctly print the maximum number of symbols allowed in the symbol table
// Correctly print the size of the maximum allowed descriptors
// Cleanup some comments
//
// Revision 4.1.2.4  1996/05/31  03:54:17  DaveBodenstab
// Cleaned up source now that lines can be longer than 80 characters
// Printed the limits for various data structures in the statistics
// Added counter for emit() calls
// Used INC and DEC for +/- 1
// Got rid of TYPENAME_INDEX array
//
// Revision 4.1.2.3  1996/05/30  07:20:11  DaveBodenstab
// Un-comment the remaining portions of the compiler that caused the descriptor
//     table to overflow.  The compiler now no longer has a fixed limit for the
//     string descriptors.
//
// Revision 4.1.2.2  1996/05/30  07:00:07  DaveBodenstab
// Change all output to use lower case
// Add back instruction counting
// Remove the 4K limit on string descriptors
//
// Revision 4.1.2.1  1996/05/29  08:18:30  DaveBodenstab
// Port to iAPX486
//
// Revision 4.1  1996/05/18  04:12:32  DaveBodenstab
// Insert RCS $Id and $Log
// Add RCS $Log information for revisions prior to the previous revision
// Document the compiler control toggles in a comment
// When PARSEPARMSTRING() recognizes $T or $U, call TRACE/UNTRACE as required
// All accumulators in use is now a severe error, not a warning
//
// Revision 4.0  1996/05/17  07:49:51  DaveBodenstab
// Print XCOM location in hex in error messages
// Eliminate non-portable character set assumptions
// Allow lower case characters in identifiers
// Reclaim a few string descriptors
// Use RCS $Revison in the banner printed at the top of the source listing
// Detect and handle C++ style comments
// Support PARMSTRING parameters FLAGON=x and FLAGOFF=x to set/clear compiler
//     control toggles
// An undefined label is now a severe error, not a warning
// A missing EOF can no longer be caused by a "/*" in column 1, so remove the
//     misleading portion of the error message
//
// Revision 3.0  1984/01/07  00:00:00  UniversityOfToronto
// University of Toronto Version 3, 1969-1972
//
// Revision 1.0  1972/01/01  00:00:00  McKeemanHorningWortman
// SHARE Version 1, January 1972
//
//
//
// COMPILER CONTROL TOGGLES:
//
//   Within a /* ... */ comment, "$x" turns on code x, "~$x" turns off code x,
//   ">$x" saves the value of code x, "<$x" restores the value of code x, and
//   "?$x" toggles code x.
//
//    Code  Default    Description
//   +----+----------+----------------------------------------------------------
//   | $B |  False   | Toggle listing of raw code bytes
//   | $D |  True    | Toggle symbol table listing when completion complete
//   | $E |  False   | Toggle listing of generated instructions and data
//   | $I |  False   | Toggle debug output from emit()
//   | $L |  True    | Toggle source listing
//   | $M |  False   | Toggle input source printing; takes precedence over $L
//   | $N |  False   | Toggle warning for procedures called with fewer
//   |    |          | parameters than declared
//   | $S |  False   | Toggle symbol table listing at end of each procedure
//   | $T |  False   | Call TRACE
//   | $U |  False   | Call UNTRACE
//   | $X |  False   | Show macro expansions
//   | $Z |  False   | Toggle override inhibition of execution for severe errors
//   | $| | Infinity | Set right margin for successive input records
//   +----+----------+----------------------------------------------------------
//

   /*  FIRST WE INITIALIZE THE GLOBAL CONSTANTS THAT DEPEND UPON THE INPUT
      GRAMMAR.  THE FOLLOWING CARDS ARE PUNCHED BY ANALYZER.         */

   DECLARE NSY LITERALLY '91', NT LITERALLY '42';
   DECLARE V(NSY) CHARACTER INITIAL ( '<ERROR: TOKEN = 0>', ';', ')', '(', ',',
      ':', '=', '|', '&', '~', '<', '>', '+', '-', '*', '/', 'IF', 'DO', 'TO',
      'BY', 'GO', '||', '_|_', 'END', 'BIT', 'MOD', 'THEN', 'ELSE', 'CASE',
      'CALL', 'GOTO', 'WHILE', 'FIXED', 'LABEL', 'RETURN', 'DECLARE', 'INITIAL',
      '<STRING>', '<NUMBER>', 'PROCEDURE', 'LITERALLY', 'CHARACTER',
      '<IDENTIFIER>', '<TYPE>', '<TERM>', '<GROUP>', '<GO TO>', '<ENDING>',
      '<PROGRAM>', '<REPLACE>', '<PRIMARY>', '<VARIABLE>', '<BIT HEAD>',
      '<CONSTANT>', '<RELATION>', '<STATEMENT>', '<IF CLAUSE>', '<TRUE PART>',
      '<LEFT PART>', '<ASSIGNMENT>', '<EXPRESSION>', '<GROUP HEAD>',
      '<BOUND HEAD>', '<IF STATEMENT>', '<WHILE CLAUSE>', '<INITIAL LIST>',
      '<INITIAL HEAD>', '<CASE SELECTOR>', '<STATEMENT LIST>',
      '<CALL STATEMENT>', '<PROCEDURE HEAD>', '<PROCEDURE NAME>',
      '<PARAMETER LIST>', '<PARAMETER HEAD>', '<LOGICAL FACTOR>',
      '<SUBSCRIPT HEAD>', '<BASIC STATEMENT>', '<GO TO STATEMENT>',
      '<STEP DEFINITION>', '<IDENTIFIER LIST>', '<LOGICAL PRIMARY>',
      '<RETURN STATEMENT>', '<LABEL DEFINITION>', '<TYPE DECLARATION>',
      '<ITERATION CONTROL>', '<LOGICAL SECONDARY>', '<STRING EXPRESSION>',
      '<DECLARATION ELEMENT>', '<PROCEDURE DEFINITION>',
      '<DECLARATION STATEMENT>', '<ARITHMETIC EXPRESSION>',
      '<IDENTIFIER SPECIFICATION>');
   DECLARE V_INDEX(12) BIT(8) INITIAL ( 1, 16, 22, 26, 31, 34, 35, 37, 39, 42,
      42, 42, 43);
   DECLARE C1(NSY) BIT(86) INITIAL (
      "(2) 00000 00000 00000 00000 00000 00000 00000 00000 000",
      "(2) 02000 00000 00000 02200 20220 00202 20002 20000 002",
      "(2) 02222 02222 22222 20022 02003 22000 00330 02000 030",
      "(2) 00030 00003 00330 00000 00000 00000 00000 00330 003",
      "(2) 00030 00002 00220 00000 00000 00000 00000 00220 003",
      "(2) 02000 00000 00000 02200 20020 00002 20002 20002 002",
      "(2) 00020 00002 00220 00000 00000 00000 00000 00220 002",
      "(2) 00010 00001 00110 00000 00000 00000 00000 00110 001",
      "(2) 00010 00001 00110 00000 00000 00000 00000 00110 001",
      "(2) 00010 01000 11110 00000 00000 00000 00000 00110 001",
      "(2) 00020 01000 00220 00000 00000 00000 00000 00220 002",
      "(2) 00020 01000 00220 00000 00000 00000 00000 00220 002",
      "(2) 00010 00000 00000 00000 00000 00000 00000 00110 001",
      "(2) 00010 00000 00000 00000 00000 00000 00000 00110 001",
      "(2) 00010 00000 00000 00000 00000 00000 00000 00110 001",
      "(2) 00010 00000 00000 00000 00000 00000 00000 00110 001",
      "(2) 00010 00001 00110 00000 00000 00000 00000 00110 001",
      "(2) 01000 00000 00000 00000 00000 00010 01000 00000 001",
      "(2) 00010 00001 00110 00000 00000 00000 00000 00110 003",
      "(2) 00010 00001 00110 00000 00000 00000 00000 00110 001",
      "(2) 00000 00000 00000 00010 00000 00000 00000 00000 000",
      "(2) 00010 00000 00110 00000 00000 00000 00000 00110 001",
      "(2) 01000 00000 00000 01100 10000 00001 10001 10000 001",
      "(2) 02000 00000 00000 00000 00000 00000 00000 00000 001",
      "(2) 00010 00000 00000 00000 00000 00000 00000 00000 000",
      "(2) 00010 00000 00000 00000 00000 00000 00000 00110 001",
      "(2) 02000 00000 00000 02200 20000 00002 20002 20000 002",
      "(2) 02000 00000 00000 02200 20000 00002 20002 20000 002",
      "(2) 00010 00001 00110 00000 00000 00000 00000 00110 001",
      "(2) 00000 00000 00000 00000 00000 00000 00000 00000 001",
      "(2) 00000 00000 00000 00000 00000 00000 00000 00000 002",
      "(2) 00010 00001 00110 00000 00000 00000 00000 00110 001",
      "(2) 02002 00000 00000 00000 00000 00000 00000 02000 000",
      "(2) 02002 00000 00000 00000 00000 00000 00000 02000 000",
      "(2) 02010 00001 00110 00000 00000 00000 00000 00110 001",
      "(2) 00010 00000 00000 00000 00000 00000 00000 00000 001",
      "(2) 00010 00000 00000 00000 00000 00000 00000 00000 000",
      "(2) 02202 02222 22222 20022 02000 22000 00000 00000 000",
      "(2) 02302 02222 22222 20022 02000 22000 00000 00000 000",
      "(2) 02020 00000 00000 00000 00002 00000 00220 00000 020",
      "(2) 00000 00000 00000 00000 00000 00000 00000 00100 000",
      "(2) 02002 00000 00000 00000 00000 00000 00000 02000 000",
      "(2) 02333 12222 22222 20022 02002 22000 00220 00000 120",
      "(2) 03002 00000 00000 00000 00000 00000 00000 02000 000",
      "(2) 02202 02222 22221 10022 02000 12000 00000 00000 000",
      "(2) 01000 00000 00000 00000 00000 00000 00000 00000 000",
      "(2) 00000 00000 00000 00000 00000 00000 00000 00000 001",
      "(2) 02000 00000 00000 00000 00000 00000 00000 00000 000",
      "(2) 00000 00000 00000 00000 00200 00000 00000 00000 000",
      "(2) 00010 00001 00110 00000 00000 00000 00000 00110 001",
      "(2) 02202 02222 22222 20022 02000 22000 00000 00000 000",
      "(2) 02203 03222 22222 20022 02000 22000 00000 00000 000",
      "(2) 00000 00000 00000 00000 00000 00000 00000 00010 000",
      "(2) 02303 02222 22222 20022 02000 22000 00000 00000 000",
      "(2) 00010 00000 00110 00000 00000 00000 00000 00110 001",
      "(2) 02000 00000 00000 02200 20220 00002 20002 20000 002",
      "(2) 01000 00000 00000 01100 10000 00001 10001 10000 001",
      "(2) 01000 00000 00000 01100 10000 00001 10001 10000 001",
      "(2) 00000 00000 00000 00000 00000 00000 00000 00000 001",
      "(2) 03000 00000 00000 00000 00000 00000 00000 00000 000",
      "(2) 02101 00100 00000 00011 00000 01000 00000 00000 000",
      "(2) 01000 00000 00000 01100 10010 00001 10001 10000 001",
      "(2) 00000 00000 00000 00000 00000 00000 00000 00010 000",
      "(2) 02000 00000 00000 02200 20220 00002 20002 20000 002",
      "(2) 01000 00000 00000 00000 00000 00000 00000 00000 000",
      "(2) 02002 00000 00000 00000 00000 00000 00000 02000 000",
      "(2) 00000 00000 00000 00000 00000 00000 00000 00110 000",
      "(2) 01000 00000 00000 00000 00000 00000 00000 00000 000",
      "(2) 01000 00000 00000 01100 10210 00001 10001 10000 001",
      "(2) 01000 00000 00000 00000 00000 00000 00000 00000 000",
      "(2) 01000 00000 00000 01100 10000 00001 10001 10000 001",
      "(2) 01010 00000 00000 00000 00001 00000 00110 00000 010",
      "(2) 01000 00000 00000 00000 00001 00000 00110 00000 010",
      "(2) 00000 00000 00000 00000 00000 00000 00000 00000 001",
      "(2) 02202 00210 00000 00022 00000 02000 00000 00000 000",
      "(2) 00010 00001 00110 00000 00000 00000 00000 00110 001",
      "(2) 02000 00000 00000 02200 20220 00302 20002 20000 002",
      "(2) 01000 00000 00000 00000 00000 00000 00000 00000 000",
      "(2) 01000 00000 00000 00000 00000 00000 00000 00000 000",
      "(2) 00000 00000 00000 00000 00000 00000 00000 00000 001",
      "(2) 02202 00220 00000 00022 00000 02000 00000 00000 000",
      "(2) 01000 00000 00000 00000 00000 00000 00000 00000 000",
      "(2) 01000 00000 00000 01100 10010 00001 10001 10001 001",
      "(2) 02002 00000 00000 00000 00000 00000 00000 01000 000",
      "(2) 02000 00000 00000 00000 00000 00000 00000 00000 000",
      "(2) 02202 00220 00000 00022 00000 02000 00000 00000 000",
      "(2) 02202 01221 11000 00022 01000 02000 00000 00000 000",
      "(2) 02002 00000 00000 00000 00000 00000 00000 00000 000",
      "(2) 01000 00000 00000 00000 00000 00000 00000 00000 000",
      "(2) 01001 00000 00000 00000 00000 00000 00000 00000 000",
      "(2) 02202 02222 22110 00022 02000 02000 00000 00000 000",
      "(2) 00010 00000 00000 00000 00001 00000 00110 00000 010");
   DECLARE NC1TRIPLES LITERALLY '203';
   DECLARE C1TRIPLES(NC1TRIPLES) FIXED INITIAL ( 197379, 197385, 197388, 197389,
      197413, 197414, 197418, 207363, 459523, 459529, 459532, 459533, 459557,
      459558, 459562, 469507, 525059, 525065, 525068, 525069, 525093, 525094,
      525098, 535043, 590595, 590601, 590604, 590605, 590629, 590630, 590634,
      600579, 787203, 787209, 787212, 787213, 787237, 787238, 787242, 797187,
      852739, 852745, 852748, 852749, 852773, 852774, 852778, 862723, 918275,
      918281, 918284, 918285, 918309, 918310, 918314, 928259, 983811, 983817,
      983820, 983821, 983845, 983846, 983850, 993795, 1049347, 1049353, 1049356,
      1049357, 1049381, 1049382, 1049386, 1059331, 1124867, 1127174, 1180419,
      1180425, 1180428, 1180429, 1180453, 1180454, 1180458, 1190403, 1245955,
      1245961, 1245964, 1245965, 1245989, 1245990, 1245994, 1255939, 1377027,
      1377033, 1377036, 1377037, 1377061, 1377062, 1377066, 1387011, 1452547,
      1454852, 1454854, 1456897, 1639171, 1639177, 1639180, 1639181, 1639205,
      1639206, 1639210, 1649155, 1835779, 1835785, 1835788, 1835789, 1835813,
      1835814, 1835818, 1845763, 1911299, 2032387, 2032393, 2032396, 2032397,
      2032421, 2032422, 2032426, 2042371, 2228995, 2229001, 2229004, 2229005,
      2229029, 2229030, 2229034, 2238979, 2490904, 2490912, 2490913, 2490921,
      3212035, 3212041, 3212044, 3212045, 3212069, 3212070, 3212074, 3222019,
      3417602, 3539715, 3539721, 3539724, 3539725, 3539749, 3539750, 3539754,
      3549699, 3680771, 3683076, 3683078, 3685121, 3689499, 3746307, 3748612,
      3748614, 3750657, 3811843, 3814148, 3814150, 3936810, 4008451, 4010756,
      4010758, 4012801, 4072962, 4338946, 4338948, 4467203, 4469508, 4469510,
      4471553, 4598275, 4600580, 4600582, 4602625, 4664065, 4729601, 4794882,
      4794884, 4915971, 4915977, 4915980, 4915981, 4916005, 4916006, 4916010,
      4925955, 5188098, 5188100, 5384707, 5387012, 5387014, 5389057, 5833731,
      5833770);
   DECLARE PRTB(109) FIXED INITIAL (0, 4671531, 18219, 18248, 4430, 4416, 4419,
      71, 17, 59, 45, 88, 81, 69, 77, 89, 0, 16949, 18730, 13350, 20266, 828,
      19260, 91, 36, 24, 42, 0, 0, 18730, 20266, 16949, 19260, 51, 42, 9, 10,
      11, 0, 0, 9, 0, 9, 0, 20, 0, 4156, 76, 0, 0, 0, 0, 10792, 0, 0, 82, 0, 23,
      46, 0, 0, 4072962, 91, 23052, 23053, 12, 13, 0, 17988, 82, 61, 11278,
      11279, 11289, 0, 29, 0, 0, 14393, 68, 61, 56, 0, 58, 1195027, 13105, 18,
      31, 28, 34, 82, 0, 83, 0, 15367, 0, 82, 0, 9, 0, 0, 3354940, 18952, 0,
      22070, 0, 22788, 35, 22037, 0);

   /* THE PRODUCTION SELECTION TABLE  PRDTB  HAS BEEN HAND-MODIFIED TO
      REPLACE ENTRIES CORRESPONDING TO PRODUCTIONS WITH NULL SEMANTICS
      BY ZERO.  THE REPLACED ENTRIES ARE INDICATED BY COMMENTS
   */
   DECLARE PRDTB(109) BIT(8) INITIAL(0, 35, 33, 34, 22, 23, 24, 32, 21,
      0, 0, 0, 0, 0, 0, 0, 0 /* 6, 7, 8, 9, 10, 11, 12, 13 */, 67, 37, 60, 64,
      103, 105, 0 /* 62 */, 68, 0 /* 61 */, 106, 38, 65, 39, 66, 69, 107,
      0 /* 73 */, 43, 85, 88, 89, 82, 0 /* 72 */, 86, 83, 87, 84, 0 /* 48 */,
      40, 18, 19, 0 /* 49 */, 57, 59, 44, 53, 108, 109, 36, 58, 41, 47, 63,
      104, 55, 54, 93, 94, 95, 96, 0 /* 92 */, 31, 42, 20, 98, 99, 100,
      0 /* 97 */, 46, 102, 0 /* 101 */, 16, 0 /* 3 */, 25, 15, 0 /* 2 */,
      71, 28, 70, 27, 29, 30, 45, 0 /* 17 */, 5, 0 /* 56 */, 1, 75, 0 /* 74 */,
      0 /* 14 */, 4, 79, 78, 52, 26, 77, 0 /* 76 */, 81, 0, 0, 0
      /* 80, 51, 50 */, 91, 0 /* 90 */);

   DECLARE HDTB(109) BIT(8) INITIAL (0, 70, 70, 70, 61, 61, 61, 70, 61, 76, 76,
      76, 76, 76, 76, 76, 76, 65, 72, 43, 91, 50, 51, 62, 66, 52, 75, 73, 79,
      73, 79, 66, 75, 58, 82, 54, 54, 54, 54, 49, 54, 54, 54, 54, 46, 47, 56,
      57, 46, 43, 43, 81, 87, 53, 53, 71, 43, 47, 77, 91, 51, 83, 83, 90, 90,
      90, 90, 90, 88, 47, 45, 44, 44, 44, 44, 69, 50, 50, 63, 68, 61, 63, 68,
      59, 84, 59, 84, 64, 67, 81, 63, 55, 83, 48, 60, 60, 76, 55, 85, 85, 87,
      78, 74, 74, 80, 80, 89, 89, 86, 86);
   DECLARE PRLENGTH(109) BIT(8) INITIAL (0, 4, 3, 3, 3, 3, 3, 2, 2, 2, 2, 2, 2,
      2, 2, 2, 1, 3, 3, 3, 3, 3, 3, 2, 2, 2, 2, 1, 1, 3, 3, 3, 3, 2, 2, 2, 2, 2,
      1, 1, 2, 1, 2, 1, 2, 1, 3, 2, 1, 1, 1, 1, 3, 1, 1, 2, 1, 2, 2, 1, 1, 4, 2,
      3, 3, 2, 2, 1, 3, 2, 2, 3, 3, 3, 1, 2, 1, 1, 3, 2, 2, 2, 1, 2, 4, 3, 2, 2,
      2, 2, 2, 1, 2, 1, 3, 1, 2, 1, 2, 1, 1, 4, 3, 1, 3, 1, 3, 2, 3, 1);
   DECLARE CONTEXT_CASE(109) BIT(8) INITIAL (0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
      0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0,
      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
   DECLARE LEFT_CONTEXT(1) BIT(8) INITIAL ( 86, 71);
   DECLARE LEFT_INDEX(49) BIT(8) INITIAL ( 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
      1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2,
      2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2);
   DECLARE CONTEXT_TRIPLE(0) FIXED INITIAL ( 0);
   DECLARE TRIPLE_INDEX(49) BIT(8) INITIAL ( 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1);
   DECLARE PR_INDEX(91) BIT(8) INITIAL ( 1, 17, 23, 29, 34, 35, 40, 40, 40, 40,
      42, 44, 44, 44, 44, 44, 44, 44, 45, 45, 45, 45, 45, 46, 46, 46, 47, 48,
      48, 48, 49, 49, 50, 51, 52, 52, 52, 54, 55, 56, 56, 57, 61, 63, 68, 68,
      68, 71, 71, 71, 75, 77, 77, 78, 78, 83, 83, 83, 83, 84, 90, 90, 90, 92,
      92, 93, 93, 93, 94, 94, 94, 94, 94, 94, 96, 96, 98, 98, 98, 98, 100, 100,
      100, 101, 102, 104, 106, 108, 108, 108, 110, 110);

   /*  END OF CARDS PUNCHED BY ANALYZER  */

   /*  DECLARATIONS FOR THE SCANNER                                        */

   /* TOKEN IS THE INDEX INTO THE VOCABULARY V() OF THE LAST SYMBOL SCANNED,
      CH IS THE LAST CHARACTER SCANNED (HEX CODE),
      CP IS THE POINTER TO THE LAST CHARACTER SCANNED IN THE CARDIMAGE,
      BCD IS THE LAST SYMBOL SCANNED (LITERAL CHARACTER STRING). */
   declare (token, ch, cp) fixed, bcd character;

   /* SET UP SOME CONVENIENT ABBREVIATIONS FOR PRINTER CONTROL */
   declare EJECT_PAGE literally 'output(1) = page',
      page character initial ('1'), double character initial ('0'),
      DOUBLE_SPACE literally 'output(1) = double',
      x70 character initial (
      '                                                                      ');

   /* LENGTH OF LONGEST SYMBOL IN V */
   declare (reserved_limit, margin_chop) fixed;

   /* CHARTYPE() IS USED TO DISTINGUISH CLASSES OF SYMBOLS IN THE SCANNER.
      TX() IS A TABLE USED FOR TRANSLATING FROM ONE CHARACTER SET TO ANOTHER.
      CONTROL() HOLDS THE VALUE OF THE COMPILER CONTROL TOGGLES SET IN $ CARDS.
      NOT_LETTER_OR_DIGIT() IS SIMILIAR TO CHARTYPE() BUT USED IN SCANNING
      IDENTIFIERS ONLY.

      ALL ARE USED BY THE SCANNER AND CONTROL() IS SET THERE.
   */
   declare (chartype, tx) (255) bit(8),
           (savecontrol, control, not_letter_or_digit)(255) bit(1);

   /* ALPHABET CONSISTS OF THE SYMBOLS CONSIDERED ALPHABETIC IN BUILDING
      IDENTIFIERS     */
   declare alphabet character initial(
                    'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_$@#');

   /* BUFFER HOLDS THE LATEST CARDIMAGE,
      TEXT HOLDS THE PRESENT STATE OF THE INPUT TEXT (INCLUDING MACRO
      EXPANSIONS AND NOT INCLUDING THE PORTIONS DELETED BY THE SCANNER),
      TEXT_LIMIT IS A CONVENIENT PLACE TO STORE THE POINTER TO THE END OF TEXT,
      CARD_COUNT IS INCREMENTED BY ONE FOR EVERY XPL SOURCE CARD READ,
      ERROR_COUNT TABULATES THE ERRORS AS THEY ARE DETECTED DURING COMPILE,
      SEVERE_ERRORS TABULATES THOSE ERRORS OF FATAL SIGNIFICANCE.
   */
   declare (buffer, text, current_procedure, information) character,
      (text_limit, text_used, card_count, error_count, severe_errors, previous_error) fixed;

   /* NUMBER_VALUE CONTAINS THE NUMERIC VALUE OF THE LAST CONSTANT SCANNED,
      JBASE CONTAINS THE FIELD WIDTH IN BIT STRINGS (DEFAULT VALUE = 4),
      BASE IS  2**JBASE   (I.E., SHL(1,JBASE) ).
   */
   declare (number_value, jbase, base) fixed;

   /* EACH OF THE FOLLOWING CONTAINS THE INDEX INTO V() OF THE CORRESPONDING
      SYMBOL.   WE ASK:    IF TOKEN = IDENT    ETC.    */
   declare (ident, string, number, divide, eofile, orsymbol, subscript_head,
      concatenate) fixed;

   /* USED TO SAVE BRANCH ADDRESSES IN DO-LOOP CODE */
   declare stepk fixed;

   /* THE FOLLOWING ARE USED IN THE MACRO EXPANDER.  CONSIDERABLE LOGIC
      IS DEVOTED TO AVOIDING CREATING STRINGS OF LENGTH > 256, THE STRING LIMIT.
   */
   declare balance character, lb fixed;
   declare MACRO_LIMIT literally '255',
      (macro_name, macro_text) (MACRO_LIMIT) character,
      macro_index("100") bit(8),
      top_macro fixed initial ("FFFFFFFF");
   declare expansion_count fixed, EXPANSION_LIMIT literally '300';

   /* STOPIT() IS A TABLE OF SYMBOLS WHICH ARE ALLOWED TO TERMINATE THE ERROR
      FLUSH PROCESS.  IN GENERAL THEY ARE SYMBOLS OF SUFFICIENT SYNTACTIC
      HIERARCHY THAT WE EXPECT TO AVOID ATTEMPTING TO START COMPILING AGAIN
      RIGHT INTO ANOTHER ERROR PRODUCING SITUATION.  THE TOKEN STACK IS ALSO
      FLUSHED DOWN TO SOMETHING ACCEPTABLE TO A STOPIT() SYMBOL.
      FAILSOFT IS A BIT WHICH ALLOWS THE COMPILER ONE ATTEMPT AT A GENTLE
      RECOVERY.   THEN IT TAKES A STRONG HAND.   WHEN THERE IS REAL TROUBLE
      COMPILING IS SET TO FALSE, THEREBY TERMINATING THE COMPILATION.
      MAINLOC IS THE SYMBOL TABLE LOCATION OF COMPACTIFY FOR USE IN ERROR().
   */
   declare stopit(NT) bit(1), (failsoft, compiling) bit(1), mainloc fixed;

   declare s character;  /* A TEMPORARY USED VARIOUS PLACES */

   /* THE ENTRIES IN PRMASK() ARE USED TO SELECT OUT PORTIONS OF CODED
      PRODUCTIONS AND THE STACK TOP FOR COMPARISON IN THE ANALYSIS ALGORITHM */
   declare prmask(5) fixed initial (0, 0, "FF", "FFFF", "FFFFFF", "FFFFFFFF");

   /* SUBSTR(HEXCODES, I, 1) IS THE HEXADECIMAL CODE LETTER FOR I  */
   declare hexcodes character initial ('0123456789abcdef');

   declare (count#stack, count#scan, count#force, count#emit,
      count#arith, count#store, count#fixbfw, count#fixd,
      count#getd, count#getc, count#find, count#gets, count#getds ) fixed;

   /* RECORD THE TIMES OF IMPORTANT POINTS DURING COMPILATION */
   declare clock(5) fixed;

   /* COUNT THE NUMBER OF COMPARISONS OF IDENTIFIERS IN SYMBOL TABLE LOOK-UPS
      THIS CAN, IN GENERAL, BE EXPECTED TO BE A SUBSTANTIAL PART OF RUN TIME.
   */
   declare idcompares fixed, statement_count fixed;
   declare basedata fixed;   /*  BASE REGISTER INITIALIZATION ADDRESS */

   /*  THE EMITTER  ARRAYS  */


 /******************************************************************************

      WARNING:  THE EMITTER ARRAYS "CODE", "DATA", "DESC", AND "STRINGS" ARE
   DEPENDENT ON THE HARDWARE DEVICES AVAILABLE FOR SCRATCH STORAGE.  THE
   LITERAL CONSTANT "DISKBYTES" SHOULD BE EQUAL TO THE BLOCKSIZE OF THESE FILES
   AS ESTABLISHED BY THE SUBMONITOR.

      THIS VERSION OF XCOM NEEDS THREE SCRATCH FILES:
      1        COMPILED CODE TEMPORARY
      2        COMPILED DATA TEMPORARY
      3        DESCRIPTOR AND CHARACTER STRING TEMPORARY
      1        BINARY PROGRAM OUTPUT

 ******************************************************************************/

   declare DISKBYTES literally '512'; /* SIZE OF SCRATCH FILE BLOCKS IN BYTES */
   declare codemax fixed;        /* FORCES CODE TO WORD BOUNDARY */
   declare code (DISKBYTES) bit(8);
   declare datamax fixed;     /* FORCES DATA TO WORD BOUNDARY */
   declare data (DISKBYTES) bit(8);

   declare MAXDESC literally '8192';
   declare descmax fixed;
   declare desc(DISKBYTES) bit(8);  /* STRING DESCRIPTORS, REG SBR RELATIVE */

   declare strngblk fixed;          /* FIRST BLOCK NUMBER ON FILE(STRINGFILE) */
   declare strngmx fixed;            /*  AND FORCE STRINGS TO BE ALIGNED  */
   declare strings (DISKBYTES) bit(8); /* BUFFER FOR COMPILED STRINGS  */


   /*  CODEMAX  IS THE # OF RECORDS OF CODE GENERATED
       DATAMAX IS THE NUMBER OF RECORDS OF DATA GENERATED
       DESCMAX IS THE NUMBER OF RECORDS OF STRING DESCRIPTORS GENERATED
   */

   declare CODEFILE literally '1';    /* FILE FOR BINARY CODE, AND */
   declare BINARYFILE literally '1';  /* COLLECTION OF ALL COMPILED OUTPUT */
   declare DATAFILE literally '2';    /* SCRATCH FILE FOR DATA */
   declare STRINGFILE literally '3';  /* SCRATCH FILE FOR CHARACTER STRINGS */

   declare (pporg, pplim, dporg, dplim, curcblk, curdblk, curdsblk, cursblk, chporg,
      chplim, dsporg, dsplim, stringmax, shortdfix, shortcfix, longdfix, longcfix, fcp) fixed;

      /* ARRAYS TO HOLD FIXUPS DURING COMPILATION */

   /* FCLIM IS THE NUMBER OF FIXUPS THAT CAN BE RECORDED BEFORE THEY ARE MADE */
   declare FCLIM literally '100';
   declare fixcadr (FCLIM) fixed;      /* ADDRESS OF CODE FIXUP  */
   declare fixcl (FCLIM) bit(8);       /* Length of code fixup: 0, 1 or 4 */
   declare fixcv (FCLIM) bit(32);      /* Value of code fixup */

   declare limitword fixed;
   declare string_recover fixed;

   declare numcachc fixed;  /* Number of cached constants */
   declare xplsm fixed;   /*  ENTRY TO SUBMONITOR */
   declare xpl_to_c fixed;   /*  ENTRY TO XPL TO C INTERFACE */
   declare catentry fixed;   /*  ENTRY TO CATENATE ROUTINE */
   declare strl fixed;  /* ADDRESS OF LAST STRING COMPUTED FOR OPTIMIZING || */
   declare strn fixed;  /* ADDRESS OF TEMP IN STRING TO NUMBER ROUTINE */
   declare (cmps1,cmps2) fixed; /* ADDRESS OF TEMPS IN STRING COMPARE ROUTINE */
   declare cmpsntry fixed;   /* ENTRY TO STRING COMPARE */
   declare descl fixed;
   declare io_save fixed;
   declare nmbrntry  fixed;     /*  ENTRY TO BINARY TO CHAR. CONVERSION */
   declare tsa fixed;  /* INTEGER ADDRESS OF TOP-OF-STRINGS  */
   declare bases (8) fixed;    /*  THE VALUE OF THE BASE REGISTERS */
   declare AVAIL literally '2';

   /*  iAPX486 REGISTER ASSIGNMENTS:
            %eax        0  Scratch
            %ecx        1  Accumulator
            %edx        2  Accumulator
            %ebx        3  Accumulator, Function return
            %esp        4
            %ebp        5  Program base
            %esi        6  String descriptor area base
            %edi        7  Data area base
   */

   declare PBR literally 'EBP';  // PROGRAM REGISTER POINTS TO BASE OF CODE
   declare SBR literally 'ESI';  // STRING BASE REGISTER TO ADDRESS DESCRIPTORS
   declare DBR literally 'EDI';  // DATA BASE REGISTER
   declare target_register fixed;
   declare adreg fixed, adrdisp fixed;    /* GLOBALS FOR FINDADDRESS */
   declare rtnadr fixed;  /*  WHERE THE PRESENT RETURN ADDRESS IS STORED */
   declare returned_type bit (8);
   declare temp(3) fixed ;         /*  STORAGE FOR SAVE_REGISTERS  */
   declare (dp, pp, chp, dsp, newdp, newdsp) fixed; /* EMITTER POINTERS */
   declare itype fixed;   /*  INITIALIZATION TYPE  */
   declare stillcond fixed;  /*  REMEMBER CONDITION CODE TEST FOR PEEPHOLE */

   //
   // The TEMPLATE() BIT(56) array is encoded as:
   //
   //     XXXXXXXX XXXXXXXX XXXXXXXX ........ ........ ........ ........  code word
   //     XXXXXXX. ........ ........                                        instruction
   //     .......X XXXXXXXX XXXXXXXX                                        op1,op2,op3
   //     ........ ........ ........ XXXXXXXX XXXXXXXX ........ ........  opcode or relops-index
   //     ........ ........ ........ ........ ........ XXXXXXXX ........  flags
   //     ........ ........ ........ ........ ........ ........ XXXXXXXX  opcode index
   //
   // Code word is:
   //
   //     +---------------+-----------------+---------------+-----+
   //     |    opcode     |       op1       |       op2     | op3 |
   //     | _ _ _ _ _ _ _ | _ _ _ _ _ x x x | _ _ _ _ x x x | _ _ |
   //     |       7       |     5       3   |    4      3   |  2  | == 24
   //     +---------------+-----------------+---------------+-----+
   //

   // Operand types: carefully chosen such that 5 bits are sufficient
   // to distinguish the types for op1, 4 bits for op2, and 2 bits for op3.
   //
   //   0-4   specific registers %AL, %EAX, %CL, %EBX and %AH
   //   5-7   possible for ops 1, 2 and 3; chosen such that
   //         N & 03 is {1,2,3}
   //   8-14  possible for ops 1 and 2
   //  15-17  uniquely op1
   //  15     uniquely op2
   //
   //                                     Op1 Op2 Op3
   //      AL                 0        //  x            -- arith %AL,IMM8
   //      EAX                0        //  x   x        -- arith %EAX,IMM32
   //      CL                 1        //      x        -- s[ah][lr] xx,%CL
   //      EBX                3        //      x        -- xlat %AL,%EBX
   //      AH                 4        //  x            -- lahf %AH
   declare ONE     literally '15';     //      x        -- s[ah][lr] xx,1
   declare NONE    literally '5';      //  x   x   x
   declare REL8    literally '15';     //  x
   declare REL32   literally '16';     //  x
   declare REL     literally '17';     //  x            -- either REL8 or REL32
                                       //               --     relops[op] is REL8 opcode
                                       //               --     relops[op+1] is REL32 opcode
   declare R8      literally '8';      //  x   x        -- R/M8, register
   declare R16     literally '9';      //  x   x        -- R/M16, register
   declare R32     literally '10';     //  x   x        -- R/M32, register
   declare IMM8    literally '6';      //  x   x   x
   declare IMM16   literally '11';     //  x   x
   declare IMM32   literally '7';      //  x   x   x
   declare M8      literally '12';     //  x   x        -- R/M8, memory
   declare M16     literally '13';     //  x   x        -- R/M16, memory
   declare M32     literally '14';     //  x   x        -- R/M32, memory

   // M32/M16/M8 index register modifiers for op1/op2
   declare Xx1     literally '"(1) 1 00 00000"';
   declare Xx2     literally '"(1) 1 01 00000"';
   declare Xx4     literally '"(1) 1 10 00000"';
   declare Xx8     literally '"(1) 1 11 00000"';

   declare FromINLINE literally '"40 000000"';  // Tell emit() that REL8/REL32 offset is absolute


   // Flags
   declare F_OPR   literally '"(1) 10000000"';    // mod r/m reg is opcode extension, flag & 07
   declare F_OPD   literally '"(1) 01000000"';    // op |= reg1 or reg2
   declare F_CC    literally '"(1) 00100000"';    // first arg is condition, op |= condition
   declare F_MR    literally '"(1) 00010000"';    // r/m dest,src is reversed wrt. op1,op2
   declare F_BITO  literally '"(1) 00001000"';    // adjust op1 M32 offset by IMM8/32

   //
   // Encode an instruction: note that arguments op1 and op2 are specified as:
   //
   //   xxx .....   index register (3 bits)
   //   ... xxxxx   operand code (5 bits)
   //
   // This will be reversed to match the template encoding:
   //
   //   op1          op2
   //   xxxxx...     xxxx...   operand code (5 and 4 bits)
   //   .....xxx     ....xxx   index register (3 bits)
   //
   inst:
     procedure( op, a1, a2, a3 ) fixed;
        declare (op, a1, a2, a3) fixed;
        declare (op1, op2) fixed;
        op1 = shl( a1 & "1F", 3 ) | shr( a1 & "(1) 1 11 00000", 5 );
        op2 = shl( a2 & "0F", 3 ) | shr( a2 & "(1) 1 11 00000", 5 );
        return shl(op,17) | shl(op1,9) | shl(op2,2) | (a3 & "03");
     end inst;

   /* Start of cards punched by TEMPLATE.XPL */

   declare NTEMPLATE literally '412';
   declare template(NTEMPLATE) bit(56) initial(
            "0050A1 0037 00 00", "0250A1 D50A 00 01", "0450A1 D40A 00 02",
            "0650A1 003F 00 03", "0800C1 0014 00 05", "0800E1 0015 00 04",
            "0880C1 0080 82 05", "088101 0010 00 05", "088181 0012 10 05",
            "0891A1 6613 10 06", "08A0C1 0083 82 04", "08A0E1 0081 82 04",
            "08A141 0011 00 04", "08A1C1 0013 10 04", "08C0C1 0080 82 05",
            "08C101 0010 00 05", "08D0C1 6683 82 06", "08D121 6611 00 06",
            "08D161 6681 82 06", "08E0C1 0083 82 04", "08E0E1 0081 82 04",
            "08E141 0011 00 04", "0A00C1 0004 00 08", "0A00E1 0005 00 07",
            "0A80C1 0080 80 08", "0A8101 0000 00 08", "0A8181 0002 10 08",
            "0A91A1 6603 10 09", "0AA0C1 0083 80 07", "0AA0E1 0081 80 07",
            "0AA141 0001 00 07", "0AA1C1 0003 10 07", "0AC0C1 0080 80 08",
            "0AC101 0000 00 08", "0AD0C1 6683 80 09", "0AD121 6601 00 09",
            "0AD161 6681 80 09", "0AE0C1 0083 80 07", "0AE0E1 0081 80 07",
            "0AE141 0001 00 07", "0C00C1 0024 00 0B", "0C00E1 0025 00 0A",
            "0C80C1 0080 84 0B", "0C8101 0020 00 0B", "0C8181 0022 10 0B",
            "0C91A1 6623 10 0C", "0CA0C1 0083 84 0A", "0CA0E1 0081 84 0A",
            "0CA141 0021 00 0A", "0CA1C1 0023 10 0A", "0CC0C1 0080 84 0B",
            "0CC101 0020 00 0B", "0CD0C1 6683 84 0C", "0CD121 6621 00 0C",
            "0CD161 6681 84 0C", "0CE0C1 0083 84 0A", "0CE0E1 0081 84 0A",
            "0CE141 0021 00 0A", "0EA141 0FBC 10 0D", "0EA1C1 0FBC 10 0D",
            "10A141 0FBD 10 0E", "10A1C1 0FBD 10 0E", "12A0A1 0FC8 40 0F",
            "14A0C1 0FBA 84 10", "14A141 0FA3 00 10", "14E0C1 0FBA 8C 10",
            "14E141 0FA3 00 10", "16A0C1 0FBA 87 11", "16A141 0FBB 00 11",
            "16E0C1 0FBA 8F 11", "16E141 0FBB 00 11", "18A0C1 0FBA 86 12",
            "18A141 0FB3 00 12", "18E0C1 0FBA 8E 12", "18E141 0FB3 00 12",
            "1AA0C1 0FBA 85 13", "1AA141 0FAB 00 13", "1AE0C1 0FBA 8D 13",
            "1AE141 0FAB 00 13", "1CA0A1 00FF 82 14", "1CE0A1 00FF 82 14",
            "1D00A1 00E8 00 14", "1E50A1 6698 00 15", "2050A1 0099 00 16",
            "2250A1 00F8 00 17", "2450A1 00FC 00 18", "2650A1 00F5 00 19",
            "2800C1 003C 00 1B", "2800E1 003D 00 1A", "2880C1 0080 87 1B",
            "288101 0038 00 1B", "288181 003A 10 1B", "2891A1 663B 10 1E",
            "28A0C1 0083 87 1A", "28A0E1 0081 87 1A", "28A141 0039 00 1A",
            "28A1C1 003B 10 1A", "28C0C1 0080 87 1B", "28C101 0038 00 1B",
            "28D0C1 6683 87 1E", "28D121 6639 00 1E", "28D161 6681 87 1E",
            "28E0C1 0083 87 1A", "28E0E1 0081 87 1A", "28E141 0039 00 1A",
            "2A50A1 00A6 00 1C", "2C50A1 00A7 00 1D", "2E50A1 0098 00 1F",
            "3050A1 0027 00 20", "3250A1 002F 00 21", "3480A1 00FE 81 23",
            "34A0A1 0048 40 22", "34C0A1 00FE 81 23", "34D0A1 66FF 81 24",
            "34E0A1 00FF 81 22", "360141 00F7 96 25", "3601C1 00F7 96 25",
            "380141 00F7 97 26", "3801C1 00F7 97 26", "3A0141 00F7 95 27",
            "3A01C1 00F7 95 27", "3AA0A1 00F7 85 27", "3AA0C1 006B 10 27",
            "3AA0E1 0069 10 27", "3AA141 0FAF 10 27", "3AA142 006B 10 27",
            "3AA143 0069 10 27", "3AA1C1 0FAF 10 27", "3AA1C2 006B 10 27",
            "3AA1C3 0069 10 27", "3AE0A1 00F7 85 27", "3C80A1 00FE 80 29",
            "3CA0A1 0040 40 28", "3CC0A1 00FE 80 29", "3CD0A1 66FF 80 2A",
            "3CE0A1 00FF 80 28", "3EF0A1 0070 20 2B", "3F00A1 0F80 20 2B",
            "3F10A1 0000 20 2B", "40F0A1 00E3 00 2C", "42A0A1 00FF 84 2D",
            "42E0A1 00FF 84 2D", "42F0A1 00EB 00 2D", "4300A1 00E9 00 2D",
            "4310A1 0002 00 2D", "4440A1 009F 00 2E", "4450A1 009F 00 2E",
            "46A1C1 008D 10 2F", "4850A1 00AC 00 30", "4A50A1 00AD 00 31",
            "4CF0A1 00E2 00 32", "4EF0A1 00E0 00 33", "50F0A1 00E1 00 34",
            "5280C1 00B0 40 36", "528101 0088 00 36", "528181 008A 10 36",
            "5291A1 668B 10 3B", "52A0E1 00B8 40 35", "52A141 0089 00 35",
            "52A1C1 008B 10 35", "52C0C1 00C6 80 36", "52C101 0088 00 36",
            "52D121 6689 00 3B", "52D161 66C7 80 3B", "52E0E1 00C7 80 35",
            "52E141 0089 00 35", "5450A1 00A4 00 37", "5650A1 00A5 00 38",
            "58A101 0FBE 10 39", "58A121 0FBF 10 3A", "58A181 0FBE 10 39",
            "58A1A1 0FBF 10 3A", "5AA101 0FB6 10 3C", "5AA121 0FB7 10 3D",
            "5AA181 0FB6 10 3C", "5AA1A1 0FB7 10 3D", "5C0141 00F7 94 3E",
            "5C01C1 00F7 94 3E", "5E80A1 00F6 83 40", "5EA0A1 00F7 83 3F",
            "5EC0A1 00F6 83 40", "5ED0A1 66F7 83 41", "5EE0A1 00F7 83 3F",
            "6050A1 0090 00 42", "6280A1 00F6 82 44", "62A0A1 00F7 82 43",
            "62C0A1 00F6 82 44", "62D0A1 66F7 82 45", "62E0A1 00F7 82 43",
            "6400C1 000C 00 47", "6400E1 000D 00 46", "6480C1 0080 81 47",
            "648101 0008 00 47", "648181 000A 10 47", "6491A1 660B 10 48",
            "64A0C1 0083 81 46", "64A0E1 0081 81 46", "64A141 0009 00 46",
            "64A1C1 000B 10 46", "64C0C1 0080 81 47", "64C101 0008 00 47",
            "64D0C1 6683 81 48", "64D121 6609 00 48", "64D161 6681 81 48",
            "64E0C1 0083 81 46", "64E0E1 0081 81 46", "64E141 0009 00 46",
            "66A0A1 0058 40 49", "66E0A1 008F 80 49", "6850A1 0061 00 4A",
            "6A50A1 009D 00 4B", "6C60A1 006A 00 4C", "6C70A1 0068 00 4C",
            "6CA0A1 0050 40 4C", "6CE0A1 00FF 86 4C", "6E50A1 0060 00 4D",
            "7050A1 009C 00 4E", "728021 00D2 82 50", "7280C1 00C0 82 50",
            "7281E1 00D0 82 50", "72A021 00D3 82 4F", "72A0C1 00C1 82 4F",
            "72A1E1 00D1 82 4F", "72C021 00D2 82 50", "72C0C1 00C0 82 50",
            "72C1E1 00D0 82 50", "72D021 66D3 82 51", "72D0C1 66C1 82 51",
            "72D1E1 66D1 82 51", "72E021 00D3 82 4F", "72E0C1 00C1 82 4F",
            "72E1E1 00D1 82 4F", "748021 00D2 83 53", "7480C1 00C0 83 53",
            "7481E1 00D0 83 53", "74A021 00D3 83 52", "74A0C1 00C1 83 52",
            "74A1E1 00D1 83 52", "74C021 00D2 83 53", "74C0C1 00C0 83 53",
            "74C1E1 00D0 83 53", "74D021 66D3 83 54", "74D0C1 66C1 83 54",
            "74D1E1 66D1 83 54", "74E021 00D3 83 52", "74E0C1 00C1 83 52",
            "74E1E1 00D1 83 52", "7650A1 00F3 00 55", "7850A1 00F2 00 56",
            "7A50A1 00C3 00 57", "7AB0A1 00C2 00 57", "7C8021 00D2 80 59",
            "7C80C1 00C0 80 59", "7C81E1 00D0 80 59", "7CA021 00D3 80 58",
            "7CA0C1 00C1 80 58", "7CA1E1 00D1 80 58", "7CC021 00D2 80 59",
            "7CC0C1 00C0 80 59", "7CC1E1 00D0 80 59", "7CD021 66D3 80 5A",
            "7CD0C1 66C1 80 5A", "7CD1E1 66D1 80 5A", "7CE021 00D3 80 58",
            "7CE0C1 00C1 80 58", "7CE1E1 00D1 80 58", "7E8021 00D2 81 5C",
            "7E80C1 00C0 81 5C", "7E81E1 00D0 81 5C", "7EA021 00D3 81 5B",
            "7EA0C1 00C1 81 5B", "7EA1E1 00D1 81 5B", "7EC021 00D2 81 5C",
            "7EC0C1 00C0 81 5C", "7EC1E1 00D0 81 5C", "7ED021 66D3 81 5D",
            "7ED0C1 66C1 81 5D", "7ED1E1 66D1 81 5D", "7EE021 00D3 81 5B",
            "7EE0C1 00C1 81 5B", "7EE1E1 00D1 81 5B", "8050A1 009E 00 5E",
            "828021 00D2 87 60", "8280C1 00C0 87 60", "8281E1 00D0 87 60",
            "82A021 00D3 87 5F", "82A0C1 00C1 87 5F", "82A1E1 00D1 87 5F",
            "82C021 00D2 87 60", "82C0C1 00C0 87 60", "82C1E1 00D0 87 60",
            "82D021 66D3 87 61", "82D0C1 66C1 87 61", "82D1E1 66D1 87 61",
            "82E021 00D3 87 5F", "82E0C1 00C1 87 5F", "82E1E1 00D1 87 5F",
            "8400C1 001C 00 63", "8400E1 001D 00 62", "8480C1 0080 83 63",
            "848101 0018 00 63", "848181 001A 10 63", "8491A1 661B 10 64",
            "84A0C1 0083 83 62", "84A0E1 0081 83 62", "84A141 0019 00 62",
            "84A1C1 001B 10 62", "84C0C1 0080 83 63", "84C101 0018 00 63",
            "84D0C1 6683 83 64", "84D121 6619 00 64", "84D161 6681 83 64",
            "84E0C1 0083 83 62", "84E0E1 0081 83 62", "84E141 0019 00 62",
            "8650A1 00AE 00 65", "8850A1 00AF 00 66", "8A80A1 0F90 20 67",
            "8AC0A1 0F90 20 67", "8C8021 00D2 84 69", "8C80C1 00C0 84 69",
            "8C81E1 00D0 84 69", "8CA021 00D3 84 68", "8CA0C1 00C1 84 68",
            "8CA1E1 00D1 84 68", "8CC021 00D2 84 69", "8CC0C1 00C0 84 69",
            "8CC1E1 00D0 84 69", "8CD021 66D3 84 6A", "8CD0C1 66C1 84 6A",
            "8CD1E1 66D1 84 6A", "8CE021 00D3 84 68", "8CE0C1 00C1 84 68",
            "8CE1E1 00D1 84 68", "8E8021 00D2 85 6C", "8E80C1 00C0 85 6C",
            "8E81E1 00D0 85 6C", "8EA021 00D3 85 6B", "8EA0C1 00C1 85 6B",
            "8EA1E1 00D1 85 6B", "8EC021 00D2 85 6C", "8EC0C1 00C0 85 6C",
            "8EC1E1 00D0 85 6C", "8ED021 66D3 85 6D", "8ED0C1 66C1 85 6D",
            "8ED1E1 66D1 85 6D", "8EE021 00D3 85 6B", "8EE0C1 00C1 85 6B",
            "8EE1E1 00D1 85 6B", "9050A1 00F9 00 6E", "9250A1 00FD 00 6F",
            "9450A1 00AA 00 70", "9650A1 00AB 00 71", "9800C1 002C 00 73",
            "9800E1 002D 00 72", "9880C1 0080 85 73", "988101 0028 00 73",
            "988181 002A 10 73", "9891A1 662B 10 74", "98A0C1 0083 85 72",
            "98A0E1 0081 85 72", "98A141 0029 00 72", "98A1C1 002B 10 72",
            "98C0C1 0080 85 73", "98C101 0028 00 73", "98D0C1 6683 85 74",
            "98D121 6629 00 74", "98D161 6681 85 74", "98E0C1 0083 85 72",
            "98E0E1 0081 85 72", "98E141 0029 00 72", "9A00C1 00A8 00 76",
            "9A00E1 00A9 00 75", "9A80C1 00F6 80 76", "9A8101 0084 00 76",
            "9AA0E1 00F7 80 75", "9AA141 0085 00 75", "9AC0C1 00F6 80 76",
            "9AC101 0084 00 76", "9AD121 6685 00 77", "9AD161 66F7 80 77",
            "9AE0E1 00F7 80 75", "9AE141 0085 00 75", "9C0141 0090 40 78",
            "9C8101 0086 00 79", "9C8181 0086 10 79", "9C91A1 6687 10 7A",
            "9CA001 0090 40 78", "9CA141 0087 00 78", "9CA1C1 0087 10 78",
            "9CC101 0086 00 79", "9CD121 6687 00 7A", "9CE141 0087 00 78",
            "9E0061 00D7 00 7B", "9E50A1 00D7 00 7B", "A000C1 0034 00 7D",
            "A000E1 0035 00 7C", "A080C1 0080 86 7D", "A08101 0030 00 7D",
            "A08181 0032 10 7D", "A091A1 6633 10 7E", "A0A0C1 0083 86 7C",
            "A0A0E1 0081 86 7C", "A0A141 0031 00 7C", "A0A1C1 0033 10 7C",
            "A0C0C1 0080 86 7D", "A0C101 0030 00 7D", "A0D0C1 6683 86 7E",
            "A0D121 6631 00 7E", "A0D161 6681 86 7E", "A0E0C1 0083 86 7C",
            "A0E0E1 0081 86 7C", "A0E141 0031 00 7C" );

   declare relopcodes(3) bit(16) initial(
        "0070", "0F80", "00EB", "00E9" );

   declare NOPCODE literally '126';
   declare i486Opcodes(NOPCODE) character initial( 'aaa', 'aad', 'aam', 'aas',
        'adc', 'adcb', 'adcw', 'add', 'addb', 'addw', 'and', 'andb', 'andw',
        'bsf', 'bsr', 'bswap', 'bt', 'btc', 'btr', 'bts', 'call', 'cbw',
        'cdq', 'clc', 'cld', 'cmc', 'cmp', 'cmpb', 'cmpsb', 'cmpsd', 'cmpw',
        'cwde', 'daa', 'das', 'dec', 'decb', 'decw', 'div', 'idiv', 'imul',
        'inc', 'incb', 'incw', 'j', 'jcxz', 'jmp', 'lahf', 'lea', 'lodsb',
        'lodsd', 'loop', 'loopnz', 'loopz', 'mov', 'movb', 'movsb', 'movsd',
        'movsxb', 'movsxw', 'movw', 'movzxb', 'movzxw', 'mul', 'neg', 'negb',
        'negw', 'nop', 'not', 'notb', 'notw', 'or', 'orb', 'orw', 'pop',
        'popa', 'popf', 'push', 'pusha', 'pushf', 'rcl', 'rclb', 'rclw',
        'rcr', 'rcrb', 'rcrw', 'rep', 'repnz', 'ret', 'rol', 'rolb', 'rolw',
        'ror', 'rorb', 'rorw', 'sahf', 'sar', 'sarb', 'sarw', 'sbb', 'sbbb',
        'sbbw', 'scasb', 'scasd', 'set', 'shl', 'shlb', 'shlw', 'shr', 'shrb',
        'shrw', 'stc', 'std', 'stosb', 'stosd', 'sub', 'subb', 'subw', 'test',
        'testb', 'testw', 'xchg', 'xchgb', 'xchgw', 'xlat', 'xor', 'xorb',
        'xorw' );

   declare NINST literally '80';
   declare AAA    literally '0';
   declare AAD    literally '1';
   declare AAM    literally '2';
   declare AAS    literally '3';
   declare ADC    literally '4';
   declare ADD    literally '5';
   declare AND    literally '6';
   declare BSF    literally '7';
   declare BSR    literally '8';
   declare BSWAP  literally '9';
   declare BT     literally '10';
   declare BTC    literally '11';
   declare BTR    literally '12';
   declare BTS    literally '13';
   declare JSR    literally '14';       // call
   declare CBW    literally '15';
   declare CDQ    literally '16';
   declare CLC    literally '17';
   declare CLD    literally '18';
   declare CMC    literally '19';
   declare CMP    literally '20';
   declare CMPSB  literally '21';
   declare CMPSD  literally '22';
   declare CWDE   literally '23';
   declare DAA    literally '24';
   declare DAS    literally '25';
   declare DEC    literally '26';
   declare DIV    literally '27';
   declare IDIV   literally '28';
   declare IMUL   literally '29';
   declare INC    literally '30';
   declare JCC    literally '31';
   declare JCXZ   literally '32';
   declare JMP    literally '33';
   declare LAHF   literally '34';
   declare LEA    literally '35';
   declare LODSB  literally '36';
   declare LODSD  literally '37';
   declare LOOP   literally '38';
   declare LOOPNZ literally '39';
   declare LOOPZ  literally '40';
   declare MOV    literally '41';
   declare MOVSB  literally '42';
   declare MOVSD  literally '43';
   declare MOVSX  literally '44';
   declare MOVZX  literally '45';
   declare MUL    literally '46';
   declare NEG    literally '47';
   declare NOP    literally '48';
   declare NOT    literally '49';
   declare OR     literally '50';
   declare POP    literally '51';
   declare POPA   literally '52';
   declare POPF   literally '53';
   declare PUSH   literally '54';
   declare PUSHA  literally '55';
   declare PUSHF  literally '56';
   declare RCL    literally '57';
   declare RCR    literally '58';
   declare REP    literally '59';
   declare REPNZ  literally '60';
   declare RET    literally '61';
   declare ROL    literally '62';
   declare ROR    literally '63';
   declare SAHF   literally '64';
   declare SAR    literally '65';
   declare SBB    literally '66';
   declare SCASB  literally '67';
   declare SCASD  literally '68';
   declare SETCC  literally '69';
   declare SLL    literally '70';       // shl
   declare SRL    literally '71';       // shr
   declare STC    literally '72';
   declare STD    literally '73';
   declare STOSB  literally '74';
   declare STOSD  literally '75';
   declare SUB    literally '76';
   declare TEST   literally '77';
   declare XCHG   literally '78';
   declare XLAT   literally '79';
   declare XOR    literally '80';

   /* End of cards punched by TEMPLATE.XPL */

   declare CCnames(15) character initial(
                  'o','no','b','nb','z','nz','be','nbe',
                  's','ns','p','np','l','nl','le','nle' );

   declare CC_C  literally '2',  /* Condition codes for conditional jumps */
           CC_NC literally '3',
           CC_E  literally '4',
           CC_NE literally '5',
           CC_L  literally '12',
           CC_GE literally '13',
           CC_LE literally '14',
           CC_G  literally '15';

   declare RegName32(7) character
             initial( '%eax','%ecx','%edx','%ebx','%esp','%ebp','%esi','%edi' );
   declare RegName16(7) character
             initial( '%ax','%cx','%dx','%bx','%sp','%bp','%si','%di' );
   declare RegName8(7) character
             initial( '%al','%cl','%dl','%bl','%ah','%ch','%dh','%bh' );
   declare XregScale(3) character initial( '*1', '*2', '*4', '*8' );

   declare EAX     literally '0';
   declare ECX     literally '1';
   declare EDX     literally '2';
   declare EBX     literally '3';
   declare ESP     literally '4';
   declare EBP     literally '5';
   declare ESI     literally '6';
   declare EDI     literally '7';
   declare NOREG   literally '8';

   declare AL      literally '0';
   declare CL      literally '1';
   declare DL      literally '2';
   declare BL      literally '3';

   declare AH      literally '4';
   declare CH      literally '5';
   declare DH      literally '6';
   declare BH      literally '7';

   declare commutative(NINST) bit(1);  /* RECORD WHICH OPERATORS ARE COMMUTATIVE */
   declare instruct(NINST) fixed;      /* INSTRUCTION USE COUNTERS */

   /* COMMONLY USED iAPX486 OPERATION CODES */
   declare inst_adc_r32_imm8 fixed;
   declare inst_add_eax_imm32 fixed;
   declare inst_add_r32_imm32 fixed;
   declare inst_add_r32_imm8 fixed;
   declare inst_add_r32_m32 fixed;
   declare inst_add_r32_r32 fixed;
   declare inst_and_r32_imm8 fixed;
   declare inst_and_r32_imm32 fixed;
   declare inst_bt_Xx1m32_imm8 fixed;
   declare inst_bt_m32_imm8 fixed;
   declare inst_bt_r32_imm8 fixed;
   declare inst_bts_m32_imm8 fixed;
   declare inst_call_m32 fixed;
   declare inst_call_r32 fixed;
   declare inst_call_rel32 fixed;
   declare inst_cdq fixed;
   declare inst_cld fixed;
   declare inst_cmp_r32_imm32 fixed;
   declare inst_cmp_r32_imm8 fixed;
   declare inst_cmp_r32_m32 fixed;
   declare inst_cmp_r32_r32 fixed;
   declare inst_cmpsb fixed;
   declare inst_dec_r32 fixed;
   declare inst_idiv_eax_Xx4m32 fixed;
   declare inst_idiv_eax_m32 fixed;
   declare inst_idiv_eax_r32 fixed;
   declare inst_inc_r32 fixed;
   declare inst_jcc_rel fixed;
   declare inst_jcc_rel32 fixed;
   declare inst_jmp_m32 fixed;
   declare inst_jmp_r32 fixed;
   declare inst_jmp_rel fixed;
   declare inst_jmp_rel32 fixed;
   declare inst_lea_r32_Xx1m32 fixed;
   declare inst_lea_r32_Xx2m32 fixed;
   declare inst_lea_r32_Xx4m32 fixed;
   declare inst_lea_r32_Xx8m32 fixed;
   declare inst_lea_r32_m32 fixed;
   declare inst_mov_Xx1m32_r32 fixed;
   declare inst_mov_Xx1m8_r8 fixed;
   declare inst_mov_Xx2m16_r16 fixed;
   declare inst_mov_Xx4m32_r32 fixed;
   declare inst_mov_m16_imm16 fixed;
   declare inst_mov_m16_r16 fixed;
   declare inst_mov_m32_imm32 fixed;
   declare inst_mov_m32_r32 fixed;
   declare inst_mov_m8_imm8 fixed;
   declare inst_mov_m8_r8 fixed;
   declare inst_mov_r16_Xx2m16 fixed;
   declare inst_mov_r16_m16 fixed;
   declare inst_mov_r32_Xx1m32 fixed;
   declare inst_mov_r32_Xx4m32 fixed;
   declare inst_mov_r32_imm32 fixed;
   declare inst_mov_r32_m32 fixed;
   declare inst_mov_r32_r32 fixed;
   declare inst_mov_r8_Xx1m8 fixed;
   declare inst_mov_r8_m8 fixed;
   declare inst_movsb fixed;
   declare inst_movsx_r32_r16 fixed;
   declare inst_movzx_r32_r8 fixed;
   declare inst_neg_r32 fixed;
   declare inst_nop fixed;
   declare inst_not_r32 fixed;
   declare inst_or_r32_imm32 fixed;
   declare inst_or_r32_r32 fixed;
   declare inst_or_r8_imm8 fixed;
   declare inst_pop_m32 fixed;
   declare inst_pop_r32 fixed;
   declare inst_push_r32 fixed;
   declare inst_rep fixed;
   declare inst_ret fixed;
   declare inst_setcc_r8 fixed;
   declare inst_shl_r32_imm8 fixed;
   declare inst_shr_r32_imm8 fixed;
   declare inst_sub_r32_imm32 fixed;
   declare inst_sub_r32_r32 fixed;
   declare inst_xchg_r32_r32 fixed;
   declare inst_xor_r32_imm32 fixed;
   declare inst_xor_r32_r32 fixed;

   /* THE FOLLOWING ARE USED TO HOLD ADDRESS PAIRS IN THE EMITTER FOR || */
   declare (a2, b2, t1, t2) fixed;

   /* COMMONLY USED STRINGS */
   declare x1 character initial(' '), x4 character initial('    ');
   declare period character initial('.'),
      instq character initial(': Inst = '),
      codeq character initial(': Code = '),
      dataq character initial(': Data = '),
      vbar character initial('|'),
      x1vbar character initial(' |'),
      colon character initial(':'),
      comma character initial(','),
      equal character initial('=');

   declare stackmax fixed initial(0);

   /* TEMPORARIES USED THROUGHOUT THE COMPILER */
   declare char_temp character;
   declare (i, j, k, l) fixed;

   declare TRUE literally '1', FALSE literally '0', FOREVER literally 'while 1';

   /*  SYMBOL  TABLE  VARIABLES  */

   declare HALFWORD     literally  '1',
           LABELTYPE    literally  '2',
           ACCUMULATOR  literally  '3',
           VARIABLE     literally  '4',
           CONSTANT     literally  '5',
           CONDITION    literally  '6',
           CHRTYPE      literally  '7',
           FIXEDTYPE    literally  '8',
           BYTETYPE     literally  '9',
           FORWARDTYPE  literally '10',
           DESCRIPT     literally '11',
           SPECIAL      literally '12',
           FORWARDCALL  literally '13',
           CHAR_PROC_TYPE literally '14';
   declare typename(14) character initial ('', 'BIT(16)  ', 'LABEL    ', '', '',
            '', '', 'CHARACTER', 'FIXED    ', 'BIT(8)   ', '', '', '', '',
            'CHARACTER procedure');
   declare procmark fixed;  /* START OF LOCAL VARIABLES IN SYMBOL TABLE */
   declare parct fixed;  /* NUMBER OF PARAMETERS TO CURRENT PROCEDURE */
   declare ndecsy fixed;     /* CURRENT NUMBER OF DECLARED SYMBOLS */
   /* MAXNDECSY IS THE MAXIMUM OF NDECSY OVER A COMPILATION.  IF MAXNDECSY
      BEGINS TO APPROACH SYTSIZE THEN SYTSIZE SHOULD BE INCREASED */
   declare maxndecsy fixed;

declare SYTSIZE literally '1000';

   /*  THE SYMBOL TABLE IS INITIALIZED WITH THE NAMES OF ALL
       BUILTIN FUNCTIONS AND PSEUDO VARIABLES IN BOTH UPPER AND
       LOWER CASE.  THE PROCEDURE INITIALIZE DEPENDS ON THE ORDER
       AND PLACEMENT OF THESE NAMES.  DUE CAUTION SHOULD BE OBSERVED
       WHILE MAKING CHANGES .

           SYT_Name            SYT_Type    SYT_Base,Disp
           ----------          ----------  -------------------
        0  ''                  0           0,0
        1  ''                  0           0,0
      2,3  MONITOR_LINK        FIXEDTYPE   PBR,0
      4,5  TIME_OF_GENERATION  FIXEDTYPE   DBR,*  [DP]
      6,7  DATE_OF_GENERATION  FIXEDTYPE   DBR,*  [DP]
      8,9  COREWORD            FIXEDTYPE   0,0
    10,11  COREBYTE            BYTETYPE    0,0
    12,13  FREEPOINT           FIXEDTYPE   DBR,*  [DP]
    14,15  DESCRIPTOR          FIXEDTYPE   SBR,*  [4]
    16,17  NDESCRIPT           FIXEDTYPE   DBR,*  [DP]
    18,19  LENGTH              SPECIAL     0,1
    20,21  SUBSTR              SPECIAL     0,2
    22,23  BYTE                SPECIAL     0,3
    24,25  SHL                 SPECIAL     0,4
    26,27  SHR                 SPECIAL     0,5
    28,29  INPUT               SPECIAL     0,6
    30,31  OUTPUT              SPECIAL     0,7
    32,33  FILE                SPECIAL     0,8
    34,35  INLINE              SPECIAL     0,10
    36,37  TRACE               SPECIAL     0,11
    38,39  UNTRACE             SPECIAL     0,12
    40,41  EXIT                SPECIAL     0,13
    42,43  TIME                SPECIAL     0,14
    44,45  DATE                SPECIAL     0,15
    46,47  CLOCK_TRAP          SPECIAL     0,16
    48,49  INTERRUPT_TRAP      SPECIAL     0,17
    50,51  MONITOR             SPECIAL     0,18
    52,53  ADDR                SPECIAL     0,19
    54,55  COREHALFWORD        HALFWORD    0,0
       56  COMPACTIFY          FORWARDCALL *,*  [DBR,DP]

       *  Set by INITIALIZATION to [...]
   */

   /*  VARIABLE NAME */
   declare syt_name (SYTSIZE) character initial ('','',
         'MONITOR_LINK', 'monitor_link',
         'TIME_OF_GENERATION', 'time_of_generation',
         'DATE_OF_GENERATION', 'date_of_generation',
         'COREWORD', 'coreword',
         'COREBYTE', 'corebyte',
         'FREEPOINT', 'freepoint',
         'DESCRIPTOR', 'descriptor',
         'NDESCRIPT', 'ndescript',
         'LENGTH', 'length',
         'SUBSTR', 'substr',
         'BYTE', 'byte',
         'SHL', 'shl',
         'SHR', 'shr',
         'INPUT', 'input',
         'OUTPUT', 'output',
         'FILE', 'file',
         'INLINE', 'inline',
         'TRACE', 'trace',
         'UNTRACE', 'untrace',
         'EXIT', 'exit',
         'TIME', 'time',
         'DATE', 'date',
         'CLOCK_TRAP', 'clock_trap',
         'INTERRUPT_TRAP', 'interrupt_trap',
         'MONITOR', 'monitor',
         'ADDR', 'addr',
         'COREHALFWORD', 'corehalfword',
         'COMPACTIFY',
         '');
   /* TYPE OF THE VARIABLE */
   declare syt_type (SYTSIZE) bit(8) initial (0,0,
         FIXEDTYPE, FIXEDTYPE,
         FIXEDTYPE, FIXEDTYPE,
         FIXEDTYPE, FIXEDTYPE,
         FIXEDTYPE, FIXEDTYPE,
         BYTETYPE, BYTETYPE,
         FIXEDTYPE, FIXEDTYPE,
         FIXEDTYPE, FIXEDTYPE,
         FIXEDTYPE, FIXEDTYPE,
         SPECIAL, SPECIAL,
         SPECIAL, SPECIAL,
         SPECIAL, SPECIAL,
         SPECIAL, SPECIAL,
         SPECIAL, SPECIAL,
         SPECIAL, SPECIAL,
         SPECIAL, SPECIAL,
         SPECIAL, SPECIAL,
         SPECIAL, SPECIAL,
         SPECIAL, SPECIAL,
         SPECIAL, SPECIAL,
         SPECIAL, SPECIAL,
         SPECIAL, SPECIAL,
         SPECIAL, SPECIAL,
         SPECIAL, SPECIAL,
         SPECIAL, SPECIAL,
         SPECIAL, SPECIAL,
         SPECIAL, SPECIAL,
         HALFWORD, HALFWORD,
         FORWARDCALL,
         0);
   declare syt_base (SYTSIZE) bit (4) initial(0,0,
         PBR, PBR,
         DBR, DBR,
         DBR, DBR,
         0, 0,
         0, 0,
         DBR, DBR,
         SBR, SBR,
         DBR, DBR,
         0, 0,
         0, 0,
         0, 0,
         0, 0,
         0, 0,
         0, 0,
         0, 0,
         0, 0,
         0, 0,
         0, 0,
         0, 0,
         0, 0,
         0, 0,
         0, 0,
         0, 0,
         0, 0,
         0, 0,
         0, 0,
         0, 0,
         0,
         0);
   /* DISPLACEMENT FOR VARIABLE */
   declare syt_disp (SYTSIZE) bit (28) initial (0,0,
         0, 0,
         0, 0,
         0, 0,
         0, 0,
         0, 0,
         0, 0,
         0, 0,
         0, 0,
         1, 1,
         2, 2,
         3, 3,
         4, 4,
         5, 5,
         6, 6,
         7, 7,
         8, 8,
         10, 10,
         11, 11,
         12, 12,
         13, 13,
         14, 14,
         15, 15,
         16, 16,
         17, 17,
         18, 18,
         19, 19,
         0, 0,
         0,
         0);
   declare syt_count(SYTSIZE) bit (16);     /* COUNT OF REFERENCES TO SYMBOLS */

   declare declared_on_line(SYTSIZE) bit(16);
   declare idx fixed, ptr(SYTSIZE) fixed, hash("FF") fixed;

   /*  THE COMPILER STACKS DECLARED BELOW ARE USED TO DRIVE THE SYNTACTIC
      ANALYSIS ALGORITHM AND STORE INFORMATION RELEVANT TO THE INTERPRETATION
      OF THE TEXT.  THE STACKS ARE ALL POINTED TO BY THE STACK POINTER SP.  */

   declare STACKSIZE literally '75';
   declare parse_stack (STACKSIZE) bit(8); /* TOKENS OF THE PARTIALLY PARSED
                                                                         TEXT */
   declare ps_type (STACKSIZE) bit(8); /* OPERAND TYPE FOR EXPRESSIONS */
   declare ps_reg (STACKSIZE) bit(8);  /* ASSOCIATED GENERAL REGISTER */
   declare ps_xreg (STACKSIZE) bit(8); /* ASSOCIATED INDEX REGISTER */
   declare ps_cnt (STACKSIZE) bit(8);  /* ANY COUNT, PARAMETERS, SUBSCRIPTS...*/
   declare ps_name (STACKSIZE) character;/* NAME OF ITEM */
   declare ps_fxloc (STACKSIZE) fixed;   /* FIXUP LOCATION */
   declare ps_fxval (STACKSIZE) fixed;   /* FIXUP VALUE */
   declare ps_pp (STACKSIZE) fixed; /* ASSOCIATED PROGRAM POINTER */

   /* SP POINTS TO THE RIGHT END OF THE REDUCIBLE STRING IN THE PARSE STACK,
      MP POINTS TO THE LEFT END, AND
      MPP1 = MP+1.
   */
   declare (sp, mp, mpp1) fixed;

   /* DECLARE STATEMENTS AND CASE STATEMENTS REQUIRE AN AUXILIARY STACK */
   declare CASELIMIT literally '255', casestack(CASELIMIT) fixed;
   declare casep fixed;   /* POINTS TO THE CURRENT POSITION IN CASESTACK */
   declare dclrm character initial ('Identifier list too long');




   /*               P R O C E D U R E S                                  */


//
// Pad a STRING with blanks to WIDTH characters
//
pad:
   procedure (string, width) character;
      declare string character, (width, l) fixed;

      l = length(string);
      if l >= width then return string;
      do while width-l > 70;
         string = string || x70;
         l = l + 70;
      end;
      return string || substr(x70, 0, width-l);
   end pad;

//
// Convert a NUMBER to decimal, returning it right-justified in a string of
// WIDTH characters, using PAD as the fill character
//
iFormat:
   procedure (number, width, pad) character;
      declare (number, width, pad, l) fixed, string character, t character initial(' ');

      string = number;
      l = length(string);
      if l >= width then
         return string;
      if pad = byte(' ') then
         return substr(x70, 0, width-l) || string;
      byte(t,0) = pad;
      do l = 1 to width - l;
         string = t || string;
      end;
      return string;
   end iFormat;

//
// Convert a NUMBER to hex, returning it as a string of WIDTH characters
//
xFormat:
   procedure (number, width) character ;
      /* Warning, Xformat() returns a descriptor pointing into T; the value */
      /* of T will change upon the next call to Xformat() */
      declare (number,width,i,k) fixed, t character initial('        ');
      do k = 0 to 7;
         i = byte(hexcodes,number&"0F");
         byte(t,7-k) = i;
         number = shr(number, 4);
      end;
      if width <= 8 then return substr(t,8-width);
      return substr(x70, 0, width-8) || t;
   end xFormat;

hex:
   procedure(integer) character ;
      /* WARNING, HEX() RETURNS A DESCRIPTOR POINTING INTO T; THE VALUE */
      /* OF T WILL CHANGE UPON THE NEXT CALL TO HEX() */
      declare (i,k,integer) fixed, t character initial('        ');
      if integer = 0 then
         return '0';
      k = 7;
      do while (integer ~= 0) & (k >= 0);
         i = byte(hexcodes,integer&"0F");
         byte(t,k) = i;
         k = k - 1;
         integer = shr(integer, 4);
      end;
      return substr(t,k+1);
   end  hex  ;


error:
   procedure(msg, severity);
      /* PRINTS AND ACCOUNTS FOR ALL ERROR MESSAGES */
      /* IF SEVERITY IS NOT SUPPLIED, 0 IS ASSUMED */
      declare msg character, severity fixed;
#ifdef NOINLINE
      declare base fixed;
      base = addr( monitor_link );
#endif
      error_count = error_count + 1;
      /* IF LISTING IS SUPPRESSED, FORCE PRINTING OF THIS LINE */
      if ~ control(byte('L')) then
         output = iFormat(card_count,4,byte(' ')) || x1vbar || buffer || vbar;
      output = pad(x1,text_used+6) || vbar;
      /* SEVERITY(-1) IS A PORNOGRAPHIC WAY OF OBTAINING THE RETURN ADDRESS */
      output = '*** Error, ' || msg || ' (detected at location ' ||
#ifdef NOINLINE
                     hex( severity(-1) - base) ||
#else
                     hex( severity(-1) - inline(MOV,R32,R32,NONE, PBR,PBR)) ||
#endif
                     ' in xcom).  ***';
      if error_count > 1 then
          output = '*** Last previous error was detected on line ' ||
            previous_error || '. ***';
      previous_error = card_count;
      if severity > 0 then
         if severe_errors > 25 then
            do;
               output = '*** Too many severe errors, COMPILATION ABORTED ***';
               compiling = FALSE;
            end;
         else severe_errors = severe_errors + 1;
      severity = 0;
   end error;


   /*                      FILE HANDLING PROCEDURES                          */


getData:
   procedure;
      /* HANDLE SCRATCH STORAGE ALLOCATION FOR THE DATA ARRAY  */
      declare i fixed;
      count#getd = count#getd + 1;
      file(DATAFILE,curdblk) = data;     /*  WRITE OUT CURRENT BLOCK */
      curdblk = dp / DISKBYTES;          /* CALCULATE NEW BLOCK NUMBER */
      dporg = curdblk * DISKBYTES;
      dplim = dporg + DISKBYTES;
      if curdblk <= datamax then
            data = file(DATAFILE,curdblk);
      else
         do;
            /*  ZERO OUT THE NEW DATA BLOCK  */
            do i = 1 to shr(DISKBYTES,2);
               datamax(i) = 0;
            end;
            do datamax = datamax + 1 to curdblk - 1;
               file(DATAFILE,datamax)= data;
            end;
         end;
   end  getData;

getCode:
   procedure;
      /*  HANDLE SCRATCH STORAGE ALLOCATION FOR THE CODE ARRAY */
      declare i fixed;
      count#getc = count#getc + 1;
      file(CODEFILE,curcblk) = code;
      curcblk = pp / DISKBYTES;       /* CALCULATE NEW BLOCK NUMBER */
      pporg = curcblk * DISKBYTES;
      pplim = pporg + DISKBYTES;
      if curcblk <= codemax then
          code = file(CODEFILE,curcblk);
      else
         do;
         /*  ZERO OUT THE NEW CODE BLOCK */
            do i = 1 to shr(DISKBYTES,2);
               codemax(i) = 0;
            end;
            do codemax = codemax + 1 to curcblk - 1;
               file(CODEFILE,codemax) = code;
            end;
         end;
   end  getCode;

getDesc:
   procedure;
      /*  HANDLE SCRATCH STORAGE ALLOCATION FOR THE DESCRIPTOR ARRAY */
      declare i fixed;
      count#getds = count#getds + 1;
      file(STRINGFILE,curdsblk) = desc;
      curdsblk = dsp / DISKBYTES;       /* CALCULATE NEW BLOCK NUMBER */
      dsporg = curdsblk * DISKBYTES;
      dsplim = dsporg + DISKBYTES;
      if curdsblk <= descmax then
          desc = file(STRINGFILE,curdsblk);
      else
         do;
         /*  ZERO OUT THE NEW DESCRIPTOR BLOCK */
            do i = 1 to shr(DISKBYTES,2);
               descmax(i) = 0;
            end;
            do descmax = descmax + 1 to curdsblk - 1;
               file(STRINGFILE,descmax) = desc;
            end;
         end;
   end  getDesc;

getStrings:
   procedure;
      /* HANDLE SCRATCH STORAGE ALLOCATION FOR STRING ARRAY */
      count#gets = count#gets + 1;
      file(STRINGFILE, strngblk + cursblk) = strings;    /* WRITE INTO THE FILE */
      cursblk = chp / DISKBYTES;              /* COMPUTE NEW BLOCK NUMBER */
      chporg = cursblk*DISKBYTES;             /* NEW BLOCK ORIGIN */
      chplim = chporg + DISKBYTES;            /* NEW UPPER BOUND */
      if cursblk <= stringmax then
         strings = file(STRINGFILE,strngblk + cursblk);  /* READ BACK FROM FILE */
      else
         do stringmax = stringmax+1 to cursblk - 1;
            file(STRINGFILE,strngblk + stringmax) = strings; /* FILL OUT FILE SO NO GAPS EXIST */
         end;
   end getStrings;



  /*                   CARD IMAGE HANDLING PROCEDURE                      */


get_card:
   procedure;
      /* DOES ALL CARD READING AND LISTING                                 */
      declare i fixed, rest character, reading bit(1);


      parsePARMSTRING:
         procedure;
            /* TURN FLAGS ON/OFF FROM PARMSTRING */
            declare b fixed;
            do i = 0 to length(parmstring) - 8;
               if substr(parmstring,i,7) = 'FLAGON=' then
                  do;
                     b = byte(parmstring,i+7);
                     if byte('A') <= b & b <= byte('Z') then
                        do;
                           control(b) = TRUE;
                           if b = byte('T') then
                              call trace;
                           if b = byte('U') then
                              call untrace;
                        end;
                  end;
               else
                  if i < length(parmstring) - 8 &
                        substr(parmstring,i,8) = 'FLAGOFF=' then
                     do;
                        b = byte(parmstring,i+8);
                        if byte('A') <= b & b <= byte('Z') then
                           do;
                              control(b) = FALSE;
                              if b = byte('T') then
                                 call untrace;
                              if b = byte('U') then
                                 call trace;
                           end;
                     end;
            end;
      end parsePARMSTRING;


      if lb > 0 then
         do;
            text = balance;
            text_limit = lb - 1;
            lb = 0;
            cp = 0;
            return;
         end;
      expansion_count = 0;   /* CHECKED IN SCANNER MACRO EXPANSION */
      if reading then
         do; /* 'READING' IS FALSE DURING COMPILE OF LIBRARY FROM INPUT(2) */
            buffer = input;
            if length(buffer) = 0 then
               do; /* SIGNAL FOR EOF */
                  buffer = pad(' /*''/* */ EOF;END;EOF', 80);
                  control(byte('L')) = FALSE;
               end;
            else card_count = card_count + 1;  /* USED TO PRINT ON LISTING */
         end;
      else
         do; /* WHILE READING LIBRARY FILE ONLY */
            buffer = input(2);
            if length(buffer) = 0 then
               do;  /* SIGNAL TO SWITCH TO INPUT(0) */
                  control(byte('L')), reading = TRUE;  /* TURN ON LISTING */
                  control(byte('D')) = TRUE;    /* TURN ON SYMBOL DUMP  */
                  call parsePARMSTRING;
                  clock(1) = time;  /* KEEP TRACK OF TIME FOR COMPILE RATE */
                  text = x1;  /* INITIALIZE TEXT FOR SCAN */
                  /* STATEMENTS ARE COUNTED FOR STATISTICS */
                  statement_count = -1;
                  text_limit = 0;
                  procmark = ndecsy + 1;
                  return;
               end;
         end;
      if margin_chop > 0 then
         do; /* THE MARGIN CONTROL FROM DOLLAR | */
            i = length(buffer) - margin_chop;
            rest = substr(buffer, i);
            buffer = substr(buffer, 0, i);
         end;
      else rest = '';
      text = buffer;
      text_limit = length(text) - 1;
      text_used = 0;
      if control(byte('M')) then output = buffer;
      else if control(byte('L')) then
         do;
            char_temp = hex(pp);
            char_temp = substr(x70,0,6-length(char_temp)) || char_temp ||
                                               current_procedure || information;
            if length(buffer) <= 80 then
               do;
                  if length(rest) = 0 then
                     output = iFormat(card_count,4,byte(' ')) || x1vbar ||
                                            pad(buffer,80) || vbar || char_temp;
                  else
                     do;
                        output = iFormat(card_count,4,byte(' ')) || x1vbar ||
                                                 pad(buffer,80) || vbar || rest;
                        output = pad(x1,87) || char_temp;
                     end;
               end;
            else
               do;
                  output = iFormat(card_count,4,byte(' ')) || x1vbar || buffer || vbar;
                  output = pad(x1,87) || char_temp;
               end;
         end;
      information = '';
      cp = 0;
   end get_card;


   /*                THE SCANNER PROCEDURES              */


cchar:
   procedure;
      /* USED FOR STRINGS TO AVOID CARD BOUNDARY PROBLEMS */
      cp = cp + 1;
      if cp <= text_limit then return;
      call get_card;
   end cchar;

deblank:
   procedure;
      /* USED BY BCHAR */
      call cchar;
      do while byte(text, cp) = byte(' ');
         call cchar;
      end;
   end deblank;

bchar:
   procedure;
      /* USED FOR BIT STRINGS */
      do FOREVER;
         call deblank;
         ch = byte(text, cp);
         if ch ~= byte('(') then return;
         /*  (BASE WIDTH)  */
         call deblank;
         jbase = byte(text, cp) - byte('0');  /* WIDTH */
         if jbase < 1 | jbase > 4 then
            do;
               call error ('Illegal bit string width: ' || substr(text, cp, 1));
               jbase = 4;  /* DEFAULT WIDTH FOR ERROR */
            end;
         base = shl(1, jbase);
         call deblank;
         if byte(text, cp) ~= byte(')') then
            call error ('Missing ) in bit string' );
      end;
   end bchar;

build_bcd:
   procedure (c);
      declare c bit(8);
      if length(bcd) > 0 then
         bcd = bcd || x1;
      else
         bcd = substr(x1 || x1, 1);
      /* FORCE BCD TO THE TOP OF FREE STRING AREA AND INCREASE LENGTH
          BY ONE  */
      /* THIS LINE DEPENDS UPON THE IMPLEMENTATION OF XPL STRINGS */
      corebyte(freepoint-1) = c;
   end build_bcd;

scan:
   procedure;
      declare (s1, s2) fixed;
      declare lstrngm character initial('String too long');

      // Compare two strings for equality while disregarding case
      strcasecmp:
         procedure( s1, s2 ) bit(8);
            declare (s1, s2) character;
            declare (i, C1, c2) fixed;
            if length(s1) ~= length(s2) then
               return FALSE;
            do i = 0 to length(s1) - 1;
               C1 = byte( s1, i );
               if byte('a') <= C1 & C1 <= byte('z') then
                  C1 = C1 + (byte('A') - byte('a'));
               c2 = byte( s2, i );
               if byte('a') <= c2 & c2 <= byte('z') then
                  c2 = c2 + (byte('A') - byte('a'));
               if C1 ~= c2 then
                  return FALSE;
            end;
            return TRUE;
         end strcasecmp;

      count#scan = count#scan + 1;
      failsoft = TRUE;
      bcd = '';  number_value = 0;
   scan1:
      do FOREVER;
         if cp > text_limit then call get_card;
         else
            do; /* DISCARD LAST SCANNED VALUE */
               text_used = text_used + cp;
               text_limit = text_limit - cp;
               text = substr(text, cp);
               cp = 0;
            end;
         /*  BRANCH ON NEXT CHARACTER IN TEXT                  */
         do case chartype(byte(text));

            /*  CASE 0  */

            /* ILLEGAL CHARACTERS FALL HERE  */
            call error ('Illegal character: ' || xFormat(byte(text),2) );

            /*  CASE 1  */

            /*  BLANK  */
            do;
#ifdef NOINLINE
               cp = 1;
               do while byte(text, cp) = byte(' ') & cp <= text_limit;
                  cp = cp + 1;
               end;
               cp = cp - 1;
#else
               call inline( MOV,R8,IMM8,NONE, AL, byte(' ') );
               call inline( PUSH,R32,NONE,NONE, EDI );
               call inline( MOV,R32,M32,NONE, EDI, text );
               call inline( MOV,R32,R32,NONE, ECX, EDI );
               call inline( SRL,R32,IMM8,NONE, ECX, 24 );
               call inline( AND,R32,IMM32,NONE, EDI, "ffffff" );
               call inline( INC,R32,NONE,NONE, EDI );
               call inline( MOV,R32,R32,NONE, EBX, EDI );
               call inline( JCXZ,REL8,NONE,NONE, 5 );      /* jcxz X */
               call inline( REP,NONE,NONE,NONE );
               call inline( SCASB,NONE,NONE,NONE );
               call inline( JCC,REL8,NONE,NONE, CC_E, 1 ); /* je X */
               call inline( DEC,R32,NONE,NONE, EDI );
      /*X:*/   call inline( SUB,R32,R32,NONE, EDI, EBX );
               call inline( MOV,R32,R32,NONE, EDX, EDI );
               call inline( POP,R32,NONE,NONE, EDI );
               call inline( MOV,M32,R32,NONE, cp, EDX );
#endif
            end;

            /*  CASE 2  */

            /*  STRING QUOTE ('):  CHARACTER STRING  */
            do FOREVER;
               token = string;
               call cchar;
               s1 = cp;
               do while byte(text,cp) ~= byte('''');
                  cp = cp + 1;
                  if cp > text_limit then
                     do;
                        if length(bcd) + cp - s1 > 256 then
                           do;
                              call error(lstrngm);
                              return;
                           end;
                        bcd = bcd || substr(text,s1,cp-s1);
                        cp,s1 = 0;
                        call get_card;
                     end;
               end;
               if length(bcd)+cp-s1 > 256 then
                  do;
                     call error(lstrngm);
                     return;
                  end;
               if cp > s1 then
                  bcd = bcd || substr(text,s1,cp-s1);
               call cchar;
               if byte(text, cp) ~= byte('''') then
                  return;
               if length(bcd) > 255 then
                  do;
                     call error(lstrngm);
                     return;
                  end;
               bcd = bcd || '''';
               text_used = text_used + cp;
               text_limit = text_limit - cp;
               text = substr(text,cp);
               cp = 0;   /* PREPARE TO RESUME SCANNING STRING */
            end;

            /*  CASE 3  */

            do;      /*  BIT QUOTE("):  BIT STRING  */
               jbase = 4;  base = shl(1, jbase);  /* DEFAULT WIDTH  */
               token = number;  /* ASSUME SHORT BIT STRING */
               s1 = 0;
               call bchar;
               do while ch ~= byte('"');
                  s1 = s1 + jbase;
                  if  ch >= byte('0') & ch <= byte('9') then
                     s2 = ch - byte('0');        /*   DIGITS  */
                  else
                     if  ch >= byte('A') & ch <= byte('F') then
                        s2 = ch - (byte('A') - 10);   /*   LETTERS  */
                     else
                        s2 = ch - (byte('a') - 10);   /*   LETTERS  */
                  if s2 >= base | s2 < 0 then
                     call error ('Illegal character in bit string: ' || substr(text, cp, 1));
                  if s1 > 32 then token = string;     /* LONG BIT STRING */
                  if token = string then
                     do while s1 - jbase >= 8;
                        if length(bcd) > "FF" then
                           do;
                              call error (lstrngm);
                              return;
                           end;
                        s1 = s1 - 8;
                        call build_bcd (shr(number_value, s1-jbase));
                     end;
                  number_value = shl(number_value, jbase) + s2;
                  call bchar;
               end;     /* OF DO WHILE CH...  */
               cp = cp + 1;
               if token = string then
                  if length(bcd) > "FF" then call error (lstrngm);
                  else call build_bcd (shl(number_value, 8 - s1));
               return;
            end;

            /*  CASE 4  */

            do FOREVER;  /* A LETTER:  IDENTIFIERS AND RESERVED WORDS */
               do cp = cp + 1 to text_limit;
                  if not_letter_or_digit(byte(text, cp)) then
                     do;  /* END OF IDENTIFIER  */
                        if cp > 0 then bcd = bcd || substr(text, 0, cp);
                        s1 = length(bcd);
                        if s1 > 1 then if s1 <= reserved_limit then
                           /* CHECK FOR RESERVED WORDS */
                           do i = V_INDEX(s1-1) to V_INDEX(s1) - 1;
                              if strcasecmp(bcd, V(i)) then
                                 do;
                                    token = i;
                                    return;
                                 end;
                           end;
                        do i = macro_index(s1-1) to macro_index(s1) - 1;
                           if bcd = macro_name(i) then
                              do;
                                 bcd = macro_text(i);
                                 if expansion_count < EXPANSION_LIMIT then
                                    expansion_count = expansion_count + 1;
                                 else
                                    output = '*** Warning, too many expansions for '
                                                || macro_name(i) || ' LITERALLY: ' || bcd;
                                 text = substr(text, cp);
                                 text_limit = text_limit - cp;
                                 if length(bcd) + text_limit > 255 then
                                    do;
                                       if lb + text_limit > 255 then
                                         call error('Macro expansion too long');
                                       else
                                          do;
                                             balance = text || balance;
                                             lb = length(balance);
                                             text = bcd;
                                          end;
                                    end;
                                 else text = bcd || text;
                                 bcd = '';
                                 text_limit = length(text) - 1;
                                 if control(byte('X')) then
                                    do;
                                       if text_used = 0 then
                                          output = '     +' || pad(text,80) || '+';
                                       else
                                          do;
                                             s = pad(x1,text_used) || text;
                                             if length(s) > 80 then
                                                output = '     +' || s || '+';
                                             else
                                                output = '     +' || pad(s,80) || '+';
                                          end;
                                    end;
                                 cp = 0;
                                 go to scan1;
                              end;
                        end;
                        /*  RESERVED WORDS EXIT HIGHER: THEREFORE <IDENTIFIER>*/
                        token = ident;
                        return;
                     end;
               end;
               /*  END OF CARD  */
               bcd = bcd || text;
               call get_card;
               cp = -1;
            end;

            /*  CASE 5  */

            do;      /*  DIGIT:  A NUMBER  */
               token = number;
               do FOREVER;
                  do cp = cp to text_limit;
                     s1 = byte(text, cp);
                     if s1 < byte('0') | byte('9') < s1 then
                        return ;
                     number_value = 10*number_value + s1 - byte('0');
                  end;
                  call get_card;
               end;
            end;

            /*  CASE 6  */

            do;      /*  A /:  MAY BE DIVIDE OR START OF COMMENT  */
               call cchar;
               if byte(text, cp) = byte('/') then
                  /* WE HAVE A C++ STYLE COMMENT */
                  cp = text_limit;
               else
                  do;
                     if byte(text, cp) ~= byte('*') then
                        do;
                           token = divide;
                           return;
                        end;
                     /* WE HAVE A C OR PL/I STYLE COMMENT  */
                     s1, s2 = byte(' ');
                     do while s1 ~= byte('*') | s2 ~= byte('/');
                        /* LOOK FOR A CONTROL CHARACTER  */
                        if s1 = byte('~') & s2 = byte('$') then
                           do;  // Turn OFF code
                              s1 = s2;
                              call cchar;
                              s2 = byte(text,cp);
                              control(s2) = FALSE;
                              if s2 = byte('T') then call untrace;
                              else if s2 = byte('U') then call trace;
                              else if s2 = byte('|') then margin_chop = 0;
                           end;
                        else if s1 = byte('>') & s2 = byte('$') then
                           do;  // SAVE code
                              s1 = s2;
                              call cchar;
                              s2 = byte(text,cp);
                              savecontrol(s2) = control(s2);
                           end;
                        else if s1 = byte('<') & s2 = byte('$') then
                           do;  // RESTORE code
                              s1 = s2;
                              call cchar;
                              s2 = byte(text,cp);
                              control(s2) = savecontrol(s2);
                              if s2 = byte('T') then
                                 if control(byte('T')) then
                                    call trace;
                                 else
                                    call untrace;
                              if s2 = byte('U') then
                                 if control(byte('U')) then
                                    call untrace;
                                 else
                                    call trace;
                           end;
                        else if s1 = byte('?') & s2 = byte('$') then
                           do;  // TOGGLE code
                              s1 = s2;
                              call cchar;
                              s2 = byte(text,cp);
                              control(s2) = ~ control(s2);
                              if s2 = byte('T') then
                                 if control(byte('T')) then
                                    call trace;
                                 else
                                    call untrace;
                              if s2 = byte('U') then
                                 if control(byte('U')) then
                                    call untrace;
                                 else
                                    call trace;
                           end;
                        else if s1 = byte('$') then
                           do;  // Turn ON code
                              control(s2) = TRUE;
                              if s2 = byte('T') then call trace;
                              else if s2 = byte('U') then call untrace;
                              else if s2 = byte('|') then margin_chop = text_limit - cp + 1;
                           end;
                        s1 = s2;
                        call cchar;
                        s2 = byte(text, cp);
                     end;
                  end;
            end;

            /*  CASE 7  */
            do;      /*  SPECIAL CHARACTERS  */
               token = tx(byte(text));
               cp = 1;
               return;
            end;

            /*  CASE 8  */
            do;  /* A |:  MAY BE "OR" OR "CAT"  */
               call cchar;
               if byte(text, cp) = byte('|') then
                  do;
                     call cchar;
                     token = concatenate;
                  end;
               else token = orsymbol;
               return;
            end;

         end;     /* OF CASE ON CHARTYPE  */
         cp = cp + 1;  /* ADVANCE SCANNER AND RESUME SEARCH FOR TOKEN  */
      end;
   end scan;


  /*             ADDRESS AND REGISTER COMPUTATIONS                       */


clearregs:
   procedure;
      /* FREE ALL THE ARITHMETIC REGISTERS  */
      do i = 0 to 3;  bases(i) = AVAIL;  end;
      target_register = -1;
   end  clearregs;

findac:
   procedure fixed;
      /*  FIND AN ACCUMULATOR FOR 32 BIT QUANTITY  */
      declare (i, j) fixed;
      declare order(2) fixed initial( EBX, EDX, ECX );
      if target_register > -1 then if bases(target_register) = AVAIL then
         do;
            bases(target_register) = ACCUMULATOR;
            return target_register;
         end;
      do i = 0 to 2;
         j = order(i);
         if bases(j) = AVAIL then
            do;
               bases(j) = ACCUMULATOR;
               return j;
            end;
      end;
      call error('Used all accumulators',1);
      return 0;
   end  findac;

findaddress:
   procedure (adr);
      /* FIND THE APPROPRIATE BASE AND DISPLACEMENT FOR THE ADDRESS  */
      declare (adr, i) fixed;
      count#find = count#find + 1;
      if adr < 0 then
         do;
            adrdisp = - adr;
            adreg = SBR;
            return;
         end;
      if adr = 0 then
         do;
            adreg,adrdisp = 0;
            return;
         end;
      adrdisp =  adr;
      adreg = DBR;
      return;
   end  findaddress;




  /*                    CODE EMISSION PROCEDURES                       */


emitChar:
   procedure (c);
      declare c bit (8);
      /*  SEND ONE 8-BIT CHARACTER TO THE STRING AREA  */
      if control(byte('E')) then
         output = x70 || hex(chp) || ': Character = ' || xFormat(c,2);
      if chp < chporg | chp >= chplim then call getStrings;
      strings(chp-chporg) = c;
      chp = chp + 1;
   end  emitChar;

emitByte:
   procedure (b);
      declare b fixed;
      /*  EMIT ONE BYTE OF DATA  */
      if dp < dporg | dp >= dplim then call getData;
      data(dp-dporg) = b;
      if control(byte('E')) then
         output = x70 || hex(dp) || dataq || substr(hexcodes, shr(b,4), 1) ||
                                                   substr(hexcodes, b & "F", 1);
      dp = dp + 1;
   end emitByte;

emit1CodeByte: /*  EMIT A SINGLE BYTE OF CODE  */
   procedure (b1);
      declare b1 bit(8), i fixed;
      stillcond = 0;
      if pp < pporg | pp >= pplim then call getCode;
      i = pp - pporg;
      code(i) = b1;             /*  FIRST  BYTE  */
      if control(byte('B')) then
         output = x70 || hex(pp) || codeq || xFormat(b1,2);
      pp =  pp + 1;
   end  emit1CodeByte;

emit2CodeBytes: /*  EMIT TWO BYTES OF CODE  */
   procedure (b1,b2);
      declare (b1, b2) bit(8), i fixed;
      stillcond = 0;
      if pp < pporg | pp >= pplim then call getCode;
      i = pp - pporg;
      code(i) = b1;             /*  FIRST  BYTE  */
      pp = pp + 1;
      if pp < pporg | pp >= pplim then call getCode;
      i = pp - pporg;
      code(i) = b2;             /*  SECOND  BYTE  */
      pp = pp + 1;
      if control(byte('B')) then
         output = x70 || hex(pp-2) || codeq || xFormat(shl(b1,8)+b2,4);
   end  emit2CodeBytes ;

emit4CodeBytes: /*  EMIT FOUR BYTES OF CODE  */
   procedure (b1,b2,b3,b4);
      declare (b1, b2, b3, b4) bit(8), i fixed;
      stillcond = 0;
      if pp < pporg | pp >= pplim then call getCode;
      i = pp - pporg;
      code(i) = b1;             /*  FIRST  BYTE  */
      pp = pp + 1;
      if pp < pporg | pp >= pplim then call getCode;
      i = pp - pporg;
      code(i) = b2;             /*  SECOND  BYTE  */
      pp = pp + 1;
      if pp < pporg | pp >= pplim then call getCode;
      i = pp - pporg;
      code(i) = b3;             /*  THIRD  BYTE  */
      pp = pp + 1;
      if pp < pporg | pp >= pplim then call getCode;
      i = pp - pporg;
      code(i) = b4;             /*  FOURTH  BYTE  */
      pp = pp + 1;
      if control(byte('B')) then
         output = x70 || hex(pp-4) || codeq || xFormat(shl(b1,24)+shl(b2,16)+shl(b3,8)+b4,8);
   end  emit4CodeBytes ;

emitDataword:
   procedure(w);
      declare (w, i) fixed;
      /*  SEND A 32-BIT WORD TO THE DATA ARRAY  */
      dp = (dp + 3) & "FFFFFC";
      if dp < dporg | dp >= dplim then call getData;
      if control(byte('E')) then
         output = x70 || hex(dp) || dataq || hex(w);
      i = dp - dporg;
      data(i+3) = shr(w,24);
      data(i+2) = shr(w,16);
      data(i+1) = shr(w,8);
      data(i) = w;
      dp = dp + 4;
   end emitDataword;

emitDesc:
   procedure (d);
      declare (d, i) fixed;
      /*  SEND 32-BIT DESCRIPTOR TO STRING DESCRIPTOR AREA  */
      if dsp >= 4 * MAXDESC then
         do;
            call error ('Too many strings', 1);
            dsp = 0;
         end;
      if control(byte('E')) then
         output = x70 || hex(dsp) || ': Desc = ' || shr(d,24) || ', ' || hex(d & "FFFFFF");
      if dsp < dsporg | dsp >= dsplim then call getDesc;
      i = dsp - dsporg;
      desc(i+3) = shr(d,24);
      desc(i+2) = shr(d,16);
      desc(i+1) = shr(d,8);
      desc(i) = d;
      dsp = dsp + 4;
   end emitDesc;

emitConstant:
   procedure(c);
      /* SEE IF C HAS ALREADY BEEN EMITED, AND IF NOT EMIT.  SET UP ADDRESS */
      declare MAXCACHEC literally '512';
      declare ctab(MAXCACHEC) fixed, cadd (MAXCACHEC) bit(32), (c, i) fixed;
      do i = 1 to numcachc;
         if ctab(i) = c then
            do;
               adreg = shr(cadd(i), 28) & "0F";
               adrdisp = cadd(i) & "FFFFFFF";
               return;
            end;
      end;
      call emitDataword (c);
      ctab(i) = c;
      call findaddress(dp-4);
      cadd(i) = shl(adreg,28) + adrdisp;
      if i < MAXCACHEC then numcachc = i;
      information = information || ' C' || i || ' = ' || hex(c) || period;
   end emitConstant;


//
// Emit an instruction
//

declare hasXreg literally '"(1) 1 00"';

emit:
   procedure( code, va_arg, a2, a3, a4, a5 ) fixed;
   declare (code, va_arg, a2, a3, a4, a5) fixed;
   declare (vp, tp, op, t, x, w1, w2, w3, lw1, lw2, lw3, uop, ua1, ua2, ua3) fixed;
   declare (flag, rm, xrm, sib, xsib) bit(8);
   declare (opcode, op1, op2, op3) character,
            lb character initial( '[' ),
            rb character initial( ']' );

   //
   // Lookup CODE in the instruction template array
   //
   inst:
      procedure( code ) fixed;
         declare (i, l, h, code, V) fixed;
         l = 0;
         h = NTEMPLATE;
         do while l <= h;
            i = (l + h) / 2;
            V = shl(byte(template(i)),16) | shl(byte(template(i),1),8) | byte(template(i),2);
            if code = V then return i;
            if code < V then
               h = i - 1;
            else
               l = i + 1;
         end;
         return -1;
      end inst;

   count#emit = count#emit + 1;

   uop = shr( code, 17 ) & "7F";
   ua1 = shr( code, 9 ) & "FF";
   ua2 = shr( code, 2 ) & "7F";
   ua3 = code & "03";

   xsib,
   xrm = FALSE;

   rm,
   sib,
   lw1,
   lw2,
   lw3 = 0;

   tp = inst( code & "FFF1E3" );
   if  tp = -1 then
      do;
         call error('INST(' || uop || comma || shr(ua1,3) || comma || shr(ua2,3) || comma
                        || (ua3 + 4) || '), ... ) is an unsupported instruction', 1);
         return -1;
      end;

   vp = 0;

   op = shl(byte(template(tp),3),8) | byte(template(tp),4);
   flag = byte(template(tp),5);
   instruct(uop) = instruct(uop) + 1;
   opcode = i486Opcodes( byte(template(tp),6) );

   declare ua1v(17) character initial('EAX',''  ,'',''   ,'AH','NONE','IMM8',
                                      'IMM32','R8','R16','R32','IMM16','M8',
                                      'M16','M32','REL8','REL32','REL');
   declare ua2v(15) character initial('EAX','CL','','EBX',''  ,'NONE','IMM8',
                                      'IMM32','R8','R16','R32','IMM16','M8',
                                      'M16','M32','ONE');
   declare ua3v( 3) character initial(''  ,'NONE','IMM8','IMM32');
   declare uaxv( 7) character initial('', '', '', '', 'Xx1|', 'Xx2|', 'Xx4|', 'Xx8|');
   if control(byte('I')) then
      output = '        ' || pad(opcode,10) ||
                             pad(uaxv(ua1&7) || ua1v(shr(ua1,3)) || comma ||
                                 uaxv(ua2&7) || ua2v(shr(ua2,3)) || comma ||
                                 ua3v(ua3), 25) ||
                             va_arg || comma || a2 || comma || a3 || comma || a4 || comma || a5;

   if (flag & F_OPR) ~= 0 then   /* op /n */
      do;
         rm = rm | shl(flag & "07", 3);
         xrm = TRUE;
      end;
   if (flag & F_CC) ~= 0 then
      do;
         t = va_arg(vp);
         vp = vp + 1;
         op = op | t;
         opcode = opcode || CCnames(t);
      end;
   else
      t = 0;

   do case shr(ua1,3);
      do; /* 0:     AL: arith %AL,IMM8 */
            /*          XLAT %AL,%EBX */
            /*     EAX: arith %EAX,IMM32 */
            /*          IDIV %EAX,R/M32 */
         if shr(ua2,3) = IMM8 | uop = XLAT then
            op1 = RegName8(AL);
         else
            op1 = RegName32(EAX);
      end;
      ; /* 1:  CL */
      ; /* 2: */
      ; /* 3: */
      op1 = RegName8(AH); /* 4:  AH: LAHF %AH */
      ; /* 5:  NONE */
      do; /* 6:  IMM8 */
         lw1 = 1;
imm1:    w1 = va_arg(vp);
         vp = vp + 1;
         op1 = equal || hex(w1);
      end;
      do; /* 7:  IMM32 */
         lw1 = 4;
         goto imm1;
      end;
      do; /* 8:  R8: R/M8, register, dest */
         t = va_arg(vp);
         op1 = RegName8(t);
r8:      vp = vp + 1;
         if (flag & F_OPD) ~= 0 then
            op = op | t;
         else
            do;
               if (flag & F_MR) ~= 0 then
                  rm = rm | shl(t, 3);
               else
                  rm = rm | "C0" | t;
               xrm = TRUE;
            end;
      end;
      do; /* 9:  R16: R/M16, register, dest */
         t = va_arg(vp);
         op1 = RegName16(t);
         goto r8;
      end;
      do; /* 10:  R32: R/M32, register, dest */
         t = va_arg(vp);
         vp = vp + 1;
         if (flag & F_OPD) ~= 0 then
            op = op | t;
         else
            do;
               if (flag & F_MR) ~= 0 then
                  do;
                     rm = rm | shl(t, 3);
                     if uop = IMUL & (shr(ua2,3) = IMM8 | shr(ua2,3) = IMM32) then
                        rm = rm | "C0" | t;
                  end;
               else
                  rm = rm | "C0" | t;
               xrm = TRUE;
            end;
         op1 = RegName32(t);
      end;
      do; /* 11: IMM16 */
         lw1 = 2;
         goto imm1;
      end;
      do; /* 12: M8: R/M8, memory, dest */
m32:              /* R/M32, memory, dest */
         if (ua1 & hasXreg) ~= 0 then
            do;
               x = va_arg(vp);    /* index reg */
               vp = vp + 1;
               xsib = TRUE;
               sib = shl(ua1 & 3, 6) | shl(x, 3);
            end;
         t = va_arg(vp);    /* reg */
         w1 = va_arg(vp+1);   /* disp */
         vp = vp + 2;
         xrm = TRUE;
         if t = NOREG then
            do;
               op1 = hex(w1);
               if xsib then
                  do;
                     rm = rm | "04";
                     sib = sib | "05";
                     op1 = op1 || lb || RegName32(x) || XregScale(shr(sib,6)) || comma || rb;
                  end;
               else
                  rm = rm | "05";
               lw1 = 4;
            end;
         else
            if w1 = 0 & t ~= EBP then
               do;
                  op1 = RegName32(t);
                  if xsib then
                     do;
                        rm = rm | "04";
                        sib = sib | t;
                        op1 = RegName32(x) || XregScale(shr(sib,6)) || comma || op1;
                     end;
                  else
                     rm = rm | "00" | t;
                  op1 = lb || op1 || rb;
               end;
            else
               do;
                  if -128 <= w1 & w1 < 128 then
                     lw1 = 1;
                  else
                     lw1 = 4;
                  op1 = RegName32(t);
                  if xsib then
                     do;
                        if lw1 = 1 then
                           rm = rm | "44";
                        else
                           rm = rm | "84";
                        sib = sib | t;
                        op1 = RegName32(x) || XregScale(shr(sib,6)) || comma || op1;
                     end;
                  else
                     do;
                        if lw1 = 1 then
                           rm = rm | "40" | t;
                        else
                           rm = rm | "80" | t;
                     end;
                  op1 = hex(w1) || lb || op1 || rb;
               end;
      end;
      goto m32; /* 13: M16 */
      goto m32; /* 14: M32 */
      do; /* 15: REL8 */
         w1 = va_arg(vp);
         if (code & FromINLINE) = 0 then
            w1 = w1 - (pp + 2);
         vp = vp + 1;
         lw1 = 1;
         op1 = hex(pp + 2 + w1);
      end;
      do; /* 16: REL32 */
         if op <= 255 then
            x = 1;
         else
            x = 2;
         w1 = va_arg(vp);
         if (code & FromINLINE) = 0 then
            w1 = w1 - (pp + x + 4);
         vp = vp + 1;
         lw1 = 4;
         op1 = hex(pp + x + 4 + w1);
      end;
      do; /* 17: REL: either REL8 or REL32 */
         w1 = va_arg(vp) - (pp + 1 + 1);     /* REL8 is always 1 byte opcode */
         vp = vp + 1;
         if -128 <= w1 & w1 < 128 then
            do;
               op = relopcodes(byte(template(tp),4)) | t;
               lw1 = 1;
               x = 1;
            end;
         else
            do;
               op = relopcodes( byte(template(tp),4) + 1 ) | t;
               if op <= 255 then
                  x = 1;
               else
                  x = 2;
               w1 = w1 - (x + 2);
               lw1 = 4;
            end;
         op1 = hex(pp + x + lw1 + w1);
      end;
   end;

   do case shr(ua2,3);
      op2 = RegName32(EAX); /* 0:  %EAX:  XCHG R32,%EAX */
      op2 = RegName8(CL);   /* 1:  %CL:  s[ah][lr] xx,%CL */
      ; /* 2: */
      op2 = RegName32(EBX); /* 3:  %EBX:  XLAT %AL,%EBX */
      ; /* 4: */
      ; /* 5:  NONE */
      do; /* 6:  IMM8 */
         w2 = va_arg(vp);
         vp = vp + 1;
         if ~ (0 <= w2 & w2 <= 31) then
            do;
               if (flag & F_BITO) ~= 0 then
                  do;
                     if shr(ua1,3) = M32 then
                        do;
                           if lw1 ~= 0 then
                              w1 = w1 + 4 * (w2 / 32);
                           else
                              w1 = 4 * (w2 / 32);
                           rm = rm & "3F";
                           if -128 <= w1 & w1 < 128 then
                              do;
                                 rm = rm | "40";
                                 lw1 = 1;
                              end;
                           else
                              do;
                                 rm = rm | "80";
                                 lw1 = 4;
                              end;
                           op1 = hex(w1) || lb || RegName32(rm&"07") || rb;
                        end;
                     w2 = w2 & "1F";
                  end;
            end;
         lw2 = 1;
         op2 = equal || hex(w2);
      end;
      do; /* 7:  IMM32 */
         lw2 = 4;
imm32:   w2 = va_arg(vp);
         vp = vp + 1;
         op2 = equal || hex(w2);
      end;
      do; /* 8:  R8:  /R8 register, src */
         t = va_arg(vp);
         vp = vp + 1;
         if (flag & F_MR) ~= 0 then
            rm = rm | "C0" | t;
         else
            rm = rm | shl(t, 3);
         op2 = RegName8(t);
      end;
      do; /* 9: R16:  /R16 register, src */
         t = va_arg(vp);
         op2 = RegName16(t);
r16:     vp = vp + 1;
         if (flag & F_OPD) ~= 0 then
            op = op | t;
         else
            do;
               if (flag & F_MR) ~= 0 then
                  rm = rm | "C0" | t;
               else
                  rm = rm | shl(t, 3);
            end;
      end;
      do; /* 10:  R32:  /R32, register, src */
         t = va_arg(vp);
         op2 = RegName32(t);
         goto r16;
      end;
      do; /* 11:  IMM16 */
         lw2 = 2;
         goto imm32;
      end;
      do; /* 12: M8:  R/M8, memory as src */
m8:
         if (ua2 & hasXreg) ~= 0 then
            do;
               x = va_arg(vp);    /* index reg */
               vp = vp + 1;
               xsib = TRUE;
               sib = shl(ua2 & 3, 6) | shl(x, 3);
            end;
         t = va_arg(vp);    /* reg */
         w2 = va_arg(vp+1); /* disp */
         vp = vp + 2;
         if t = NOREG then
            do;
               op2 = hex(w2);
               if xsib then
                  do;
                     rm = rm | "04";
                     sib = sib | "05";
                     op2 = op2 || lb || RegName32(x) || XregScale(shr(sib,6)) || comma || rb;
                  end;
               else
                  rm = rm | "05";
               lw2 = 4;
            end;
         else
            if w2 = 0 & t ~= EBP then
               do;
                  op2 = RegName32(t);
                  if xsib then
                     do;
                        rm = rm | "04";
                        sib = sib | t;
                        op2 = RegName32(x) || XregScale(shr(sib,6)) || comma || op2;
                     end;
                  else
                     rm = rm | "00" | t;
                  op2 = lb || op2 || rb;
               end;
            else
               do;
                  if -128 <= w2 & w2 < 128 then
                     lw2 = 1;
                  else
                     lw2 = 4;
                  op2 = RegName32(t);
                  if xsib then
                     do;
                        if lw2 = 1 then
                           rm = rm | "44";
                        else
                           rm = rm | "84";
                        sib = sib | t;
                        op2 = RegName32(x) || XregScale(shr(sib,6)) || comma || op2;
                     end;
                  else
                     do;
                        if lw2 = 1 then
                           rm = rm | "40" | t;
                        else
                           rm = rm | "80" | t;
                     end;
                  op2 = hex(w2) || lb || op2 || rb;
               end;
      end;
      goto m8; /* 13: M16:  R/M16, memory as src */
      goto m8; /* 14: M32:  R/M32, memory as src */
      op2 = 1; /* 15: ONE:  s[AH][lr] xx,1 */
   end;

   do case ua3;
      ;  /* 0: */
      ;  /* 1: NONE & "03" */
      do;  /* 2: IMM8 & "03" */
         lw3 = 1;
imm8:    w3 = va_arg(vp);
         vp = vp + 1;
         op3 = equal || hex(w3);
      end;
      do;  /* 3: IMM32 & "03" */
         lw3 = 4;
         goto imm8;
      end;
   end;

   if control(byte('E')) then
      do;
         if shr(ua1,3) ~= NONE then
            do;
               opcode = pad(opcode,8) || op1;
               if shr(ua2,3) ~= NONE then
                  do;
                     opcode = opcode || comma || op2;
                     if ua3 ~= (NONE & 03) then
                        opcode = opcode || comma || op3;
                  end;
            end;
         output = x70 || hex(pp) || instq || opcode;
      end;

   if op <= 255 then
      call emit1CodeByte( op );
   else
      call emit2CodeBytes( shr(op,8), op );
   if xrm then
      call emit1CodeByte( rm );
   if xsib then
      call emit1CodeByte( sib );
   if lw1 ~= 0 then
      if lw1 = 1 then
         call emit1CodeByte( w1 );
      else
         if lw1 = 2 then
            call emit2CodeBytes( w1, shr(w1,8) );
         else
            call emit4CodeBytes( w1, shr(w1,8), shr(w1,16), shr(w1,24) );
   if lw2 ~= 0 then
      if lw2 = 1 then
         call emit1CodeByte( w2 );
      else
         if lw2 = 2 then
            call emit2CodeBytes( w2, shr(w2,8) );
         else
            call emit4CodeBytes( w2, shr(w2,8), shr(w2,16), shr(w2,24) );
   if lw3 ~= 0 then
      if lw3 = 1 then
         call emit1CodeByte( w3 );
      else
         call emit4CodeBytes( w3, shr(w3,8), shr(w3,16), shr(w3,24) );

   return 0;
   end emit;


  /*                       FIXUP PROCEDURES                                  */



insert_code_fixups:
   procedure;
      /* EMPTY THE FIXUP TABLE, EITHER FOR LOADING OR BECAUSE OF
         TABLE OVERFLOW */
      declare (i, j, l, fxlim, t1, k) fixed, (modified, t2) bit(8);

      /* THE FIRST STEP IS TO SORT THE CODE FIXUP TABLE */
      fxlim = fcp - 1;
      k = shr(fxlim+1,1);
      do while k > 0;
         do j = 0 to fxlim-k;
            i = j;
            do while fixcadr(i) > fixcadr(i+k);
               l = i+k;
               t1 = fixcadr(l);  fixcadr(l) = fixcadr(i);   fixcadr(i) = t1;
               t2 = fixcl(l);    fixcl(l) = fixcl(i);       fixcl(i) = t2;
               t1 = fixcv(l);    fixcv(l) = fixcv(i);       fixcv(i) = t1;
               i = i - k;
               if i < 0 then
                  go to lm;
            end;
     lm: end;
         k = shr(k,1);
     end;

      /* NOW WRITE OUT THE CURRENT BLOCK */
      file(CODEFILE,curcblk) = code;

      /* WRITE BINARY PROGRAM PATCHES INTO PROGRAM FILE */

      k, pporg=0;  pplim = DISKBYTES;
      do j = 0 to codemax;

         /* KEEP TRACK SO THAT WE WILL KNOW WHEN TO READ IN */
         modified = FALSE;

         do while (k <= fxlim)  &  (fixcadr(k) < pplim);
            /* IF THE FILE HAS NOT YET BEEN READ IN, DO SO */
            if ~ modified then          /* ONLY IF A FIX IS NEEDED */
                code = file(CODEFILE,j);
            t1 = fixcadr(k);
            l = t1 - pporg;  /* RELATIVE ADDRESS WITHIN THIS BLOCK */
            if fixcl(k) = 0 then  /* A branch instruction */
               do;
                  if code(l) = "0F" | code(l) = "FF" then
                     do;                     /* JCC REL32 or JMP M32 indirect */
                        fixcadr(k) = t1 + 2;
                        fixcl(k) = 4;
                        fixcv(k) = fixcv(k) - (t1 + 6);
                     end;
                  else
                     if code(l) = "E9" then   /* JMP REL32 */
                        do;
                           fixcadr(k) = t1 + 1;
                           fixcl(k) = 4;
                           fixcv(k) = fixcv(k) - (t1 + 5);
                        end;
                     else                     /* near branch */
                        do;
                           t1 = fixcv(k) - (t1 + 2);
                           if -128 <= t1 & t1 <= 127 then
                              do;
                                 fixcadr(k) = fixcadr(k) + 1;
                                 fixcl(k) = 1;
                                 fixcv(k) = t1;
                              end;
                           else
                              do;
                                 call error( 'Target ' || hex(fixcv(k)) ||
                                             ' out of range for near branch at location '
                                             || hex(fixcadr(k)), 1);
                                 k = k + 1;
                              end;
                        end;
               end;
            else
               do;
                  modified = TRUE;
                  t2,
                  code(l) = fixcv(k);
                  if control(byte('B')) then
                     output = x70 || hex(fixcadr(k)) || codeq || xFormat(t2,2);
                  if fixcl(k) = 1 then  /* A single byte; we're done */
                     k = k + 1;
                  else
                     do;
                        /* Do a single byte at a time */
                        fixcadr(k) = fixcadr(k) + 1;
                        fixcl(k) = fixcl(k) - 1;
                        fixcv(k) = shr( fixcv(k), 8 );
                     end;
               end;
         end;

         if modified then    /* A FIXUP WAS DONE */
            file(CODEFILE,j) = code;  /* SO WRITE OUT THE CONTENTS */

         pporg = pporg + DISKBYTES;
         pplim = pplim + DISKBYTES;
      end;

      fcp = 0;  /* RESET TABLE TO EMPTY */
      code = file(CODEFILE,curcblk);  /* RESTORE FILE TO PREVIOUS STATE */
      pporg = curcblk*DISKBYTES;  pplim = pporg + DISKBYTES;
   end insert_code_fixups;


//
// Set a 4-byte immediate value at WHERE to VAL
//
fixcodeword:
   procedure (where, val);
      declare (where, val, p) fixed;
      declare (b1, b2, b3, b4) bit(8);
      if pporg <= where & where+3 < pplim then
         do;
            p = where - pporg;
            shortcfix = shortcfix + 1;
            b1,
            code(p) = val;
            b2,
            code(p+1) = shr(val,8);
            b3,
            code(p+2) = shr(val,16);
            b4,
            code(p+3) = shr(val,24);
            if control(byte('B')) then
               output = x70 || hex(where) || codeq || xFormat(shl(b1,24)+shl(b2,16)+shl(b3,8)+b4,8);
         end;
      else
         do;
            longcfix = longcfix + 1;
            fixcl(fcp) = 4;             /* an immediate32 to VAL at WHERE */
            fixcadr(fcp) = where;
            fixcv(fcp) = val;
            fcp = fcp + 1;
         end;
   end fixcodeword;


//
// Fix up a single byte at WHERE to VAL
//
fixcodebyte:
   procedure (where, val);
      declare (where, val, p) fixed;
      if pporg <= where & where < pplim then
         do;
            p = where - pporg;
            shortcfix = shortcfix + 1;
            code(p) = val;
            if control(byte('B')) then
               output = x70 || hex(where) || codeq || xFormat(val,2);
         end;
      else
         do;
            longcfix = longcfix + 1;
            fixcl(fcp) = 1;             /* an byte to VAL at WHERE */
            fixcadr(fcp) = where;
            fixcv(fcp) = val;
            fcp = fcp + 1;
         end;
   end fixcodebyte;


//
// Fix up a branch to a known address; we don't yet know if it's a near
// or far branch, or where exactly the immediate value begins in the
// instruction at WHERE
//
fixbfw:
   procedure (where, val);
      declare (where, val, i, j, p) fixed;
      if where = 0 then return;
      count#fixbfw = count#fixbfw + 1;
      if control(byte('E')) then
         output = x70 || '     ' || hex(where) || ': Text fixup = ' || hex(val);
      if fcp >= FCLIM then
         call insert_code_fixups;
      if pporg <= where & where < pplim then
         do;
            p = where - pporg;
            if code(p) = "0F" | code(p) = "FF" then
               /* JCC REL32 or JMP M32 indirect */
               call fixcodeword( where + 2, val - (where + 6) );
            else
               if code(p) = "E9" then   /* JMP REL32 */
                  call fixcodeword( where + 1, val - (where + 5));
               else                     /* near branch */
                  do;
                     j = val - (where + 2);
                     if -128 <= j & j <= 127 then
                        call fixcodebyte( where + 1, j );
                     else
                        call error( 'Target ' || hex(val) ||
                                    ' out of range for near branch at location '
                                    || hex(where), 1);
                  end;
         end;
      else
         do;
            longcfix = longcfix + 1;
            fixcl(fcp) = 0;     /* an unknown branch to VAL at WHERE */
            fixcadr(fcp) = where;
            fixcv(fcp) = val;
            fcp = fcp + 1;
         end;
   end fixbfw;


fixwholedataword:
   procedure (adr, word);
      declare (adr, word) fixed;
      declare (blk, temp) fixed, reread bit(1);
      if control(byte('E')) then
         output = x70 || hex(adr) || ': Data fixup = ' || hex(word);
      count#fixd = count#fixd + 1;
      blk = adr/DISKBYTES;
      reread = (curdblk ~= blk);
      if reread then
         do;  /* MUST GET THE RIGHT BLOCK  */
            longdfix = longdfix + 1;
            temp = dp;
            dp = adr;
            call getData;
         end;
      else shortdfix = shortdfix + 1;
      adr = adr mod DISKBYTES;
      data(adr+3) = shr(word, 24);
      data(adr+2) = shr(word, 16);
      data(adr+1) = shr(word, 8);
      data(adr) = word;
      if reread then dp = temp;
   end  fixwholedataword;



   /*    PROCEDURES  FOR  MANIPULATING  THE SYMBOL  TABLE  */


hasher:
   procedure(id);
      /*  GENERATES A HASH CODE FOR THE IDENTIFIER ID  */
      declare id character, l fixed;
      l = length(id);
      return (byte(id) + byte(id,l-1) + shl(l,4)) & "FF";
   end  hasher  ;


enter:
   procedure (name, type, location, line);
      /*  ENTER A SYMBOL IN THE SYMBOL TABLE  */
      declare (i, j, k, location, type, line) fixed, name character;

      idx = hasher(name);
      i = hash(idx);
      do while i >= procmark ;
         /*  NOW TEST FOR NAME USING INDIRECT INDICES  */
         idcompares = idcompares + 1;
         if name = syt_name(i) then
            do;
               k = syt_type(i);
               if type = LABELTYPE & (k = FORWARDTYPE | k = FORWARDCALL) then
                  do;
                     if control(byte('E')) then
                        output = x70 || 'Fix references to: ' || name;
                     j = bases(syt_base(i))+ syt_disp(i);
                     if k = FORWARDCALL then
                        do;
                           /* This depends on what instructions will be
                              generated for a PROCEDURE */
                           location = location + 1 + 4; /* Allow for the JMP REL32 */
                           location = (location + 3) & "FFFFFFFC"; /* Round to next word address */
                        end;
                     syt_base(i) = PBR;
                     syt_disp(i) = location;
                     call fixwholedataword(j,location);
                     syt_type(i) = type;
                  end;
               else if procmark + parct < i then
                  call error('Duplicate declaration for:  ' || name);
               declared_on_line(i) = line;
               return i;
            end;
         i = ptr(i);         /*  CHECK NEXT LINK  */
      end;
      ndecsy = ndecsy + 1;
      if ndecsy > maxndecsy then
         if ndecsy > SYTSIZE then
            do;
               call error ('Symbol table overflow', 1);
               ndecsy = ndecsy - 1;
               compiling = FALSE;
               output = '*** COMPILATION ABORTED  ****';
            end;
         else maxndecsy = ndecsy;
      syt_name(ndecsy) = name;
      /*  LINK IN HASH ID AS LEGAL  */
      ptr(ndecsy) = hash(idx);
      hash(idx) = ndecsy;
      syt_type(ndecsy) = type;
      declared_on_line(ndecsy) = line;
      syt_count(ndecsy) = 0;
      if type = LABELTYPE then
         do;
            syt_base(ndecsy) = PBR;
            syt_disp(ndecsy) = location;
         end;
      else
         do;
            call findaddress(location);
            syt_base(ndecsy) = adreg;
            syt_disp(ndecsy) = adrdisp;
         end;
      return ndecsy;
   end  enter;

id_lookup:
   procedure (p);
       /* LOOKS UP THE IDENTIFIER AT P IN THE ANALYSIS STACK IN THE
          SYMBOL TABLE AND INITIALIZES PS_FXloc,PS_Cnt,PS_Type,PS_Reg,PS_Xreg
          APPROPRIATELY.  IF THE IDENTIFIER IS NOT FOUND, PS_FXloc IS
          SET TO -1
       */
      declare p fixed, i fixed;
      char_temp = ps_name(p);
      i = hash(hasher(char_temp));
      do while i ~= -1;
         idcompares = idcompares + 1;
         if syt_name(i) = char_temp then
            do;
               ps_fxloc(p) = i;
               ps_cnt(p) = 0;   /* INITIALIZE SUBSCRIPT COUNT  */
               ps_type(p) = VARIABLE;
               if syt_type(i) = SPECIAL then
                  ps_fxval(p) = syt_disp(i);          /* BUILTIN FUNCTION */
               else
                  ps_fxval(p) = 0;               /* ~ BUILTIN FUNCTION */
               ps_reg(p),ps_xreg(p) = 0;   /* INITIALIZE REGISTER POINTERS */
               syt_count(i) = syt_count(i) + 1;  /* COUNT REFERENCES */
               return;
            end;
         i = ptr(i);
      end;
      ps_fxloc(p) = -1;      /*  IDENTIFIER NOT  FOUND */
   end   id_lookup;


undeclared_id:
   procedure (p);
      /* ISSUES AN ERROR MESSAGE FOR UNDECLARED IDENTIFIERS AND
         ENTERS THEM WITH DEFAULT TYPE IN THE SYMBOL TABLE
      */
      declare p fixed;
      call error('Undeclared identifier:  ' || ps_name(p) );
      call emitDataword(0);
      call enter (ps_name(p), FIXEDTYPE, dp-4, card_count);
      ps_cnt(p) = 0;
      ps_fxval(p) = 0;
      ps_reg(p) = 0;
      ps_xreg(p) = 0;
      ps_fxloc(p) = ndecsy;
      syt_count(ndecsy) = 1;                /* COUNT FIRST REFERENCE */
      ps_type(p) = VARIABLE;
   end  undeclared_id;

setinit:
   procedure;
      /*  PLACES INITIAL VALUES INTO DATA AREA */

      declare (i, j) fixed;
      if itype = CHRTYPE then
         do;
            if ps_type(mpp1) ~= CHRTYPE then ps_name(mpp1) = ps_fxval(mpp1);
            s = ps_name(mpp1);    /* THE STRING */
            i = length(s) - 1;

            if i < 0 then
               call emitDesc(0);
            else
               call emitDesc(shl(i,24) + chp);

            do j = 0 to i;
               call emitChar(byte(s,j));
            end;
         end;
      else if ps_type(mpp1) ~= CONSTANT then
         call error ('Illegal CONSTANT in INITIAL list');
      else if itype = FIXEDTYPE then
         call emitDataword(ps_fxval(mpp1));
      else if itype = HALFWORD then
         do;
            /*  FIRST FORCE ALIGNMENT  */
            dp = (dp + 1) & "FFFFFE";
            call emitByte(ps_fxval(mpp1) & "FF");
            call emitByte (shr(ps_fxval(mpp1), 8));
         end;
      else if itype = BYTETYPE then
         call emitByte(ps_fxval(mpp1));
   end  setinit;

allocate :
   procedure(p,dim);
      /* ALLOCATES STORAGE FOR THE IDENTIFIER AT P IN THE ANALYSIS
         STACK WITH DIMENSION DIM
      */

      declare (p, dim, j) fixed;


   check_newdp:
      procedure;
         declare t fixed;
         t = dp;
         dp = newdp;
         dp = t;
      end  check_newdp;



      dim = dim + 1;         /* ACTUAL NUMBER OF ITEMS  */
      do case ps_type(p);

         ;     /*  CASE  0    DUMMY        */

         do;      /*   CASE 1    HALFWORD  */
            newdp = (newdp + 1) & "FFFFFE";   /* ALIGN HALFWORD  */
            call check_newdp;
            j = newdp;
            newdp = newdp + shl(dim, 1);
         end;


         ;     /*  CASE  2    LABEL TYPE         */


          ;    /*  CASE  3    ACCUMULATOR        */

          ;    /*  CASE  4    VARIABLE           */

          ;    /*  CASE  5    CONSTANT           */

          ;    /*  CASE  6    CONDITION          */

          do;  /*  CASE  7    CHARACTER TYPE     */
            j = -newdsp;
            newdsp = newdsp + shl(dim,2);
            if newdsp >= 4 * MAXDESC then
               do;
                  call error('Too many character strings',1);
                  dsp, newdsp = 0;  /*  TAKE CORRECTIVE ACTION  */
               end;
          end;

          do;  /*  CASE  8    FIXED TYPE         */
            newdp = (newdp + 3) & "FFFFFC";    /* ALIGN TO WORD */
            call check_newdp;
            j = newdp;
            newdp = newdp + shl(dim,2);
          end;

          do;  /*  CASE  9    BYTE TYPE          */
            call check_newdp;
            j = newdp;
            newdp = newdp + dim;
          end;

         do;  /*  CASE 10    FORWARD TYPE  (LABEL)  */
            newdp = (newdp+3) & "FFFFFC";  /* WORD ALIGN */
            call check_newdp;
            j = newdp;
            newdp = newdp + shl(dim,2);        /* SPACE FOR FIXUPS  */
         end;

          ;    /*  CASE 11    DESCRIPT           */

          ;    /*  CASE 12    SPECIAL            */

          ;    /*  CASE 13    FORWARD CALL       */

          ;    /*  CASE 14    CHAR_PROC_TYPE             */

          ;    /*  CASE 15    UNUSED             */

      end; /*  OF DO CASE PS_Type(P)  */

      syt_type(ps_fxloc(p)) = ps_type(p);
      call findaddress(j);
      syt_base(ps_fxloc(p)) = adreg;
      syt_disp(ps_fxloc(p)) = adrdisp;

   end  allocate;


tdeclare:
   procedure (dim);
      /*  ALLOCATES STORAGE FOR IDENTIFIERS IN DECLARATIONS  */
      declare dim fixed;
      newdp = dp;
      newdsp = dsp;
      ps_type(mp) = ps_type(sp);
      casep = ps_fxloc(mp);
      do i = 1 to ps_xreg(mp);
         ps_fxloc(mp) = casestack(casep+i);      /* SYMBOL TABLE POINTER */
         call allocate(mp, dim);
      end;
   end  tdeclare;




movestacks:
   procedure (f,t);
      declare f fixed, t fixed;
      /*  MOVE ALL THE COMPILER STACKS DOWN FROM F TO T  */
      ps_type(t) = ps_type(f);    ps_name(t) = ps_name(f);
      ps_fxloc(t) = ps_fxloc(f);  ps_fxval(t) = ps_fxval(f);
      ps_xreg(t) = ps_xreg(f);    ps_reg(t) = ps_reg(f);
      ps_pp(t) = ps_pp(f);        ps_cnt(t) = ps_cnt(f);
   end  movestacks;




  /*                        BRANCH PROCEDURES                                */



branch:
   procedure (cond, location);
      declare (cond, location) fixed;
      if location = 0 then location = pp;
      /* ASSUME FIXUP WILL BE NEAR  */
      if location = -1 then
         call emit( inst_jcc_rel32, cond, pp );
      else
         call emit( inst_jcc_rel, cond, location );
   end branch;


jump:
   procedure (location);
      declare location fixed;
      if location = 0 then location = pp;
      /* ASSUME FIXUP WILL BE NEAR  */
      if location = -1 then
         call emit( inst_jmp_rel32, pp );
      else
         call emit( inst_jmp_rel, location );
   end jump;




  /*                     EXPRESSIONS                                         */


condtoreg:
   procedure (mp, cc);
      declare (mp, cc, ncc, j) fixed;
      j = findac;
      ncc = (cc & "FE") | (~cc & "01");
      call emit( inst_setcc_r8, ncc, j );
      call emit( inst_movzx_r32_r8, j, j );
      ps_type(mp) = ACCUMULATOR;
      ps_reg(mp) = j;
      stillcond = cc;
   end condtoreg;



   /*                  CODE FOR PROCEDURES                                   */


save_registers:
   procedure;
      /* GENERATES CODE TO SAVE REGISTERS BEFORE A PROCEDURE OR
         FUNCTION CALL
      */
      declare i fixed;
      do i = 1 to 3;
         if bases(i) ~= AVAIL then
            do;
               call emitDataword(0);
               call findaddress(dp-4);
               temp(i) = shl(adreg,28)+ adrdisp;
               call emit( inst_mov_m32_r32, adreg,adrdisp, i );
            end;
         else
            temp(i) = 0;
      end;
   end  save_registers;


unsave_registers:
   procedure (r,p);
      /*  GENERATES CODE TO RESTORE REGISTERS AFTER A FUNCTION
          OR PROCEDURE CALL AND ALSO DOES SOME HOUSEKEEPING
      */
      declare (r, p, i, j) fixed;
      if bases(r) ~= AVAIL then
         do;
            j = findac;
            call emit( inst_mov_r32_r32, j, r );
         end;
      else
         j = r;
      do i = 1 to 3;
         if temp(i) ~= 0 then
            call emit( inst_mov_r32_m32, i, shr(temp(i),28),temp(i)&"FFFFFFF" );
      end;
      ps_type(p) = ACCUMULATOR;
      ps_reg(p) = j;
      bases(j) = ACCUMULATOR;
   end  unsave_registers;


io_savereg:
   procedure;
      declare i fixed;
      do i = 1 to 2;
         if bases(i) ~= AVAIL then
            call emit( inst_mov_m32_r32, DBR,io_save+shl(i-1,2), i );
      end;
   end  io_savereg  ;


io_unsavereg:
   procedure;
      declare i fixed;
      do i = 1 to 2;
         if bases(i) ~= AVAIL then
            call emit( inst_mov_r32_m32, i, DBR,io_save+shl(i-1,2) );
      end;
   end  io_unsavereg  ;


callsub:
   procedure (sd, r, p);
      declare (sd, r, p) fixed;
      call save_registers;
      call emit( inst_call_rel32, sd);
      call unsave_registers(r, p);
   end  callsub;


callsub_forward:
   procedure (sb,sd,r,p);
      declare (sb, sd, r, p, j) fixed;
      call save_registers;
      j = findac;
      call emit( inst_mov_r32_m32, j, sb,sd );
      call emit( inst_add_r32_r32, j, PBR );
      call emit( inst_call_r32, j );
      bases(j) = AVAIL;
      call unsave_registers(r, p);
   end  callsub_forward;



force_address:
   procedure (sp,r);
      /* GENERATES THE ADDRESS OF THE <VARIABLE> IN THE ANALYSIS
         STACK AT SP IN REGISTER R.
      */
      declare (sp, r, k, inxsp, disp, sb, sd) fixed;
      if syt_type(ps_fxloc(sp)) = LABELTYPE | syt_type(ps_fxloc(sp)) = CHAR_PROC_TYPE then
         do;
            k = ps_fxloc(sp);
            call emit( inst_lea_r32_m32, r, PBR,syt_disp(k) );
         end;
      else
         do;
            k = syt_type(ps_fxloc(sp));
            inxsp = ps_xreg(sp);
            if k = FORWARDTYPE | k = FORWARDCALL then
               do;
                  k = ps_fxloc(sp);
                  call emit( inst_mov_r32_m32, r, syt_base(k),syt_disp(k) );
                  call emit( inst_add_r32_r32, r, PBR );
               end;
            else
               do;
                  sb = syt_base(ps_fxloc(sp));
                  sd = syt_disp(ps_fxloc(sp));
                  disp = ps_fxval(sp);
                  if sb = 0 then
                     do;
                        if inxsp = 0 then
                           call emit( inst_mov_r32_imm32, r, sd );
                        else
                           do;
                              if inxsp = NOREG then
                                 /* Constant subscript */
                                 do;
                                    if k = BYTETYPE then
                                       call emit( inst_lea_r32_m32, r, NOREG,disp+sd );
                                    else if k = HALFWORD then
                                       call emit( inst_lea_r32_m32, r, NOREG,disp*2+sd );
                                    else
                                       call emit( inst_lea_r32_m32, r, NOREG,disp*4+sd );
                                 end;
                              else
                                 do;
                                    if k = BYTETYPE then
                                       call emit( inst_lea_r32_Xx1m32, r, inxsp, NOREG,sd );
                                    else if k = HALFWORD then
                                       call emit( inst_lea_r32_Xx2m32, r, inxsp, NOREG,sd );
                                    else
                                       call emit( inst_lea_r32_Xx4m32, r, inxsp, NOREG,sd );
                                    bases(inxsp) = AVAIL;
                                 end;
                           end;
                     end;
                  else
                     do;
                        if inxsp = 0 then
                           call emit( inst_lea_r32_m32, r, sb,sd );
                        else
                           do;
                              if inxsp = NOREG then
                                 /* Constant subscript */
                                 do;
                                    if k = BYTETYPE then
                                       call emit( inst_lea_r32_m32, r, sb,disp+sd );
                                    else if k = HALFWORD then
                                       call emit( inst_lea_r32_m32, r, sb,disp*2+sd );
                                    else
                                       call emit( inst_lea_r32_m32, r, sb,disp*4+sd );
                                 end;
                              else
                                 do;
                                    if k = BYTETYPE then
                                       call emit( inst_lea_r32_Xx1m32, r, inxsp, sb,sd );
                                    else if k = HALFWORD then
                                       call emit( inst_lea_r32_Xx2m32, r, inxsp, sb,sd );
                                    else
                                       call emit( inst_lea_r32_Xx4m32, r, inxsp, sb,sd );
                                    bases(inxsp) = AVAIL;
                                 end;
                           end;
                     end;
               end;
         end;
   end  force_address;


file_pseudo_array:
   procedure (varp,filep, direction);
      /* PROCEDURE TO GENERATE CODE FOR THE FILE PSEUDO ARRAY.
         TWO FORMS ARE HANDLED:

               <VARIABLE>  =  FILE(I,J);

               FILE(I,J)  =  <VARIABLE>;

         VARP IS A POINTER TO THE <VARIABLE> IN THE ANALYSIS STACKS.
         FILEP IS A POINTER TO THE ANALYSIS STACK WHERE FILE(I,J)
         HAS BEEN ASSIMILATED UNDER THE GUISE OF A SUBSCRIPTED
         VARIABLE.  DIRECTION = 0 FOR THE FIRST CASE (READ) AND
         DIRECTION = 4 FOR THE SECOND CASE (WRITE).  I IS THE FILE
         INDEX (I = 1,2,3) AND J IS THE RELATIVE RECORD WITHIN THE
         FILE.  THE GENERATED CODE SHOULD HAVE THE SAME EFFECT AS;

               lea   0,<VARIABLE>
               mov   1,I
               shl   1,3                 I*8
               lea   1,DIRECTION+44[1]
               mov   2,J
               call  XPL_TO_C

         REGISTERS 0-3 ARE NOT PRESERVED ACROSS THE MONITOR CALL,
         HENCE ALL REGISTERS ARE FREED,

      */
      declare (varp, direction, filep, r) fixed;
      if ps_type(varp) = VARIABLE then
         do;
            call force_address(varp,0);
            if ps_xreg(filep) ~= NOREG then
               do;
                  r = findac;
                  if ps_xreg(filep) = 1 then
                     do;                      /*  JUGGLE REGISTERS  */
                        call emit( inst_mov_r32_r32, r, 1 );
                        ps_xreg(filep) = r;
                     end;
               end;
            if ps_reg(filep) >= NOREG then
               call emit( inst_mov_r32_imm32, 1, shl((ps_reg(filep) - NOREG),3) + (44+direction) );
            else
               /* I*8 + (44+DIRECTION) */
               call emit( inst_lea_r32_Xx8m32, 1, ps_reg(filep), NOREG,44+direction);
            if ps_xreg(filep) ~= 2 then
               if ps_xreg(filep) = NOREG then
                  do;
                     if ps_pp(filep) = 0 then
                        call emit( inst_sub_r32_r32, 2, 2 );    /* J */
                     else
                        call emit( inst_mov_r32_imm32, 2, ps_pp(filep));    /* J */
                  end;
               else
                  call emit( inst_mov_r32_r32, 2, ps_xreg(filep));    /* J */
            call emit( inst_call_rel32, xpl_to_c );

            ps_type(filep) = SPECIAL;  /*  NO MORE ASSIGNMENTS  */
            call clearregs;            /*  FREE ALL REGISTERS  */
         end;
      else
         call error('Illegal use of FILE pseudo array',1);
   end  file_pseudo_array;


//
// For the iAPX486, INLINE() is called as follows:
//
//      INLINE( C1,C2,C3,C4  [, A1, ... ] )
//      INLINE( X );
//
// Cn can be either a numeric CONSTANT or a string CONSTANT having the
// appropriate values for a call to INST().  Arguments A1,... can be either
// numeric constants or variables.  The <VALUE> for INLINE is always
// ACCUMULATOR; argument A1 is taken to be the register value if it is a
// numeric CONSTANT, otherwise the register value is undefined.
//
// The second form is used to emit a single, arbitrary byte
//
emit_inline:
   procedure( done );
      declare done bit(8);

      /* GENERATES CODE FOR THE PSEUDO FUNCTION INLINE                */

      declare binlm character initial ('Bad argument to INLINE');
      declare t character;
      declare (i,j, code, na, fv,fl) fixed, a(4) fixed;
      declare suppress bit(8);
      declare ua1(17) character initial('ax' ,''  ,'',''   ,'ah','none','imm8',
                                        'imm32','r8','r16','r32','imm16','m8',
                                        'm16','m32','rel8','rel32','rel');
      declare ua2(15) character initial('eax','cl','','ebx',''  ,'none','imm8',
                                        'imm32','r8','r16','r32','imm16','m8',
                                        'm16','m32','one');
      declare ua3( 3) character initial(                    ''  ,'none','imm8','imm32');
      declare uax( 7) character initial('', '', '', '', 'Xx1|', 'Xx2|', 'Xx4|', 'Xx8|');

      if ps_cnt(mp) = 1 then
         do;
            suppress = FALSE;
            na = 0;
         end;
      if done & (1 < ps_cnt(mp) & ps_cnt(mp) < 4) then
         do;
            call error(binlm,1);
            goto ret;
         end;
      fv = ps_fxval(mpp1);
      fl = ps_fxloc(mpp1);
      if ps_cnt(mp) < 5 then
         do;
            if ps_type(mpp1) = CHRTYPE | ps_type(mpp1) = CONSTANT then
               do case ps_cnt(mp);

                  ;                             /* NO CASE 0 */

                  do;                           /* C1 */
                     ps_type(mp) = ACCUMULATOR; // Fake out type in case DONE
                     ps_reg(mp) = EAX;
                     if ps_type(mpp1) = CHRTYPE then
                        do;
                           if ~done then
                              // Find the code for the specified opcode
                              do i = 0 to NOPCODE;
                                 t = i486Opcodes(i);
                                 if t = 'j' | t = 'set' then
                                    t = t || 'cc';
                                 if t = ps_name(mpp1) then
                                    // We've got the opcode; now search the TEMPLATE array to
                                    // find the instruction code
                                    do j = 0 to NTEMPLATE;
                                       if byte(template(j),6) = i then
                                          do;
                                             code = shl( byte(template(j)) & "FE", 16);
                                             goto ret;
                                          end;
                                    end;
                              end;
                        end;
                     else if ps_type(mpp1) = CONSTANT then
                        do;
                           if done then
                              do;
                                 call emit1CodeByte( fv );
                                 goto ret;
                              end;
                           else
                              if 0 <= fv & fv <= NINST then
                                 do;
                                    code = shl(fv, 17);
                                    goto ret;
                                 end;
                        end;
                  end;

                  do;                           /* C2 */
                     if ps_type(mpp1) = CHRTYPE then
                        do;
                           if ps_name(mpp1) ~= '' then
                              do i = 0 to 17;
                                 if ua1(i) = ps_name(mpp1) then
                                    do;
                                       code = code | shl(i, 12);
                                       goto ret;
                                    end;
                                 if i = M8 | i = M32 then
                                    do j = 4 to 7;
                                       if (uax(j) || ua1(i)) = ps_name(mpp1) then
                                          do;
                                             code = code | shl(shl(i,3)+j, 9);
                                             goto ret;
                                          end;
                                    end;
                              end;
                        end;
                     else if ps_type(mpp1) = CONSTANT then
                        do;
                           if 0 <= fv & fv <= 15 then
                              do;
                                 code = code | shl(fv, 12);
                                 goto ret;
                              end;
                        end;
                  end;

                  do;                           /* C3 */
                     if ps_type(mpp1) = CHRTYPE then
                        do;
                           if ps_name(mpp1) ~= '' then
                              do i = 0 to 15;
                                 if ua2(i) = ps_name(mpp1) then
                                    do;
                                       code = code | shl(i, 5);
                                       goto ret;
                                    end;
                                 if i = M8 | i = M32 then
                                    do j = 4 to 7;
                                       if (uax(j) || ua2(i)) = ps_name(mpp1) then
                                          do;
                                             code = code | shl(shl(i,3)+j, 2);
                                             goto ret;
                                          end;
                                    end;
                              end;
                        end;
                     else if ps_type(mpp1) = CONSTANT then
                        do;
                           if 0 <= fv & fv <= 15 then
                              do;
                                 code = code | shl(fv, 5);
                                 goto ret;
                              end;
                        end;
                  end;

                  do;                           /* C4 */
                     if ps_type(mpp1) = CHRTYPE then
                        do;
                           if ps_name(mpp1) ~= '' then
                              do i = 0 to 3;
                                 if ua3(i) = ps_name(mpp1) then
                                    do;
                                       code = code | i;
                                       if done & ~suppress then
                                          do;
                                             if emit(FromINLINE | code) = 0 then
                                                goto ret;
                                          end;
                                       else
                                          goto ret;
                                    end;
                              end;
                        end;
                     else if ps_type(mpp1) = CONSTANT then
                        do;
                           if 5 <= fv & fv <= 7 then
                              do;
                                 code = code | (fv & "03");
                                 if done & ~suppress then
                                    do;
                                       if emit(FromINLINE | code) = 0 then
                                          goto ret;
                                    end;
                                 else
                                    goto ret;
                              end;
                        end;
                  end;
               end;
            suppress = TRUE;
            call error(binlm,1);
         end;
      //
      //    PS_Cnt(MP) is 5 or more
      //
      else if ps_type(mpp1) = CONSTANT then
         do;
            if na <= 4 then
               do;
                  if ps_cnt(mp) = 5 then
                     ps_reg(mp) = fv;
                  a(na) = fv;
                  na = na + 1;
                  if done & ~suppress then
                     do;
                        if emit(FromINLINE | code,a(0),a(1),a(2),a(3),a(4)) ~= 0 then
                           call error(binlm,1);
                     end;
               end;
            else
               do;
                  suppress = TRUE;
                  call error(binlm,1);
               end;
         end;
      else if ps_type(mpp1) = VARIABLE then
         do;
            if na <= 3 then
               do;
                  if syt_type(fl) = LABELTYPE then
                     a(na) =  PBR;
                  else
                     a(na) =  syt_base(fl);
                  a(na+1) = syt_disp(fl);
                  na = na + 2;
                  if done & ~suppress then
                     do;
                        if emit(FromINLINE | code,a(0),a(1),a(2),a(3),a(4)) ~= 0 then
                           call error(binlm,1);
                     end;
               end;
            else
               do;
                  suppress = TRUE;
                  call error(binlm,1);
               end;
         end;
      else
         do;
            suppress = TRUE;
            call error(binlm,1);
         end;

ret:
   end  emit_inline;




proc_start:
   procedure;
      /*  GENERATES CODE FOR THE HEAD OF A PROCEDURE */

      declare i fixed;
      i = ps_fxloc(mp);
      ps_fxloc(mp) = pp;
      call jump( -1 );    /*  BRANCH AROUND  */
      call emitDataword(0);  /*  PLACE TO STORE RETURN ADDRESS */
      ps_pp(mp) = rtnadr;
      rtnadr = dp - 4;
      call findaddress(rtnadr);
      do while (pp & "03") ~= 0;
         call emit( inst_nop );
      end;
      syt_base(i) = PBR;                   /* ADDRESS OF THE PROCEDURE  */
      syt_disp(i) = pp & "0FFFFFFF";
      call emit( inst_pop_m32, adreg,adrdisp );
   end  proc_start;


check_string_overflow:
   procedure;
      declare (i, br_save) fixed;
      call emit( inst_mov_r32_m32, EAX, DBR,tsa );
      call emit( inst_cmp_r32_m32, EAX, DBR,limitword );
      i = pp;
      call branch (CC_L, 0);
      if syt_type (string_recover) = LABELTYPE then
         call callsub(syt_disp(string_recover), 0, STACKSIZE);
      else
         call callsub_forward(syt_base(string_recover), syt_disp(string_recover), 0, STACKSIZE);
      bases(ps_reg(STACKSIZE)) = AVAIL;
      syt_count(string_recover) = syt_count(string_recover) + 1;
      call findaddress (strl);
      call emit( inst_mov_m32_imm32, adreg,adrdisp, 0 );
      call fixbfw (i, pp);
   end check_string_overflow;


forceaccumulator:
   procedure (p);
      declare (p, i) fixed;
      /* FORCE THE OPERAND AT P INTO AN ACCUMULATOR */
      declare (r, b, d, sb, sd, tp, sfp, disp) fixed, t1 character;
      count#force = count#force + 1;
      tp = ps_type(p);
      if tp = CONDITION then call condtoreg (p, ps_reg(p));
      else if tp = VARIABLE then
         do;
            sb = syt_base(ps_fxloc(p));
            sd = syt_disp(ps_fxloc(p));
            sfp = syt_type(ps_fxloc(p));
            if sfp = LABELTYPE | sfp = CHAR_PROC_TYPE then
               do;
                  call callsub(sd,3,p);
                  if length(syt_name(ps_fxloc(p)+ps_cnt(p)+1)) = 0 then
                     if control(byte('N')) then
                        output = '** Warning--Not all parameters supplied';
                  if sfp = CHAR_PROC_TYPE then
                     ps_type(p) = DESCRIPT;
               end;
            else if sfp = FORWARDTYPE | sfp = FORWARDCALL then
               do;
                  call callsub_forward(sb,sd,3,p);
                  syt_type(ps_fxloc(p)) = FORWARDCALL;
               end;
            else  if sfp = SPECIAL then
               do;
                  if sd = 6 then
                     do;  /*  INPUT */
                        call check_string_overflow;
                        if ps_reg(p) ~= NOREG then
                           bases(ps_reg(p)) = AVAIL;
                        call io_savereg;
                        if ps_reg(p) = 0 then   /* INPUT */
                           call emit( inst_sub_r32_r32, 2, 2 );
                        else
                           if ps_reg(p) ~= 2 then
                              if ps_reg(p) = NOREG then       /* INPUT(CONSTANT) */
                                 do;
                                    if ps_pp(p) = 0 then
                                       call emit( inst_sub_r32_r32, 2, 2 );
                                    else
                                       call emit( inst_mov_r32_imm32, 2, ps_pp(p) );
                                 end;
                              else
                                 call emit( inst_mov_r32_r32, 2, ps_reg(p) );
                        call findaddress (tsa);
                        /* THIS IS A POINTER TO THE FIRST FREE STRING AREA*/
                        call emit( inst_mov_r32_m32, 0, adreg,adrdisp );
                        call emit( inst_mov_r32_imm32, 1, 4); /* 4 IS READ CARD  */
                        call emit( inst_call_rel32, xpl_to_c );
                        /* MOVE FREE STRING AREA POINTER */
                        call emit( inst_mov_m32_r32, adreg,adrdisp, 1);
                        call findaddress (strl); /* LAST COMPUTED STRING */
                        call emit( inst_mov_m32_r32, adreg,adrdisp, 0);
                        call io_unsavereg;
                        ps_reg(p) = 0;
                        ps_type(p) = DESCRIPT;
                     end;
                  else if sd = 8 then
                     call file_pseudo_array(p-2,p,0);
                  else if sd >= 11 & sd <= 18 then
                     do;
                        /* TRACE, UNTRACE, EXIT, TIME, DATE, CLOCK_TRAP,
                           INTERRUPT_TRAP, MONITOR */
                        // Note that R is both a register number
                        // and a value to compute the service code
                        if sd = 15 then r = 1; else r = 0;
                        if sd > 15 then
                           do;  /* CLOCK_TRAP, INTERRUPT_TRAP, MONITOR */
                              bases(ps_reg(p)),bases(ps_xreg(p)) = AVAIL;
                              call io_savereg;
                              if ps_reg(p) ~= 0 then
                                 call emit( inst_mov_r32_r32, 0, ps_reg(p) );
                              if (ps_xreg(p) ~= 0) & (ps_xreg(p) ~= 2) then
                                 call emit( inst_mov_r32_r32, 2, ps_xreg(p) );
                           end;
                        else
                           call io_savereg;
                        /* SET UP MONITOR REQUEST CODE */
                        call emit( inst_mov_r32_imm32, 1, shl(sd-r,2)-32 );
                        /* MONITOR CALL */
                        call emit( inst_call_rel32, xpl_to_c );
                        ps_type(p) = ACCUMULATOR;
                        if r ~= 0 then
                           call emit( inst_mov_r32_r32, 0, r );
                        call io_unsavereg;
                        ps_reg(p) = 0;
                     end;
                  else call error (' Illegal use of ' || syt_name(ps_fxloc(p)));
               end;
            else
               do;  /* FETCH THE VARIABLE (ALL ELSE HAS FAILED) */
                  r = ps_xreg(p);
                  if sfp ~= BYTETYPE then
                     do;
                        if r ~= 0 then
                           do;
                              if r = NOREG then
                                 /* Constant subscript */
                                 do;
                                    r = findac;
                                    disp = ps_fxval(p);
                                    if sfp = HALFWORD then
                                       do;
                                          if sb = 0 then
                                             call emit( inst_mov_r16_m16, r, NOREG,disp*2+sd );
                                          else
                                             call emit( inst_mov_r16_m16, r, sb,disp*2+sd );
                                          call emit( inst_movsx_r32_r16, r, r );
                                       end;
                                    else
                                       if sb = 0 then
                                          call emit( inst_mov_r32_m32, r, NOREG,disp*4+sd );
                                       else
                                          call emit( inst_mov_r32_m32, r, sb,disp*4+sd );
                                 end;
                              else
                                 do;
                                    if sfp = HALFWORD then
                                       do;
                                          if sb = 0 then
                                             call emit( inst_mov_r16_Xx2m16, r, r, NOREG,sd );
                                          else
                                             call emit( inst_mov_r16_Xx2m16, r, r, sb,sd );
                                          call emit( inst_movsx_r32_r16, r, r );
                                       end;
                                    else
                                       if sb = 0 then
                                          call emit( inst_mov_r32_Xx4m32, r, r, NOREG,sd );
                                       else
                                          call emit( inst_mov_r32_Xx4m32, r, r, sb,sd );
                                 end;
                           end;
                        else
                           do;
                              r = findac;
                              if sfp = HALFWORD then
                                 do;
                                    call emit( inst_mov_r16_m16, r, sb,sd );
                                    call emit( inst_movsx_r32_r16, r, r );
                                 end;
                              else
                                 call emit( inst_mov_r32_m32, r, sb, sd );
                           end;
                     end;
                  else
                     do;
                        if r ~= 0 then
                           do;
                              if r = NOREG then
                                 /* Constant subscript */
                                 do;
                                    r = findac;
                                    disp = ps_fxval(p)+sd;
                                    if sb = 0 then
                                       call emit( inst_mov_r8_m8, r, NOREG,disp );
                                    else
                                       call emit( inst_mov_r8_m8, r, sb,disp );
                                 end;
                              else
                                 do;
                                    if sb = 0 then
                                       call emit( inst_mov_r8_m8, r, r,sd );
                                    else
                                       call emit( inst_mov_r8_Xx1m8, r, r, sb,sd );
                                 end;
                           end;
                        else
                           do;
                              r = findac;
                              call emit( inst_mov_r8_m8, r, sb,sd );
                           end;
                        call emit( inst_movzx_r32_r8, r, r );
                     end;
                  if sfp = CHRTYPE then ps_type(p) = DESCRIPT;
                  else ps_type(p) = ACCUMULATOR;
                  ps_reg(p) = r;
               end;
         end;
            else if tp = CONSTANT then
               do;
                  r = findac;
                  /* FETCH A CONSTANT INTO AN ACCUMULATOR */
                  if ps_fxval(p) = 0 then
                     call emit( inst_sub_r32_r32, r, r );
                  else
                     call emit( inst_mov_r32_imm32, r, ps_fxval(p) );
                  ps_type(p) = ACCUMULATOR;
                  ps_reg(p) = r;
               end;
            else if tp = CHRTYPE then
               do;
                  r = findac;
                  ps_type(p) = DESCRIPT;
                  ps_reg(p) = r;
                  t1 = ps_name(p);
                  sd = length(t1) - 1;
                  if sd < 0 then
                     call emit( inst_sub_r32_r32, r, r ); /* CLEAR REG R, NULL STRING */
                  else
                     do;
                        call findaddress (-dsp);
                        /* MAKE UP A DESCRIPTOR */
                        call emitDesc(shl(sd,24)+chp);
                        do i = 0 to sd;
                           call emitChar(byte(t1, i));
                        end;
                        call emit( inst_mov_r32_m32, r, adreg,adrdisp );
                     end;
               end;
            else if tp ~= ACCUMULATOR then if tp ~= DESCRIPT then
               call error ('FORCEACCUMULATOR failed ***', 1);
   end forceaccumulator;

forcedescript:
   procedure (p);
      /* GET A DESCRIPTOR FOR THE OPERAND P */
      declare p fixed;
      if ps_type(p) = CONSTANT then
         do;
            ps_name(p) = ps_fxval(p);
            ps_type(p) = CHRTYPE;
         end;
      call forceaccumulator (p);
      if ps_type(p) ~= DESCRIPT then
         do;
            /* STORE IN PARAMETER LOCATION FOR NUMBER-TO-DECIMAL-STRING */
            call emit( inst_mov_m32_r32, DBR,strn, ps_reg(p) );
            bases(ps_reg(p)) = AVAIL;
            call callsub(nmbrntry,3,p);
            ps_type(p) = DESCRIPT;
         end;
   end forcedescript;

stuff_parameter:
   procedure;
      /* GENERATES CODE TO SEND AN ACTUAL PARAMETER TO A PROCEDURE */
      declare (sb, sd, t, r, V) fixed;
      i = ps_fxloc(mp) + ps_cnt(mp);
      sb =  syt_base(i);
      sd =  syt_disp(i);
      V =  ps_fxval(mpp1);
      t = syt_type(i);
      if length(syt_name(i)) = 0 then
         do;
            if ps_type(mpp1) = CONSTANT then
               do;
                  if t = BYTETYPE then
                     call emit( inst_mov_m8_imm8, sb,sd, V );
                  else if t = HALFWORD then
                     call emit( inst_mov_m16_imm16, sb,sd, V );
                  else
                     call emit( inst_mov_m32_imm32, sb,sd, V );
               end;
            else
               do;
                  call forceaccumulator (mpp1);
                  r = ps_reg(mpp1);
                  if t = BYTETYPE then
                     call emit( inst_mov_m8_r8, sb,sd, r );
                  else if t = HALFWORD then
                     call emit( inst_mov_m16_r16, sb,sd, r );
                  else
                     call emit( inst_mov_m32_r32, sb,sd, r );
                  bases(r) = AVAIL;
               end;
         end;
      else
         call error('Too many actual parameters', 1);
   end  stuff_parameter;

genstore:
   procedure (mp, sp);
      declare (mp, sp, sfp, sb, sd, r, x, disp, fromop) fixed;
      count#store = count#store + 1;
      if ps_type(sp) = SPECIAL then return;
      /* GENERATE TYPE CONVERSION (IF NECESSARY) & STORAGE CODE --
            ALSO HANDLES OUTPUT AND FILE ON LEFT OF REPLACE OPERATOR */
      sb = syt_base(ps_fxloc(mp));
      sd = syt_disp(ps_fxloc(mp));
      sfp = syt_type(ps_fxloc(mp));
      if sfp = SPECIAL then
         do;
            if sd = 3 then      /*  FUNCTION "BYTE" ON THE LEFT */
               do;
                  if ps_type(mp) = CHRTYPE then
                     call error( 'Illegal use of BYTE', 1 );
                  else
                     do;
                        if ps_type(sp) = CONSTANT then
                           do;
                              r = ps_fxval(sp);
                              fromop = IMM8;
                           end;
                        else
                           do;
                              call forceaccumulator(sp);
                              r = ps_reg(sp);
                              fromop = R8;
                           end;
                        x =  ps_reg(mp);
                        call emit( inst_and_r32_imm32, x, "FFFFFF");
                        if ps_cnt(mp) = 1 then
                           call emit( inst(MOV,M8,fromop,NONE), x,0, r );
                        else
                           do;
                              if ps_xreg(mp) ~= 0 then
                                 call emit( inst(MOV,Xx1|M8,fromop,NONE), ps_xreg(mp), x,0, r );
                              else
                                 call emit( inst(MOV,M8,fromop,NONE), x,ps_pp(mp), r );
                           end;
                        bases(x) = AVAIL;
                     end;
               end;
            else if sd = 7 then
               do;      /* OUTPUT   */
                  target_register = 0;
                  call forcedescript (sp);
                  target_register = -1;
                  if ps_reg(mp) ~= NOREG then
                     bases(ps_reg(mp)) = AVAIL;
                  bases(ps_reg(sp)) = AVAIL;
                  call io_savereg;
                  if ps_reg(sp) ~= 0 then
                     call emit( inst_mov_r32_r32, 0, ps_reg(sp));
                  if ps_reg(mp) = 0 then        /* OUTPUT = ... */
                     call emit( inst_sub_r32_r32, 2, 2 );
                  else if ps_reg(mp) ~= 2 then
                     if ps_reg(mp) = NOREG then       /* OUTPUT(CONSTANT) = ... */
                        do;
                           if ps_pp(mp) = 0 then
                              call emit( inst_sub_r32_r32, 2, 2 );
                           else
                              call emit( inst_mov_r32_imm32, 2, ps_pp(mp));
                        end;
                     else
                        call emit( inst_mov_r32_r32, 2, ps_reg(mp));
                  call emit( inst_mov_r32_imm32, 1, 8); /* 8 = PRINT CODE */
                  call emit( inst_call_rel32, xpl_to_c );
                  call io_unsavereg;
               end;
            else if sd = 8 then
               call file_pseudo_array(sp,mp,4);
            else call error ('Illegal use of ' || syt_name(ps_fxloc(mp)));
         end;
      else
         do;
            if ps_type(sp) ~= CONSTANT |
               (sfp ~= CHRTYPE & ps_type(sp) = CONSTANT & ps_fxval(sp) = 0) then
               call forceaccumulator (sp);
            if ps_type(sp) ~= SPECIAL then
               do;
                  x = ps_xreg(mp);
                  if sfp = CHRTYPE then
                     do;
                        call forcedescript (sp);
                        r = ps_reg(sp);
                        fromop = R32;
                     end;
                  else
                     if ps_type(sp) = CONSTANT then
                        do;
                           r = ps_fxval(sp);
                           if sfp = FIXEDTYPE then
                              fromop = IMM32;
                           else if sfp = HALFWORD then
                              fromop = IMM16;
                           else if sfp = BYTETYPE then
                              fromop = IMM8;
                        end;
                     else
                        do;
                           r = ps_reg(sp);
                           if sfp = FIXEDTYPE then
                              fromop = R32;
                           else if sfp = HALFWORD then
                              fromop = R16;
                           else if sfp = BYTETYPE then
                              fromop = R8;
                        end;

                  if sfp=FIXEDTYPE & (ps_type(sp)=ACCUMULATOR | ps_type(sp)=CONSTANT) | sfp=CHRTYPE then
                     do;
                        if x ~= 0 then
                           do;
                              if x = NOREG then
                                 /* Constant subscript */
                                 do;
                                    disp = ps_fxval(mp)*4+sd;
                                    if sb = 0 then
                                       call emit( inst(MOV,M32,fromop,NONE), NOREG,disp, r );
                                    else
                                       call emit( inst(MOV,M32,fromop,NONE), sb,disp, r );
                                 end;
                              else
                                 do;
                                    if sb = 0 then
                                       call emit( inst(MOV,Xx4|M32,fromop,NONE), x, NOREG,sd, r );
                                    else
                                       call emit( inst(MOV,Xx4|M32,fromop,NONE), x, sb,sd, r );
                                 end;
                           end;
                        else
                           call emit( inst(MOV,M32,fromop,NONE), sb,sd, r );
                     end;
                  else if sfp = HALFWORD & (ps_type(sp) = ACCUMULATOR | ps_type(sp) = CONSTANT) then
                     do;
                        if x ~= 0 then
                           do;
                              if x = NOREG then
                                 /* Constant subscript */
                                 do;
                                    disp = ps_fxval(mp)*2+sd;
                                    if sb = 0 then
                                       call emit( inst(MOV,M16,fromop,NONE), NOREG,disp, r );
                                    else
                                       call emit( inst(MOV,M16,fromop,NONE), sb,disp, r );
                                 end;
                              else
                                 do;
                                    if sb = 0 then
                                       call emit( inst(MOV,Xx2|M16,fromop,NONE), x, NOREG,sd, r );
                                    else
                                       call emit( inst(MOV,Xx2|M16,fromop,NONE), x, sb,sd, r );
                                 end;
                           end;
                        else
                           call emit( inst(MOV,M16,fromop,NONE), sb,sd, r );
                     end;
                  else if sfp = BYTETYPE & (ps_type(sp) = ACCUMULATOR | ps_type(sp) = CONSTANT) then
                     do;
                        if x ~= 0 then
                           do;
                              if x = NOREG then
                                 /* Constant subscript */
                                 do;
                                    disp = ps_fxval(mp)+sd;
                                    if sb = 0 then
                                       call emit( inst(MOV,M8,fromop,NONE), NOREG,disp, r );
                                    else
                                       call emit( inst(MOV,M8,fromop,NONE), sb,disp, r );
                                 end;
                              else
                                 do;
                                    if sb = 0 then
                                       call emit( inst(MOV,M8,fromop,NONE), x,sd, r );
                                    else
                                       call emit( inst(MOV,Xx1|M8,fromop,NONE), x, sb,sd, r );
                                 end;
                           end;
                        else
                           call emit( inst(MOV,M8,fromop,NONE), sb,sd, r );
                     end;
                  else call error('Assignment needs illegal type conversion');
               end;
         end;
      if ps_xreg(mp) ~= NOREG then
         bases(ps_xreg(mp)) = AVAIL;
      if ps_type(sp) ~= CONSTANT & ps_reg(sp) < NOREG then
         bases(ps_reg(sp)) = AVAIL;
      call movestacks (sp, mp);
   end genstore;

stringcompare:
   procedure;
      /* GENERATES THE CODE TO COMPARE THE STRINGS AT SP & MP */
      declare (i, j, k, l, rsp, rmp) fixed;
      call forcedescript (sp);  /* GET THE DESCRIPTOR FOR THE SECOND OPERAND */
      rmp = ps_reg(mp);
      rsp = ps_reg(sp);
      i = 6 - rmp - rsp;  /* FIND THE THIRD REGISTER */
      call emit( inst_mov_r32_r32, 0, rmp ); /* WE CAN USE 0 FOR SCRATCH */
      call emit( inst_xor_r32_r32, 0, rsp ); /* XOR TO COMPARE */
      l = pp;
      call branch( CC_E, 0 );  /* TRUE IFF DESCRIPTORS ARE IDENTICAL */
      call emit( inst_shr_r32_imm8, 0, 24 ); /* CHECK HIGH ORDER 8 BITS FOR ZERO */
      if ps_reg(mpp1) = CC_E | ps_reg(mpp1) = CC_NE then
         do;          /* IF WE ONLY NEED TO TEST EQUALITY, CODE IS SIMPLER  */
            k = pp;
            call branch (CC_NE, 0);
         end;
      else
         do;
            j = pp;
            call branch (CC_E, 0);     /*  SKIP IF EQUAL LENGTH */
            call emit( inst_cmp_r32_r32, rmp, rsp); /* SET CONDITION CODE */
            k = pp;  /* SAVE FOR FIXUP */
            call jump (0);  /* BRANCH AROUND STRING COMPARE CODE */
            call fixbfw (j, pp);
         end;
      /* Lengths are equal for A relop B, one of the two strings is not '' */
      call emit( inst_mov_m32_r32, DBR,cmps1, rmp );
      call emit( inst_mov_m32_r32, DBR,cmps2, rsp );
      call emit( inst_call_rel32, cmpsntry );
      bases(rsp) = AVAIL;
      call fixbfw (k, pp);  /* BRING OTHER BRANCH IN HERE */
      call fixbfw (l, pp);  /* BRING OTHER BRANCH IN HERE */
   end stringcompare;

shouldcommute:
   procedure bit(1);
      if ps_type(sp) = VARIABLE then
         if syt_type(ps_fxloc(sp)) = FIXEDTYPE then return FALSE;
      if ps_type(mp) = CONSTANT then return TRUE;
      if ps_type(mp) = VARIABLE then
         if syt_type(ps_fxloc(mp)) = FIXEDTYPE then return TRUE;
      return FALSE;
   end;

arithemit:
   procedure (op);
      /* EMIT AN INSTRUCTION FOR AN INFIX OPERATOR -- CONNECTS MP & SP */

      declare (op, tp, t1, r, xreg, breg, disp) fixed;
      count#arith = count#arith + 1;
      if op ~= CMP & (ps_type(sp) = CONSTANT & ps_type(mp) = CONSTANT) then
         do;
            tp = ps_fxval(mp);
            t1 = ps_fxval(sp);
            if op = ADD then
               ps_fxval(mp) = tp + t1;
            else if op = SUB then
               ps_fxval(mp) = tp - t1;
            else if op = IMUL then
               ps_fxval(mp) = tp * t1;
            else if op = OR then
               ps_fxval(mp) = tp | t1;
            else if op = AND then
               ps_fxval(mp) = tp & t1;
            else
               call error('ARITHEMIT called with unknown OP: ' || op, 1);
            return;
         end;
      tp = 0;  /* REMEMBER IF COMMUTED */
      if commutative(op) & ps_type(sp) ~= CONSTANT then
         if shouldcommute then
            do;
               tp = mp; mp = sp; sp = tp;
            end;
      call forceaccumulator (mp);  /* GET THE LEFT ONE INTO AN ACCUMULATOR */
      /* PS_FXloc(sp) IS GARBAGE IF TYPE ~= VARIABLE */
      t1 = "0";
      if ps_type(sp) = VARIABLE then
         if syt_type(ps_fxloc(sp)) = FIXEDTYPE then
            t1 = "1";
      if ps_type(mp) = DESCRIPT then
         do;
            if op = CMP then call stringcompare;
            else call error ('Arithmetic with a string descriptor');
         end;
      else if t1 then
            do;  /* OPERATE DIRECTLY FROM STORAGE  */
               xreg = ps_xreg(sp);
               breg = syt_base(ps_fxloc(sp));
               disp = syt_disp(ps_fxloc(sp));
               r = ps_reg(mp);
               if xreg ~= 0 then
                  /* SHIFT TO WORD INDEXING */
                  do;
                     if xreg = NOREG then
                        /* Constant subscript */
                        do;
                           disp = disp + ps_fxval(sp)*4;
                           if op = IDIV then
                              do;
                                 if breg ~= 0 then
                                    call emit( inst_idiv_eax_m32, breg,disp );
                                 else
                                    call emit( inst_idiv_eax_m32, NOREG,disp );
                              end;
                           else
                              do;
                                 if breg ~= 0 then
                                    call emit( inst(op,R32,M32,NONE), r, breg,disp );
                                 else
                                    call emit( inst(op,R32,M32,NONE), r, NOREG,disp );
                              end;
                        end;
                     else
                        do;
                           if op = IDIV then
                              do;
                                 if breg ~= 0 then
                                    call emit( inst_idiv_eax_Xx4m32, xreg, breg,disp );
                                 else
                                    call emit( inst_idiv_eax_Xx4m32, xreg, NOREG,disp );
                              end;
                           else
                              do;
                                 if breg ~= 0 then
                                    call emit( inst(op,R32,Xx4|M32,NONE), r, xreg, breg,disp );
                                 else
                                    call emit( inst(op,R32,Xx4|M32,NONE), r, xreg, NOREG,disp );
                              end;
                        end;
                  end;
               else
                  if op = IDIV then
                     call emit( inst_idiv_eax_m32, breg,disp );
                  else
                     call emit( inst(op,R32,M32,NONE), r, breg,disp );
               if xreg ~= NOREG then
                  bases(xreg) = AVAIL;
            end;
      else if ps_type(sp) = CONSTANT then
            do;
               t1 = ps_fxval(sp);
               r = ps_reg(mp);
               if op = IDIV then
                  do;
                     call emitConstant( t1 );
                     call emit( inst_idiv_eax_m32, adreg, adrdisp );
                  end;
               else
                  do;
                     if op = ADD & t1 = 1 then
                        call emit( inst_inc_r32, r );
                     else
                        if op = SUB & t1 = 1 then
                           call emit( inst_dec_r32, r );
                        else
                           if op = CMP & t1 = 0 then
                              call emit( inst_or_r32_r32, r, r );
                           else
                              call emit( inst(op,R32,IMM32,NONE), r, t1 );
                  end;
            end;
      else
            do;
               call forceaccumulator (sp);
               if ps_type(sp) ~= ACCUMULATOR then
                  call error ('Arithmetic between string descriptors', 1);
               r = ps_reg(sp);
               if op = IDIV then
                     call emit( inst_idiv_eax_r32, r );
               else
                     call emit( inst(op,R32,R32,NONE), ps_reg(mp), r );
               bases(r) = AVAIL;
            end;
      if tp ~= 0 then
         do;  /* COMMUTED */
            sp = mp;  mp = tp;
            call movestacks (sp, mp);
         end;
         /* BY THE ALGORITHM, TYPE(MP) IS ALREADY ACCUMULATOR */
   end arithemit;

boolbranch:
   procedure (sp, mp);
      declare (sp, mp, t1, x, sb, sd, disp) fixed;
      t1 = "0";
      if ps_type(sp) = VARIABLE then
         if syt_type(ps_fxloc(sp)) = BYTETYPE then
            t1 = "1";
      /* GENERATE A CONDITIONAL BRANCH FOR A DO WHILE OR AN IF STATEMENT */
      if stillcond ~= 0 then
         do;
            bases(ps_reg(sp)) = AVAIL;
            pp = pp - 3 - 3;
            /* The amount to backup depends on what instructions CONDTOREG()
               generates */
            if control(byte('E')) then
                  output = x70 || '               Back up code emitter';
            instruct(SETCC) = instruct(SETCC) - 1;  /* KEEP STATISTICS ACCURATE */
            instruct(MOVZX) = instruct(MOVZX) - 1;
            ps_reg(sp) = stillcond;
         end;
      else if t1 then
         do;
            sb = syt_base(ps_fxloc(sp));
            sd = syt_disp(ps_fxloc(sp));
            x = ps_xreg(sp);
            if x ~= 0 then
               do;
                  if x = NOREG then
                     /* Constant subscript */
                     do;
                        disp = ps_fxval(sp) + sd;
                        if sb ~= 0 then
                           call emit( inst_bt_m32_imm8, sb,disp, 0 );
                        else
                           call emit( inst_bt_m32_imm8, NOREG,disp, 0 );
                     end;
                  else
                     do;
                        if sb ~= 0 then
                           call emit( inst_bt_Xx1m32_imm8, x, sb,sd, 0 );
                        else
                           call emit( inst_bt_m32_imm8, x,sd, 0 );
                        bases(x) = AVAIL;
                     end;
               end;
            else
               call emit( inst_bt_m32_imm8, sb,sd, 0 );
            ps_reg(sp) = CC_NC;
         end;
      else if ps_type(sp) = CONSTANT then
         do;
            if ps_fxval(sp) then
               do;
                  ps_fxloc(mp) = 0;
                  return;
               end;
            else ps_reg(sp) = 99;  /* unconditional jump */
         end;
      else if ps_type(sp) ~= CONDITION then
         do;
            target_register = EAX;
            call forceaccumulator (sp);
            target_register = -1;
            call emit( inst_and_r32_imm8, ps_reg(sp), 1 ); /* TEST LS BIT */
            bases(ps_reg(sp)) = AVAIL;
            ps_reg(sp) = CC_E;
         end;
      ps_fxloc(mp) = pp;  /* SAVE ADDRESS FOR FUTURE FIXUP */
      if ps_reg(sp) = 99 then
         call jump( -1 );
      else
         call branch(ps_reg(sp), -1 ); /* PS_Reg(SP) HAS THE CC TO BE TESTED */
   end boolbranch;


set_limit:
   procedure;
      /*  SETS DO LOOP LIMIT FOR <ITERATION CONTROL>   */
      if ps_type(mpp1) = CONSTANT then
         do;
            ps_type(mp) = CONSTANT;
            ps_fxval(mp) = ps_fxval(mpp1);
         end;
      else
         do;
            call forceaccumulator(mpp1);
            call emitDataword(0);
            call findaddress(dp-4);
            call emit( inst_mov_m32_r32, adreg,adrdisp, ps_reg(mpp1) );
            bases(ps_reg(mpp1)) = AVAIL;
            ps_type(mp) = VARIABLE;
            ps_xreg(mp) = adreg;
            ps_fxval(mp) = adrdisp;
         end;
   end  set_limit;


//
// Shuffle the registers until a divide can be done; OP = 1 for divide, 0 for MOD
//
divide_code:
   procedure( op );
      /*  GENERATES THE CODE FOR DIVISION  */
      declare (op, i) fixed;

      target_register = EAX;
      call forceaccumulator(mp);
      target_register = -1;
      if ps_reg(mp) ~= EAX then
         do;
            call emit( inst_mov_r32_r32, EAX, ps_reg(mp));
            bases(ps_reg(mp)) = AVAIL;
            ps_reg(mp) = EAX;
         end;
      if bases(EDX) ~= AVAIL then
         do;
            if ps_type(sp) = ACCUMULATOR & ps_reg(sp) = EDX then
               do;
                  i = findac;
                  if i ~= 0 then
                     do;
                        call emit( inst_mov_r32_r32, i, EDX );
                        bases(EDX) = AVAIL;
                        ps_reg(sp) = i;
                     end;
               end;
         end;
      i = 0;
      if bases(EDX) ~= AVAIL then
         do;
            i = findac;
            if i ~= 0 then
               do;
                  call emit( inst_mov_r32_r32, i, EDX );
                  bases(EDX) = AVAIL;
               end;
         end;
      if bases(EDX) = AVAIL then
         do;
            /*  MUST "SMEAR"  THE SIGN  */
            call emit( inst_cdq );
            bases(EDX) = ACCUMULATOR;
            call arithemit(IDIV);       /* RESULT: quotient=EAX, remainder=EDX */
            if i = 0 then
               do;
                  ps_reg(mp) = EDX;
                  if op = 1 then   /* divide */
                     call emit( inst_mov_r32_r32, EDX, EAX );
               end;
            else
               do;
                  ps_reg(mp) = i;
                  if op = 1 then   /* divide */
                     do;
                        call emit( inst_mov_r32_r32, EDX, i );
                        call emit( inst_mov_r32_r32, i, EAX );
                     end;
                  else             /* MOD */
                     call emit( inst_xchg_r32_r32, i, EDX );
               end;
         end;
      else
         call error('Division or MOD requires busy register',1);

   end  divide_code;


shift_code:
   procedure (op);
      /*  GENERATES CODE FOR THE BUILT IN FUNCTIONS  SHL  AND  SHR  */
      declare op fixed;
      if ps_cnt(mp) ~= 2 then
         call error('Shift requires two arguments');
      else if ps_type(mpp1) = CONSTANT then
         do;
            if ps_type(mp) = CONSTANT then
               do;
                  if op = SLL then
                     ps_fxval(mp) = shl( ps_pp(mp), ps_fxval(mpp1) );
                  else if op = SRL then
                     ps_fxval(mp) = shr( ps_pp(mp), ps_fxval(mpp1) );
                  else
                     call error('SHIFT_CODE called with unknown OP: ' || op, 1);
               end;
            else
               do;
                  if ps_fxval(mpp1) = 1 then
                     call emit( inst(op,R32,ONE,NONE), ps_reg(mp) );
                  else
                     call emit( inst(op,R32,IMM8,NONE), ps_reg(mp), ps_fxval(mpp1) );
                  ps_type(mp) = ACCUMULATOR;
               end;
         end;
      else
         do;
            target_register = ECX;
            call forceaccumulator(mpp1);
            target_register = -1;
            if ps_reg(mpp1) = ECX then
               do;
                  if ps_type(mp) = CONSTANT then
                     do;
                        ps_reg(mp) = findac;
                        ps_type(mp) = ACCUMULATOR;
                        call emit( inst_mov_r32_imm32, ps_reg(mp), ps_pp(mp) );
                     end;
                  call emit( inst(op,R32,CL,NONE), ps_reg(mp) );
               end;
            else
               if bases(ECX) = AVAIL then
                  do;
                     bases(ECX) = ACCUMULATOR;
                     call emit( inst_mov_r32_r32, ECX, ps_reg(mpp1) );
                     bases(ps_reg(mpp1)) = AVAIL;
                     if ps_type(mp) = CONSTANT then
                        do;
                           ps_reg(mp) = findac;
                           ps_type(mp) = ACCUMULATOR;
                           call emit( inst_mov_r32_imm32, ps_reg(mp), ps_pp(mp) );
                        end;
                     call emit( inst(op,R32,CL,NONE), ps_reg(mp) );
                     bases(ECX) = AVAIL;
                  end;
               else
                  call error('Shift requires busy register',1);

            bases(ps_reg(mpp1)) = AVAIL;
            ps_type(mp) = ACCUMULATOR;
         end;
   end  shift_code;



  /*                    BUILT-IN FUNCTIONS                              */


//
// Generate initial code to initialize the run time environment.
// The XPL program is called from C with:
//
//      (*xpl)( (void(*entry)()), (void*)codebase,
//                                (void*)database,
//                                (void*)datalength,
//                                (xplstring_t)parmstring );
//
register_setup_code:
   procedure;
      if control(byte('E')) then
         output = x70 || hex(pp) || instq || 'enter:';
      i = pp;
      call jump( 0 );           // Initial entry; skip over support routines

      pp = i + 4;    /* Submonitor and XCOM must agreee on this value! */
      if control(byte('E')) then
         output = x70 || hex(pp) || instq || 'enter+4:';
      k = pp;
      call jump( 0 );           // Resume from trace; skip over support routines

      //
      // Final return to the submonitor
      //
      pp = k + 4;
      j = pp;
      if control(byte('E')) then
         output = x70 || hex(pp) || instq || '[RTNADR]:';
      call emit( inst_mov_r32_r32, EAX, EBX );
      call emit( inst_pop_r32, EBP );
      call emit( inst_ret );

      // XPL to C interface
      //
      // The submonitor is effectively called with:
      //
      //    (*entry)( &svparms, XPL-return-address );
      //
      do while (pp & "03") ~= 0;
         call emit( inst_nop );
      end;

      xplsm = dp;  dp = dp + 4;

      if control(byte('E')) then
         output = x70 || hex(pp) || instq || 'XPL_TO_C:';
      xpl_to_c = pp;
      call emit( inst_mov_m32_r32, DBR,dp, 0 );
      call emit( inst_mov_m32_r32, DBR,dp+4, 1 );
      call emit( inst_mov_m32_r32, DBR,dp+8, 2 );
      call emit( inst_lea_r32_m32, EAX, DBR,dp );
      call emit( inst_push_r32, EAX );
      call emit( inst_call_m32, DBR,xplsm );
      call emit( inst_add_r32_imm32, ESP, 4 );
      call emit( inst_mov_r32_m32, 0, DBR,dp );
      call emit( inst_mov_r32_m32, 1, DBR,dp+4 );
      call emit( inst_mov_r32_m32, 2, DBR,dp+8 );
      call emit( inst_ret );
      dp = dp + 12;

      //
      // Resume point when XPL program calls UNTRACE if tracing was enabled at initial entry
      // Called with:
      //
      //        (*resume)( EBP, EDI, ESI, resume-address );
      //
      do while (pp & "03") ~= 0;
         call emit( inst_nop );
      end;

      call fixbfw( k, pp );

      if control(byte('E')) then
         output = x70 || hex(pp) || instq || 'resume:';
      call emit( inst_push_r32, EBP );
      call emit( inst_mov_r32_r32, EBP, ESP );
      call emit( inst_mov_r32_m32, EAX, EBP,20 );
      call emit( inst_mov_r32_m32, SBR, EBP,16 );
      call emit( inst_mov_r32_m32, DBR, EBP,12 );
      call emit( inst_mov_r32_m32, PBR, EBP,8 );
      call emit( inst_lea_r32_m32, EBX, PBR,j );   // Store return address
      call emit( inst_mov_m32_r32, DBR,rtnadr, EBX );

      call emit( inst_xchg_r32_r32, SBR, EAX ); // save resume address

      /* Tell the submonitor what the final value for %ESP, DBR and SBR are */
      call emit( inst_mov_r32_r32, 2, EAX ); // SBR
      call emit( inst_mov_r32_r32, 0, DBR );
      call emit( inst_mov_r32_imm32,  1, 0 );
      call emit( inst_call_rel32,  xpl_to_c );

      call emit( inst_mov_r32_r32, EAX, SBR ); // restore resume address
      call emit( inst_mov_r32_r32, SBR, 2 );
      call emit( inst_jmp_r32, EAX );

      //
      // Start
      //
      call fixbfw( i, pp );

      if control(byte('E')) then
         output = x70 || hex(pp) || instq || 'start:';
      call emit( inst_push_r32, EBP );
      call emit( inst_mov_r32_r32, EBP, ESP );
      call emit( inst_mov_r32_m32, DBR, EBP,16 );  // DATABASE
      call emit( inst_mov_r32_m32, EBX, EBP,20 );
      call emit( inst_add_r32_r32, EBX, DBR );     // TOPLIMIT
      call emit( inst_mov_r32_m32, ECX, EBP,24 );  // PARMSTRING
      call emit( inst_mov_r32_m32, EAX, EBP,8 );   // ENTRY
      call emit( inst_mov_m32_r32, DBR,xplsm, EAX );
      call emit( inst_mov_r32_m32, PBR, EBP,12 );  // CODEBASE
      // Initialization complete

      call emit( inst_lea_r32_m32, EAX, PBR,j );   // Store return address
      call emit( inst_mov_m32_r32, DBR,rtnadr, EAX );

      call emit( inst_sub_r32_imm32, EBX, 256 );
      limitword = dp;
      call emit( inst_mov_m32_r32, DBR,dp, EBX );
      call enter ('FREELIMIT', FIXEDTYPE, dp, 0);
      call enter ('freelimit', FIXEDTYPE, dp, 0);
      dp = dp + 4;
      call emit( inst_mov_m32_r32, DBR,dp, ECX );
      call enter('PARMSTRING', CHRTYPE, dp, 0);
      call enter('parmstring', CHRTYPE, dp, 0);
      dp = dp + 4;
      basedata = dp;   /* FOUR OFFSETS: (0) = descriptors */
                       /*               (1) = top of descriptors */
                       /*               (2) = top of strings */
                       /*               (3) = scratch */
      dp = dp+16;
   end register_setup_code;

//
// Emit code to relocate descriptors to absolute addresses.  This routine
// immediately follows REGISTER_SETUP_CODE
//
relocate_descriptors_code:
   procedure;

      if control(byte('E')) then
         output = x70 || hex(pp) || instq || 'RELOCATE_DESCRIPTORS_CODE:';

      call emit( inst_mov_r32_m32, EAX, DBR,basedata+8 );
      call emit( inst_add_r32_r32, EAX, DBR );
      call emit( inst_mov_m32_r32, DBR,tsa, EAX );
      call emit( inst_mov_m32_r32, DBR,dp, EAX );
      call enter('FREEBASE', FIXEDTYPE, dp, 0);
      call enter('freebase', FIXEDTYPE, dp, 0);
      dp = dp + 4;
      call emit( inst_bts_m32_imm8, DBR,basedata+12, 0 );
      k = pp;
      call branch(CC_C, 0);
      call emit( inst_mov_r32_m32, EAX, DBR,basedata );
      call emit( inst_lea_r32_Xx1m32, SBR, EAX, DBR,0 );
      call emit( inst_mov_r32_m32, EBX, DBR,basedata+4 );
      call emit( inst_add_r32_r32, EBX, DBR );

/* LOOP: */
      j = pp;                         /* SAVE DESTINATION FOR LOOP */
      call emit( inst_mov_r32_Xx1m32, EDX, EAX, DBR,0 );
      call emit( inst_or_r32_r32, EDX, EDX );
      i = pp;
      call branch(CC_E, 0);           /* ESCAPE */

      call emit( inst_add_r32_r32, EDX, EBX );
      call emit( inst_mov_Xx1m32_r32, EAX, DBR,0, EDX );

      call fixbfw( i, pp );
      call emit( inst_add_eax_imm32, 4 );
      call emit( inst_cmp_r32_m32, EAX, DBR,basedata+4 );
      call branch(CC_L, j );          /* LOOP */

      call fixbfw( k, pp );
      /* Tell the submonitor what the final values for DBR and SBR are */
      call emit( inst_mov_r32_r32, 0, DBR );
      call emit( inst_mov_r32_r32, 2, SBR );
      call emit( inst_mov_r32_imm32,  1, 0 );
      call emit( inst_call_rel32,  xpl_to_c );

      l = pp;           /* Remember JUMP for fixup at end of CONVERT_CODE() */
      call jump( -1 );  /* Jump to first compiled code */
   end relocate_descriptors_code;

catenate_code:
   procedure;
      /* BUILD A CATENATE SUBROUTINE  */

      do while (pp & "03") ~= 0;
         call emit( inst_nop );
      end;

      if control(byte('E')) then
         output = x70 || hex(pp) || instq || 'CATENTRY:';

      catentry = pp;
      call check_string_overflow;

      call emit( inst_mov_r32_m32, EDX, SBR,a2 );       // Load 1st descriptor
      call emit( inst_mov_r32_r32, EBX, EDX );          // Copy 1st descriptor
      call emit( inst_mov_r32_m32, EAX, SBR,b2 );       // Load 2nd descriptor
      call emit( inst_add_r32_r32, EBX, EAX );          // Add 2nd descriptor to copy of 1st
      call emit( inst_or_r32_r32, EDX, EDX );           // If 1st descriptor was ''; return 2nd descriptor
      t1 = pp;
      call branch( CC_E, 0 );

      /* If sum of 1st and 2nd descriptors EQ 1st descriptor, then 2nd */
      /*   descriptor is ''; return 1st descriptor */
      call emit( inst_cmp_r32_r32, EBX, EDX );
      t2 = pp;
      call branch( CC_E, 0 );

      call emit( inst_push_r32, ESI );
      call emit( inst_push_r32, EDI );
      call emit( inst_cld );
      call emit( inst_and_r32_imm32, EBX, "FF000000" ); // Isolate and compute final length
      call emit( inst_add_r32_imm32, EBX, "01000000" );

      call findaddress( strl );
      call emit( inst_cmp_r32_m32, EDX, adreg,adrdisp );// Was it the last string made?
      call emit( inst_mov_r32_r32, ESI, EDX );          //  (Load 1st descriptor; destroys SBR)
      call findaddress( tsa );
      call emit( inst_mov_r32_m32, EDI, adreg,adrdisp );//  (Load target address in case it's needed; destroys DBR)
      i = pp;
      call branch( CC_NE, 0 );                          // No, complete new string must be built

      /* Yes, just append 2nd string to 1st */
      call emit( inst_and_r32_imm32, ESI, "00FFFFFF" ); // Get address of 1st string

      call emit( inst_or_r32_r32, EBX, ESI );           // Complete final result descriptor
      j = pp;
      call jump( 0 );

      call fixbfw( i, pp );
      call emit( inst_and_r32_imm32, ESI, "00FFFFFF" ); // Get address of 1st string

      call emit( inst_or_r32_r32, EBX, EDI );           // Complete final result descriptor

      call emit( inst_mov_r32_r32, ECX, EDX );          // Extract and compute actual length of 1st string
      call emit( inst_shr_r32_imm8, ECX,24 );
      call emit( inst_inc_r32, ECX );

      call emit( inst_rep );                            // Move 1st string to final result
      call emit( inst_movsb );

      call fixbfw( j, pp );
      call emit( inst_mov_r32_r32, ESI, EAX );          // Get address of 2nd string
      call emit( inst_and_r32_imm32, ESI, "00FFFFFF" );

      call emit( inst_mov_r32_r32, ECX, EAX );          // Extract and compute actual length of 2nd string
      call emit( inst_shr_r32_imm8, ECX,24 );
      call emit( inst_inc_r32, ECX );

      call emit( inst_rep );                            // Move 2nd string to final result
      call emit( inst_movsb );

      call emit( inst_pop_r32, ECX );                   // Retrieve DBR for addressability
      call emit( inst_mov_m32_r32, ECX,adrdisp, EDI );  // Store new TSA
      call emit( inst_mov_r32_r32, EDI, ECX );          // Restore DBR
      call emit( inst_pop_r32, ESI );                   // Restore SBR
      call findaddress( strl );
      call emit( inst_mov_m32_r32, adreg,adrdisp, EBX );// Save latest string made

      call fixbfw( t1, pp );
      call fixbfw( t2, pp );
      call emit( inst_ret );

   end catenate_code;

compare_code:
   procedure;
      /*  THE STRING-TO-STRING COMPARISON SUBROUTINE */

      do while (pp & "03") ~= 0;
         call emit( inst_nop );
      end;

      if control(byte('E')) then
         output = x70 || hex(pp) || instq || 'COMPARE_CODE:';

      /*
       *  This subroutine is only called for strings whose lengths are
       *  unequal.  One, but not both, of the strings could be ''; the empty
       *  string should have been caught during the length compare, but due
       *  to the implementation of XPL string descriptors, a string of length
       *  one will appear to have the same length as the empty string.  Since
       *  XPL compares strings first by length, the empty string should compare
       *  lower than any other string, and any other string should compare
       *  higher than the empty string.
       */
      cmpsntry = pp;
      call emit( inst_push_r32, EAX );
      call emit( inst_push_r32, ECX );
      call emit( inst_push_r32, ESI );
      call emit( inst_push_r32, EDI );
      call emit( inst_sub_r32_r32, EAX, EAX );
      call emit( inst_mov_r32_m32, ESI, DBR,cmps1 );
      call emit( inst_or_r32_r32, ESI, ESI );  // Is first string the null string?
      i = pp;
      call branch( CC_NE, 0 );                 // No
      call emit( inst_cmp_r32_imm8, EAX, 1 );  // Yes, set CONDITION codes to LOW
      j = pp;
      call jump( 0 );

      call fixbfw( i, pp );
      call emit( inst_mov_r32_m32, EDI, DBR,cmps2 );
      call emit( inst_or_r32_r32, EDI, EDI );  // Is second string the null string?
      i = pp;
      call branch( CC_NE, 0 );                 // No
      call emit( inst_cmp_r32_imm8, EAX, -1 ); // Yes, set CONDITION codes to HIGH
      k = pp;
      call jump( 0 );

      call fixbfw( i, pp );
      call emit( inst_mov_r32_r32, ECX, EDI ); // Get true length of strings
      call emit( inst_shr_r32_imm8, ECX, 24 );
      call emit( inst_inc_r32, ECX );

      call emit( inst_and_r32_imm32, ESI, "00FFFFFF" ); // Isolate string addresses
      call emit( inst_and_r32_imm32, EDI, "00FFFFFF" );

      call emit( inst_cld );                   // Compare
      call emit( inst_rep );
      call emit( inst_cmpsb );

      call fixbfw( j, pp );
      call fixbfw( k, pp );
      call emit( inst_pop_r32, EDI );
      call emit( inst_pop_r32, ESI );
      call emit( inst_pop_r32, ECX );
      call emit( inst_pop_r32, EAX );
      call emit( inst_ret );

   end compare_code;

convert_code:
   procedure;
      /*  THE NUMBER-TO-STRING CONVERSION SUBROUTINE */

      do while (pp & "03") ~= 0;
         call emit( inst_nop );
      end;

      if control(byte('E')) then
         output = x70 || hex(pp) || instq || 'CONVERT_CODE:';

      nmbrntry = pp;
      call check_string_overflow;         /* CALL COMPACTIFY */

      call emit( inst_mov_r32_m32, EAX, DBR,strn );
      call emit( inst_or_r32_r32, EAX, EAX );
      i = pp;
      call branch( CC_GE, 0 );
      call emit( inst_neg_r32, EAX );

      call fixbfw( i, pp );
      call emit( inst_mov_r32_m32, ECX, DBR,tsa );
      call emit( inst_add_r32_imm8, ECX, 11 );
      call emit( inst_mov_m32_r32, DBR,tsa, ECX );

      call emit( inst_mov_r32_imm32, EBX, 10 );

      i = pp;
      call emit( inst_dec_r32, ECX );
      call emit( inst_cdq );
      call emit( inst_idiv_eax_r32, EBX );
      call emit( inst_or_r8_imm8, DL, byte('0') );
      call emit( inst_mov_m8_r8, ECX,0, DL );
      call emit( inst_or_r32_r32, EAX, EAX );
      call branch( CC_NE, i );

      call emit( inst_bt_m32_imm8, DBR,strn, 31 );
      i = pp;
      call branch( CC_NC, 0 );
      call emit( inst_dec_r32, ECX );
      call emit( inst_mov_m8_imm8, ECX,0, byte('-') );

      call fixbfw( i, pp );
      call emit( inst_mov_r32_m32, EBX, DBR,tsa );
      call emit( inst_sub_r32_r32, EBX, ECX );
      call emit( inst_dec_r32, EBX );
      call emit( inst_shl_r32_imm8, EBX, 24 );
      call emit( inst_or_r32_r32, EBX, ECX );
      call findaddress(strl); /* UPDATE POINTER TO NEWEST STRING */
      call emit( inst_mov_m32_r32, adreg,adrdisp, EBX );
      call emit( inst_ret );

      // FIXUP JMP to first compiled code from RELOCATE_DESCRIPTORS_CODE
      call fixbfw (l, pp);
   end convert_code;


  /*                       TIME AND DATE                                 */


print_time:
   procedure (message, t, raw);
      declare (message, ampm) character, (h, t, raw) fixed;
      if raw then
         do;
            output = message || iFormat(t/360000,2,byte('0')) || colon ||
                                iFormat(t mod 360000/6000,2,byte('0')) || colon ||
                                iFormat(t mod 6000/100,2,byte('0')) || period ||
                                iFormat(t mod 100,2,byte('0')) || period;
            return;
         end;
      h = t / 360000;
      if h >= 12 then
         do;
            ampm = 'pm';
            if h > 12 then
               h = h - 12;
         end;
      else
         do;
            ampm = 'am';
            if h = 0 then
               h = 12;
         end;
      output = message || iFormat(h,2,byte('0')) || colon ||
                          iFormat(t mod 360000/6000,2,byte('0')) || colon ||
                          iFormat(t mod 6000/100,2,byte('0')) || period ||
                          iFormat(t mod 100,2,byte('0')) || x1 || ampm || period;
   end print_time;

/*
 * Zeller's congruence:
 * dow = ((26M - 2)/10 + D + Y + Y/4 + C/4 - 2C) mod 7
 * D is the day of the month
 * Y is the last 2 digits of the year
 * C is the first two digits of the year
 * M is the month number (Mar = 1, Dec = 10, Jan and Feb are months 11 and
 *    12 of the *previous* year)
 * Result is 0 = Sun, 1 = Mon etc.
 */
dayofweek:
   procedure(month, day, year) character;
   declare (month, day, year, y, c, d, m, dow) fixed;
   declare dayname(6) character initial( 'Sunday', 'Monday', 'Tuesday', 'Wednesday',
                           'Thursday', 'Friday', 'Saturday' );

   y = year mod 100;
   c = year / 100;
   d = day;
   m = month - 2; // Mar, Apr, May, ... Jan, Feb == 1, 2, 3, ... 11, 12
   if m <= 0 then
      do;
      m = m + 12;
      y = y - 1;
      if y < 0 then
         do;
         y = y + 100;
         c = c - 1;
         end;
      end;

   dow = ( ( 26 * m - 2 ) / 10 + d + y + y / 4 + c / 4 - 2 * c ) mod 7;
   if dow < 0 then
      dow = dow + 7;
   return dayname(dow);
   end dayofweek;

print_date_and_time:
   procedure (message, d, t);
      declare message character, (d, t, year, day, m) fixed;
      declare months(12) character initial ('', 'January', 'February', 'March', 'April',
         'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'),
      days(12) fixed initial (0, 31, 60, 91, 121, 152, 182, 213, 244, 274,
         305, 335, 366);
      year = d/1000 + 1900;
      day = d mod 1000;
      if (year & "3") ~= 0 then if day > 59 then day = day + 1; /* ~ LEAP YEAR*/
      m = 1;
      do while day > days(m);  m = m + 1;  end;
      call print_time(message || dayofweek(m,day-days(m-1),year) || comma ||
                        x1 || months(m) || x1 || day - days(m-1) || comma ||
                        x1 || year || '. Clock time = ', t, FALSE);
   end print_date_and_time;

  /*                       INITIALIZATION                                     */



initialization:
   procedure;
      declare revision character initial('$Revision: 4.1.2.27 $');
      EJECT_PAGE;
      call print_date_and_time('X P L   Compilation -- Xcom  '
                                || substr(revision,11,length(revision)-13)
                                || '  version of ',
                                date_of_generation, time_of_generation);
      DOUBLE_SPACE;
      call print_date_and_time ('Today is ', date, time);
      DOUBLE_SPACE;
      do i = 1 to NSY;
         s = V(i);
         if s = '<NUMBER>' then number = i;  else
         if s = '<IDENTIFIER>' then ident = i;  else
         if s = '<STRING>' then string = i;  else
         if s = '/' then divide = i;  else
         if s = '_|_' then eofile = i;  else
         if s = 'DECLARE' then stopit(i) = TRUE;  else
         if s = 'PROCEDURE' then stopit(i) = TRUE;  else
         if s = 'END' then stopit(i) = TRUE;  else
         if s = 'DO' then stopit(i) = TRUE;  else
         if s = ';' then stopit(i) = TRUE;  else
         if s = vbar then orsymbol = i; else
         if s = '||' then concatenate = i; else
         if s = '<SUBSCRIPT HEAD>' then subscript_head = i; else
         ;
      end;
      if ident = NT then reserved_limit = length(V(NT-1));
      else reserved_limit = length(V(NT));
      V(eofile) = 'EOF';
      stopit(eofile) = TRUE;
      chartype(byte(' ')) = 1;
      chartype(byte('''')) = 2;
      chartype(byte('"')) = 3;
      do i = 0 to 255;
         not_letter_or_digit(i) = TRUE;
      end;
      do i = 0 to length(alphabet) - 1;
         j = byte(alphabet, i);
         tx(j) = i;
         not_letter_or_digit(j) = FALSE;
         chartype(j) = 4;
      end;
      do i = 0 to 9;
         j = byte('0123456789', i);
         not_letter_or_digit(j) = FALSE;
         chartype(j) = 5;
      end;
      do i = V_INDEX(0) to V_INDEX(1) - 1;
         j = byte(V(i));
         tx(j) = i;
         chartype(j) = 7;
      end;
      chartype(byte('|')) = 8;
      chartype(byte('/')) = 6;
      commutative(AND) = TRUE;
      commutative(OR) = TRUE;
      commutative(ADD) = TRUE;
      commutative(IMUL) = TRUE;

#define I(op,a1,a2,a3) shl(op,17)|shl(shl((a1)&"1F",3)|shr(a1,5),9)|shl(shl((a2)&"0F",3)|shr(a2,5),2)|(a3&"03")

      inst_adc_r32_imm8 = I(ADC,R32,IMM8,NONE);
      inst_add_eax_imm32 = I(ADD,EAX,IMM32,NONE);
      inst_add_r32_imm32 = I(ADD,R32,IMM32,NONE);
      inst_add_r32_imm8 = I(ADD,R32,IMM8,NONE);
      inst_add_r32_m32 = I(ADD,R32,M32,NONE);
      inst_add_r32_r32 = I(ADD,R32,R32,NONE);
      inst_and_r32_imm8 = I(AND,R32,IMM8,NONE);
      inst_and_r32_imm32 = I(AND,R32,IMM32,NONE);
      inst_bt_Xx1m32_imm8 = I(BT,Xx1|M32,IMM8,NONE);
      inst_bt_m32_imm8 = I(BT,M32,IMM8,NONE);
      inst_bt_r32_imm8 = I(BT,R32,IMM8,NONE);
      inst_bts_m32_imm8 = I(BTS,M32,IMM8,NONE);
      inst_call_m32 = I(JSR,M32,NONE,NONE);
      inst_call_r32 = I(JSR,R32,NONE,NONE);
      inst_call_rel32 = I(JSR,REL32,NONE,NONE);
      inst_cdq = I(CDQ,NONE,NONE,NONE);
      inst_cld = I(CLD,NONE,NONE,NONE);
      inst_cmp_r32_imm32 = I(CMP,R32,IMM32,NONE);
      inst_cmp_r32_imm8 = I(CMP,R32,IMM8,NONE);
      inst_cmp_r32_m32 = I(CMP,R32,M32,NONE);
      inst_cmp_r32_r32 = I(CMP,R32,R32,NONE);
      inst_cmpsb = I(CMPSB,NONE,NONE,NONE);
      inst_dec_r32 = I(DEC,R32,NONE,NONE);
      inst_idiv_eax_Xx4m32 = I(IDIV,EAX,Xx4|M32,NONE);
      inst_idiv_eax_m32 = I(IDIV,EAX,M32,NONE);
      inst_idiv_eax_r32 = I(IDIV,EAX,R32,NONE);
      inst_inc_r32 = I(INC,R32,NONE,NONE);
      inst_jcc_rel = I(JCC,REL,NONE,NONE);
      inst_jcc_rel32 = I(JCC,REL32,NONE,NONE);
      inst_jmp_m32 = I(JMP,M32,NONE,NONE);
      inst_jmp_r32 = I(JMP,R32,NONE,NONE);
      inst_jmp_rel = I(JMP,REL,NONE,NONE);
      inst_jmp_rel32 = I(JMP,REL32,NONE,NONE);
      inst_lea_r32_Xx1m32 = I(LEA,R32,Xx1|M32,NONE);
      inst_lea_r32_Xx2m32 = I(LEA,R32,Xx2|M32,NONE);
      inst_lea_r32_Xx4m32 = I(LEA,R32,Xx4|M32,NONE);
      inst_lea_r32_Xx8m32 = I(LEA,R32,Xx8|M32,NONE);
      inst_lea_r32_m32 = I(LEA,R32,M32,NONE);
      inst_mov_Xx1m32_r32 = I(MOV,Xx1|M32,R32,NONE);
      inst_mov_Xx1m8_r8 = I(MOV,Xx1|M8,R8,NONE);
      inst_mov_Xx2m16_r16 = I(MOV,Xx2|M16,R16,NONE);
      inst_mov_Xx4m32_r32 = I(MOV,Xx4|M32,R32,NONE);
      inst_mov_m16_imm16 = I(MOV,M16,IMM16,NONE);
      inst_mov_m16_r16 = I(MOV,M16,R16,NONE);
      inst_mov_m32_imm32 = I(MOV,M32,IMM32,NONE);
      inst_mov_m32_r32 = I(MOV,M32,R32,NONE);
      inst_mov_m8_imm8 = I(MOV,M8,IMM8,NONE);
      inst_mov_m8_r8 = I(MOV,M8,R8,NONE);
      inst_mov_r16_Xx2m16 = I(MOV,R16,Xx2|M16,NONE);
      inst_mov_r16_m16 = I(MOV,R16,M16,NONE);
      inst_mov_r32_Xx1m32 = I(MOV,R32,Xx1|M32,NONE);
      inst_mov_r32_Xx4m32 = I(MOV,R32,Xx4|M32,NONE);
      inst_mov_r32_imm32 = I(MOV,R32,IMM32,NONE);
      inst_mov_r32_m32 = I(MOV,R32,M32,NONE);
      inst_mov_r32_r32 = I(MOV,R32,R32,NONE);
      inst_mov_r8_Xx1m8 = I(MOV,R8,Xx1|M8,NONE);
      inst_mov_r8_m8 = I(MOV,R8,M8,NONE);
      inst_movsb = I(MOVSB,NONE,NONE,NONE);
      inst_movsx_r32_r16 = I(MOVSX,R32,R16,NONE);
      inst_movzx_r32_r8 = I(MOVZX,R32,R8,NONE);
      inst_neg_r32 = I(NEG,R32,NONE,NONE);
      inst_nop = I(NOP,NONE,NONE,NONE);
      inst_not_r32 = I(NOT,R32,NONE,NONE);
      inst_or_r32_imm32 = I(OR,R32,IMM32,NONE);
      inst_or_r32_r32 = I(OR,R32,R32,NONE);
      inst_or_r8_imm8 = I(OR,R8,IMM8,NONE);
      inst_pop_m32 = I(POP,M32,NONE,NONE);
      inst_pop_r32 = I(POP,R32,NONE,NONE);
      inst_push_r32 = I(PUSH,R32,NONE,NONE);
      inst_rep = I(REP,NONE,NONE,NONE);
      inst_ret = I(RET,NONE,NONE,NONE);
      inst_setcc_r8 = I(SETCC,R8,NONE,NONE);
      inst_shl_r32_imm8 = I(SLL,R32,IMM8,NONE);
      inst_shr_r32_imm8 = I(SRL,R32,IMM8,NONE);
      inst_sub_r32_imm32 = I(SUB,R32,IMM32,NONE);
      inst_sub_r32_r32 = I(SUB,R32,R32,NONE);
      inst_xchg_r32_r32 = I(XCHG,R32,R32,NONE);
      inst_xor_r32_imm32 = I(XOR,R32,IMM32,NONE);
      inst_xor_r32_r32 = I(XOR,R32,R32,NONE);

#undef I

      returned_type = FIXEDTYPE;          /* DEFAULT RETURN TYPE */

      /*              INITIALIZE SYMBOL TABLE VARIABLES */
      pp = 60;   /*  OFFSET  CODE  FOR  CONTROL  RECORD (SEE LOADER) */
         /*  ALSO USED FOR THE MONITOR_LINK COMMUNICATION ARRAY  */
      dp = 0;    /*  DATA ORIGIN  */
      dsp = 4;
      chp = 1;
      pplim, dplim, dsplim, chplim = DISKBYTES; // UPPER BOUND FOR EMITTER ARRAYS
      pporg, dporg, dsporg, chporg = 0;         // LOWER BOUND FOR EMITTER ARRAYS
      curcblk, curdblk, curdsblk, cursblk = 0; // CURRENT BLOCK OCCUPYING EMITTER ARRAYS
      strngblk = (4 * MAXDESC + DISKBYTES - 1) / DISKBYTES;
      shortcfix, shortdfix, longcfix, longdfix = 0; // STATISTICAL COUNTERS FOR FIXUPS
      fcp = 0;  /* POINTER INTO FIXUP ARRAY */
      procmark = 1;   parct = 0;

      /*  WARNING, THE FOLLOWING SECTION OF INITIALIZE DEPENDS ON
          THE INITIALIZATION OF THE BUILTIN FUNCTION AND PSEUDO
          VARIABLE NAMES AND ATTRIBUTES IN THE SYMBOL TABLE ARRAYS.
      */

      io_save = dp;  dp = dp + 12;  /* REGISTER SAVE FOR INPUT/OUTPUT  */

      call emitDataword(0);  tsa = dp-4;
      syt_disp(4), syt_disp(5) = dp;         /*  TIME_OF_GENERATION         */
      call emitDataword(time);
      syt_disp(6), syt_disp(7) =  dp;        /*  DATE_OF_GENERATION         */
      call emitDataword(date);
      syt_disp(8), syt_disp(9) = 0;          /*  COREWORD                   */
      syt_disp(10), syt_disp(11) = 0;        /*  COREBYTE                   */
      syt_disp(12), syt_disp(13) = tsa;      /*  FREEPOINT                  */
      syt_disp(14), syt_disp(15) = dsp;      /*  DESCRIPTOR                 */
      syt_disp(16), syt_disp(17) = dp;       /*  NDESCRIPT                  */
      descl = dp;
      call emitDataword (0);
      a2 = dsp;       /* A2 IS THE FIRST PARAMETER TO || */
      call emitDesc (0);
      b2 = dsp;       /* B2 IS THE SECOND PARAMETER TO || */
      call emitDesc (0);
      strl = -dsp;  call emitDesc(0);
      strn = dp; call emitDataword(0);
      cmps1 = dp; call emitDataword(0);
      cmps2 = dp; call emitDataword(0);
      rtnadr = dp; call emitDataword (0);
      ndecsy = 56;  /* ONE BEYOND LAST BUILTIN FUNCTION NAME; 'COMPACTIFY'  */

      do i = 0 to SYTSIZE;
         ptr(i) = -1;
      end;
      do i = 0 to "FF";
         hash(i) = -1;
      end;
      do i = 2 to ndecsy;    /*  INITIALIZE RESERVED WORD POINTERS  */
         idx = hasher(syt_name(i));
         ptr(i) = hash(idx);
         hash(idx) = i;
      end;

      call emitDataword (0);
      syt_disp(ndecsy) = dp-4;            /*  COMPACTIFY                 */
      syt_base(ndecsy) = DBR;
      string_recover = ndecsy;
      call clearregs;


      /*         EMIT CODE FOR BUILT_IN FUNCTIONS                        */

      call register_setup_code;

      call relocate_descriptors_code;

      call catenate_code;

      call compare_code;

      call convert_code;

      mainloc = pp;
      call clearregs;
      /* FIRST SET UP GLOBAL VARIABLES CONTROLLING SCAN, THEN CALL IT */
      cp = 0;  text_limit = -1;
      text, current_procedure = '';
      call scan;

      /* INITIALIZE THE PARSE STACK */
      sp = 1;  parse_stack(sp) = eofile;

   end initialization;



  /*               SYMBOL AND STATISTICS PRINTOUT                         */


symboldump:
   procedure;
      /* LISTS THE SYMBOLS IN THE PROCEDURE THAT HAS JUST BEEN
         COMPILED IF DOLLAR S OR DOLLAR D IS ENABLED
      */
      declare (i, j, k, l, m) fixed, buffer character,
         sytsort(SYTSIZE) bit(16);

   string_gt:
      procedure (a, b) bit(1);
         /*  DOES AN HONEST STRING COMPARE FOR A > B.  USES THE
             KNOWLEDGE THAT NEITHER A NOR B MAY CONTAIN BLANKS.
         */
         declare (a, b) character, (la, lb) fixed;
         la = length(a);
         lb = length(b);
         if la = lb then
            return a > b;    /*  XCOM IS HONEST IN THIS CASE  */
         else if la > lb then
            return substr(a,0,lb) >= b;
         else
            return  a > substr(b,0,la);
      end  string_gt  ;

      outline:
         procedure (name, p) character;
            declare (name, t) character, p fixed;

            if syt_count(p) = 0 then
               t = ' and not referenced.';
            else
               do;
                  t = ' and referenced ' || syt_count(p);
                  if syt_count(p) = 1 then
                     t = t || ' time.';
                  else
                     t = t || ' times.';
               end;

            buffer = pad(hex(syt_disp(p)) || '(' || RegName32(syt_base(p)) || '),',11);
            return name || ': ' || typename(syt_type(p)) || ' at ' || buffer ||
                           ' declared on line ' || declared_on_line(p) || t;
         end  outline;


      if procmark <= ndecsy then
         do;
            DOUBLE_SPACE;
            output = 'Symbol  Table  Dump';
            DOUBLE_SPACE;
            do i = procmark to ndecsy;
               sytsort(i) = i;
            end;

            k = ndecsy - procmark;
            m = shr(k+1,1);
            do while m > 0;
               do j = procmark to procmark+k-m;
                  i = j;
                  do while string_gt(syt_name(sytsort(i)), syt_name(sytsort(i+m)));
                     l = sytsort(i);
                     sytsort(i) = sytsort(i+m);
                     sytsort(i+m) = l;
                     i = i - m;
                     if i < procmark then
                        go to lm;
                  end;
            lm:end;
               m = shr(m,1);
            end;


            i = procmark;
            do while length(syt_name(sytsort(i))) = 0;
               i = i + 1;              /* IGNORE NULL NAMES */
            end;

            do i = i to ndecsy;
               k = sytsort(i);
               output = outline(pad(syt_name(k), 23), k);

               k = k + 1;
               do while (length(syt_name(k)) = 0) & (k <= ndecsy);
                  j = k - sytsort(i);
                  output = outline('  parameter  ' || j || substr(x70,0,9), k);
                  k = k + 1;
               end;

            end;

            EJECT_PAGE;
         end;

   end  symboldump;



dumpit:
   procedure;    /* DUMP OUT THE COMPILED CODE & DATA AREAS  */
      declare x label;
      declare ops(5) character;

      call symboldump;
      output = 'Macro Definitions:';
      output = '';
      do i = 0 to top_macro;
         output = pad(macro_name(i), 20) || ' Literally: ' || macro_text(i);
      end;
      DOUBLE_SPACE;

      /*  PUT OUT THE ENTRY COUNT FOR IMPORTANT PROCEDURES */
      output = 'Function call and usage statistics:';
      output = '';
      output = 'scan()            = ' || count#scan;
      output = 'getStrings()      = ' || count#gets;
      output = 'getDesc()         = ' || count#getds;
      output = 'getData()         = ' || count#getd;
      output = 'getCode()         = ' || count#getc;
      output = 'ID Compares       = ' || idcompares;
      output = 'Stacking Decisions= ' || count#stack;
      output = 'Emit()            = ' || count#emit;
      output = 'forceaccumulator()= ' || count#force;
      output = 'arithemit()       = ' || count#arith;
      output = 'genstore()        = ' || count#store;
      output = 'findaddress()     = ' || count#find;
      output = 'fixbfw()          = ' || count#fixbfw;
      output = 'Fast Code Fix     = ' || shortcfix;
      output = 'Slow Code Fix     = ' || longcfix;
      output = 'Fix Data Word     = ' || count#fixd;
      output = 'Fast Data Fix     = ' || shortdfix;
      output = 'Slow Data Fix     = ' || longdfix;
      output = 'Max. stack depth  = ' || stackmax || ' (of ' || STACKSIZE || ')';
      output = 'Symbol table size = ' || maxndecsy || ' (of ' || SYTSIZE || ')';
      output = 'Macro definitions = ' || top_macro + 1 || ' (of ' || MACRO_LIMIT + 1 || ')';
      output = 'Cached constants  = ' || numcachc || ' (of ' || MAXCACHEC || ')';
      output = 'Free string area  = ' || freelimit - freebase;
      s = ', ';
      output = 'String collections= ' || STRING_COLLECTIONS(0) || s ||
                                         STRING_COLLECTIONS(1) || s ||
                                         STRING_COLLECTIONS(2);
      DOUBLE_SPACE;

      output = ''; output = 'Instruction frequencies:';
      output = '';
      do i = 0 to NINST;    // For each instruction...
         if instruct(i) ~= 0 then
            do;
               // Find the non-suffixed opcode; there are several opcodes for each
               // instruction, the difference being a 'b' or 'w' suffix.
               k = 0;
               do j = 0 to NTEMPLATE;
                  l = shr( byte(template(j)), 1); // the instruction code
                  if l = i then
                     do;  // Collect all the unique opcodes
                        s = i486Opcodes( byte(template(j),6) );
                        if k > 0 then
                           do l = 0 to k - 1;
                              if ops(l) = s then
                                 goto x;
                           end;
                        ops(k) = s;
                        k = k + 1;
                  x: end;
               end;
               // The shortest opcode has no 'b' or 'w' suffix
               if k > 0 then
                  do;
                     l = 0;
                     do j = 1 to k - 1;
                        if length(ops(j)) < length(ops(l)) then
                           l = j;
                     end;
                     s = ops(l);
                     if i = JCC | i = SETCC then
                        s = s || 'cc';
                     else
                        if i = MOVSX | i = MOVZX then
                           s = substr( s, 0, 5 );
                     output = pad(s,10) || instruct(i);
                  end;
               else
                  output = pad('???',10) || instruct(i);
            end;
      end;
   end dumpit;


stack_dump:
   procedure;
      declare line character;
      line = 'Partial parse to this point is: ';
      do i = 2 to sp;
         if length(line) > 105 then
            do;
               output = line;
               line = x4;
            end;
         line = line || x1 || V(parse_stack(i));
      end;
      output = line;
   end stack_dump;


  /*                  THE SYNTHESIS ALGORITHM FOR XPL                      */


synthesize:
procedure(production_number);
   declare production_number fixed;

   /*  ONE STATEMENT FOR EACH PRODUCTION OF THE GRAMMAR*/


do case production_number;
   /* WARNING:  THE PRODUCTION SELECTION TABLE PRDTB HAS BEEN MODIFIED
       SO THAT SYNTHESIZE IS NOT CALLED FOR PRODUCTIONS WITH NULL
       SEMATICS
   */
   ;      /*  CASE 0 IS A DUMMY, BECAUSE WE NUMBER PRODUCTIONS FROM 1  */

 /*  <PROGRAM>  ::=  <STATEMENT LIST>    */
   do;   /* FINAL CODE FOR XPLSM INTERFACE & SETUP  */
      if mp ~= 2 then  /* WE DIDN'T GET HERE LEGITIMATELY  */
         do;
            call error ('EOF at invalid point', 1);
            call stack_dump;
         end;
      do i = 1 to ndecsy;
         if syt_type(i) = FORWARDTYPE | syt_type(i) = FORWARDCALL then
          if syt_count(i) > 0 then
            call error ('Undefined label or procedure: ' || syt_name(i), 1);
      end;
      call emit( inst_sub_r32_r32, 3, 3 );  /* RETURN CODE OF ZERO  */
      call emit( inst_jmp_m32, DBR,rtnadr );
      /* SET UP BASE REGISTERS */
      bases(SBR) = (dp + 3) & "FFFFFC";
      call fixwholedataword(descl, shr(dsp,2)-1);
      compiling = FALSE;
   end;

 /*  <STATEMENT LIST> ::= <STATEMENT>    */
   ;
 /*  <STATEMENT LIST> ::= <STATEMENT LIST> <STATEMENT>    */
   ;
 /*  <STATEMENT> ::= <BASIC STATEMENT>    */
   do;
      call clearregs;
      statement_count = statement_count + 1;
   end;

 /*  <STATEMENT> ::= <IF STATEMENT>    */
   call clearregs;

 /*  <BASIC STATEMENT> ::= <ASSIGNMENT> ;    */
   ;
 /*  <BASIC STATEMENT> ::= <GROUP> ;    */
   ;
 /*  <BASIC STATEMENT> ::= <PROCEDURE DEFINITION> ;    */
   ;
 /*  <BASIC STATEMENT> ::= <RETURN STATEMENT> ;    */
   ;
 /*  <BASIC STATEMENT> ::= <CALL STATEMENT> ;    */
   ;
 /*  <BASIC STATEMENT> ::= <GO TO STATEMENT> ;    */
   ;
 /*  <BASIC STATEMENT> ::= <DECLARATION STATEMENT> ;    */
   ;

 /*  <BASIC STATEMENT> ::= ;    */
      ;
 /*  <BASIC STATEMENT> ::= <LABEL DEFINITION> <BASIC STATEMENT>    */
      ;
 /*  <IF STATEMENT> ::= <IF CLAUSE> <STATEMENT>    */
   call fixbfw(ps_fxloc(mp), pp);
   /* FIX THE ESCAPE BRANCH NOW THAT STMT IS DONE */

 /*  <IF STATEMENT> ::= <IF CLAUSE> <TRUE PART> <STATEMENT>    */
   do;  /* THERE ARE TWO BRANCHES TO BE FILLED IN WITH ADDRESSES HERE */
      call fixbfw(ps_fxloc(mpp1), pp); /* ESCAPE FROM TRUE PART */
      call fixbfw(ps_fxloc(mp), ps_fxval(mpp1)); /* HOP AROUND TRUE PART */
   end;

 /*  <IF STATEMENT> ::= <LABEL DEFINITION> <IF STATEMENT>    */
   ;

 /*  <IF CLAUSE> ::= IF <EXPRESSION> THEN    */
   call boolbranch(mpp1, mp); /* BRANCH ON FALSE OVER TRUE PART */

  /*  <TRUE PART> ::= <BASIC STATEMENT> ELSE   */
   do;  /* SAVE THE PROGRAM POINTER & EMIT THE CONDITIONAL BRANCH */
      ps_fxloc(mp) = pp;
      call jump( -1 );
      ps_fxval(mp) = pp;
   end;

 /*  <GROUP> ::= <GROUP HEAD> <ENDING>    */
   do;  /* BRANCH BACK TO LOOP & FIX ESCAPE JUMP */
      if ps_xreg(mp) = 1 | ps_xreg(mp) = 2 then
         do; /* STEP OR WHILE LOOP FIX UP */
            call jump(ps_pp(mp));
            call fixbfw(ps_fxloc(mp), pp);
         end;
      else if  ps_xreg(mp) = 3 then
         do;  /* COMMENT  CASE GROUP */
            /* JUSTIFY TO WORD BOUNDARY */
            dp = (dp + 3) & "FFFFFC";
            call findaddress(dp);
            call fixcodeword(ps_fxloc(mp), adrdisp);
            do i = ps_pp(mp) to casep-1; call emitDataword(casestack(i)); end;
            casep = ps_pp(mp) - 1;
            call fixbfw(ps_fxval(mp), pp);
         end;
      if length(ps_name(sp)) > 0 then if ps_name(mp-1) ~= ps_name(sp) then
         call error ('END ' || ps_name(sp) || '  must match label on group');
   end;

 /*  <GROUP HEAD> ::= DO ;    */
   ps_xreg(mp) = 0;

 /*  <GROUP HEAD> ::= DO <STEP DEFINITION> ;    */
   do;
      call movestacks(mpp1, mp);
      ps_xreg(mp) = 1;  /* 1 DENOTES STEP */
   end;

 /*  <GROUP HEAD> ::= DO <WHILE CLAUSE> ;    */
   do;
      ps_pp(mp) = ps_pp(mpp1);
      ps_fxloc(mp) = ps_fxloc(mpp1);
      ps_xreg(mp) = 2;  /* 2 DENOTES WHILE */
   end;

 /*  <GROUP HEAD> ::= DO <CASE SELECTOR> ;    */
   do;
      call movestacks(mpp1, mp);
      ps_xreg(mp) = 3;  /* 3 DENOTES CASE  */
      information = information || ' Case 0.';
   end;

 /*  <GROUP HEAD> ::= <GROUP HEAD> <STATEMENT>    */
   if  ps_xreg(mp) = 3 then
      do;  /* CASE GROUP, MUST RECORD STATEMENT ADDRESSES */
         call jump (ps_fxval(mp));
      if casep >= CASELIMIT then call error ('Too many cases', 1);
         else casep = casep + 1;  casestack(casep) = pp;
      if bcd ~= 'END' & bcd ~= 'end' then
            information = information || ' Case ' || casep-ps_pp(mp) || period;
      end;

 /*  <STEP DEFINITION> ::= <VARIABLE> <REPLACE> <EXPRESSION> <ITERATION CONTROL>
         */
   do; /* EMIT CODE FOR STEPPING DO LOOPS */
      call forceaccumulator(mp+2);
      if ps_xreg(mp) ~= 0 then
         call error ('Subscripted DO VARIABLE');
      stepk = pp;
      call jump(0);
      ps_pp(mp) = pp;
      l = ps_fxloc(mp);
      adreg = syt_base(l);
      adrdisp = syt_disp(l);
      if syt_type(l) = BYTETYPE then
         do;
            call emit( inst_mov_r8_m8, ps_reg(mp+2), adreg,adrdisp );
            call emit( inst_movzx_r32_r8, ps_reg(mp+2), ps_reg(mp+2) );
         end;
      else if syt_type(l) = HALFWORD then
         do;
            call emit( inst_mov_r16_m16, ps_reg(mp+2), adreg,adrdisp );
            call emit( inst_movsx_r32_r16, ps_reg(mp+2), ps_reg(mp+2) );
         end;
      else
         call emit( inst_mov_r32_m32, ps_reg(mp+2), adreg,adrdisp );
      if ps_cnt(mp+3) = CONSTANT then
         do;
            if ps_fxloc(mp+3) = 1 then
               call emit( inst_inc_r32, ps_reg(mp+2) );
            else
               call emit( inst_add_r32_imm32, ps_reg(mp+2), ps_fxloc(mp+3) );
         end;
      else
         call emit( inst_add_r32_m32, ps_reg(mp+2), ps_reg(mp+3),ps_fxloc(mp+3) );
      call fixbfw(stepk, pp);
      if syt_type(l) = BYTETYPE then
         call emit( inst_mov_m8_r8, syt_base(l),syt_disp(l), ps_reg(mp+2) );
      else if syt_type(l) = HALFWORD then
         call emit( inst_mov_m16_r16, syt_base(l),syt_disp(l), ps_reg(mp+2) );
      else
         call emit( inst_mov_m32_r32, syt_base(l),syt_disp(l), ps_reg(mp+2) );
      if ps_type(mp+3) = CONSTANT then
         call emit( inst_cmp_r32_imm32, ps_reg(mp+2), ps_fxval(mp+3) );
      else
         call emit( inst_cmp_r32_m32, ps_reg(mp+2), ps_xreg(mp+3),ps_fxval(mp+3) );
      ps_fxloc(mp) = pp;
      call branch(CC_G, -1);
      bases(ps_xreg(mp)) = AVAIL;
      bases(ps_reg(mp+2)) = AVAIL;
   end;

 /*  <ITERATION CONTROL> ::= TO <EXPRESSION>    */
   do;
      /* BY 1 */
      ps_cnt(mp) = CONSTANT;
      ps_fxloc(mp) = 1;
      call set_limit;
   end;

 /*  <ITERATION CONTROL> ::= TO <EXPRESSION> BY <EXPRESSION>    */
   do;
      if ps_type(sp) = CONSTANT then
         do;
            /* BY <CONSTANT> */
            ps_cnt(mp) = CONSTANT;
            ps_fxloc(mp) = ps_fxval(sp);
         end;
      else
         do;
            /* BY <EXPRESSION> */
            call forceaccumulator (sp);
            call emitDataword (0);
            call findaddress (dp-4);
            call emit( inst_mov_m32_r32, adreg,adrdisp, ps_reg(sp) );
            bases(ps_reg(sp)) = AVAIL;
            ps_cnt(mp) = VARIABLE;
            ps_reg(mp) = adreg;
            ps_fxloc(mp) = adrdisp;
         end;
      call set_limit;
   end;

 /*  <WHILE CLAUSE> ::= WHILE <EXPRESSION>    */
   call boolbranch(sp, mp);

 /*  <CASE SELECTOR> ::= CASE <EXPRESSION>    */
   do;
      call forceaccumulator(sp);
      // Next instruction will be MOV MODRM SIB DISP32
      ps_fxloc(mp) = pp+3;
      // Force displacement in generated instruction to be four bytes
      call emit( inst_mov_r32_Xx4m32, ps_reg(sp), ps_reg(sp), DBR,"FFFFFF" );
      call emit( inst_add_r32_r32, ps_reg(sp), PBR );
      call emit( inst_jmp_r32, ps_reg(sp) );
      bases(ps_reg(sp)) = AVAIL;
      ps_fxval(mp) = pp;
      call jump( -1 );
      if casep >= CASELIMIT then call error ('Too many cases', 1);
      else casep = casep + 1;
      casestack(casep) = pp;
      ps_pp(mp) = casep;
   end;

 /*  <PROCEDURE DEFINITION> ::= <PROCEDURE HEAD> <STATEMENT LIST> <ENDING>    */
   do; /* PROCEDURE IS DEFINED, RESTORE SYMBOL TABLE */
      if length(ps_name(sp)) > 0 then
         if substr(current_procedure, 1) ~= ps_name(sp) then
            call error ('Procedure' || current_procedure || ' closed by END ' || ps_name(sp));
      if control(byte('S')) then call symboldump;
      do i = procmark to ndecsy;
         if syt_type(i) = FORWARDTYPE | syt_type(i) = FORWARDCALL then
          if syt_count(i) > 0 then
            call error ('Undefined label or procedure: ' || syt_name(i), 1);
      end;
      /*  REMOVE THE IDENTIFIERS DECLARED IN THIS PROCEDURE FROM
          THE SYMBOL TABLE
      */
      do i = 0 to (ndecsy+1) - (procmark+parct);
         j = ndecsy - i;
         if (j >= (procmark+parct)) & (length(syt_name(j)) > 0) then
            do;
               /*  UNWIND HASH POINTERS  */
               hash(hasher(syt_name(j))) = ptr(j);
               ptr(j) = -1;
            end;
      end;

      do i = procmark + parct  to  ndecsy + 1;
         syt_name(i) = x1;
      end;
      ndecsy = procmark + parct - 1;
      /* PARAMETER ADDRESS MUST BE SAVED BUT NAMES DISCARDED */
      do j = 0 to ndecsy - procmark;
         i = ndecsy - j;
         if syt_type(i) = 0 then
            do;
               call error('Undeclared parameter:' || syt_name(i));
               syt_type(i) = FIXEDTYPE;
               call emitDataword(0);
               call findaddress(dp-4);
               syt_base(i) = adreg;
               syt_disp(i) = adrdisp;
            end;
         hash(hasher(syt_name(i))) = ptr(i);
         ptr(i) = -1;
         syt_name(i) = '';
      end;
      current_procedure = ps_name(mp);
      procmark = ps_fxval(mp);  parct = ps_cnt(mp);
      returned_type = ps_type(mp) ;
      /* EMIT A GRATUITOUS RETURN */
      call findaddress(rtnadr);
      call emit( inst_jmp_m32, adreg,adrdisp );
      rtnadr = ps_pp(mp);
      call fixbfw(ps_fxloc(mp), pp);
      /* COMPLETE JUMP AROUND PROCEDURE DEFINITION */
   end;

 /*  <PROCEDURE HEAD> ::= <PROCEDURE NAME> ;    */
   do;  /* MUST POINT AT FIRST PARAMETER EVEN IF NONEXISTENT  */
      /* SAVE OLD PARAMETER COUNT */
      ps_cnt(mp) = parct; parct = 0;
      /* SAVE OLD PROCEDURE MARK IN SYMBOL TABLE */
      ps_fxval(mp) = procmark;  procmark = ndecsy + 1;
      ps_type(mp) = returned_type;
      returned_type = 0;
      call proc_start;
   end;


 /*  <PROCEDURE HEAD> ::= <PROCEDURE NAME> <TYPE> ;    */
   do;
      ps_cnt(mp) = parct;
      parct = 0;
      ps_fxval(mp) = procmark;
      procmark = ndecsy + 1;
      ps_type(mp) = returned_type;
      returned_type = ps_type(sp-1);
      if returned_type = CHRTYPE then
         syt_type(ps_fxloc(mp)) = CHAR_PROC_TYPE ;
      call proc_start;
   end;

 /*  <PROCEDURE HEAD> ::= <PROCEDURE NAME> <PARAMETER LIST> ;    */
   do;
      ps_cnt(mp) = ps_cnt(mpp1);  /* SAVE PARAMETER COUNT */
      ps_fxval(mp) = ps_fxval(mpp1);
      ps_type(mp) = returned_type;
      returned_type = 0;
      call proc_start;
   end;


 /*  <PROCEDURE HEAD> ::= <PROCEDURE NAME> <PARAMETER LIST> <TYPE> ;       */
   do;
      ps_cnt(mp) = ps_cnt(mpp1);
      ps_fxval(mp) = ps_fxval(mpp1);
      ps_type(mp) = returned_type;
      returned_type = ps_type(sp-1);
      if returned_type = CHRTYPE then
         syt_type(ps_fxloc(mp)) = CHAR_PROC_TYPE ;
      call proc_start;
   end;

 /*  <PROCEDURE NAME> ::= <LABEL DEFINITION> PROCEDURE    */
   do;
      s = current_procedure;
      current_procedure = x1 || ps_name(mp);
      ps_name(mp) = s;
   end;

 /*  <PARAMETER LIST> ::= <PARAMETER HEAD> <IDENTIFIER> )    */
   do;
      parct = parct + 1;
      call enter (ps_name(mpp1), 0, 0, 0);
   end;

 /*  <PARAMETER HEAD> ::= (   */
   do;  /* POINT AT THE FIRST PARAMETER FOR SYMBOL TABLE */
      ps_fxval(mp) = procmark;  procmark = ndecsy + 1;
      ps_cnt(mp) = parct;
      parct = 0;
   end;

 /*  <PARAMETER HEAD> ::= <PARAMETER HEAD> <IDENTIFIER> ,    */
   do;
      parct = parct + 1;
      call enter (ps_name(mpp1), 0, 0, 0);
   end;

 /*  <ENDING> ::= END    */
   ps_name(mp) = '';

 /*  <ENDING> ::= END <IDENTIFIER>    */
   ps_name(mp) = ps_name(sp);

 /*  <ENDING> ::= <LABEL DEFINITION> <ENDING>    */
   ps_name(mp) = ps_name(sp);

 /*  <LABEL DEFINITION> ::= <IDENTIFIER> :    */
   ps_fxloc(mp) = enter (ps_name(mp), LABELTYPE, pp, ps_fxloc(mp));


 /*  <RETURN STATEMENT> ::= RETURN    */
   do;  /* EMIT A RETURN BRANCH */
      call findaddress(rtnadr);
      call emit( inst_jmp_m32, adreg,adrdisp );
   end;

 /*  <RETURN STATEMENT> ::= RETURN <EXPRESSION>    */
   do;  /* EMIT A RETURN BRANCH & PASS VALUE IN REGISTER 3 */
      /* NOW FORCE IT INTO REGISTER 3 */
      target_register = EBX;
      if returned_type = CHRTYPE then
         call forcedescript(mpp1);
      else
         call forceaccumulator(mpp1);
      target_register = -1;
      if ps_reg(mpp1) ~= EBX then
         call emit( inst_mov_r32_r32, EBX, ps_reg(mpp1) );
      call findaddress(rtnadr);
      call emit( inst_jmp_m32, adreg,adrdisp );
      call clearregs;
   end;

 /*  <CALL STATEMENT> ::= CALL <VARIABLE>    */
   do;
      call forceaccumulator(sp);
      call clearregs;
   end;

 /*  <GO TO STATEMENT> ::= <GO TO> <IDENTIFIER>    */
   do;
      call id_lookup(sp);
      j = ps_fxloc(sp);
      if j < 0 then          /*  1ST OCURRANCE OF THE LABEL */
         do;
            call emitDataword(0);      /* SPACE FOR FIXUP */
            j = enter (ps_name(sp), FORWARDTYPE, dp-4, ps_fxloc(sp));
            syt_count(j) = 1;
         end;
      if syt_type(j) = LABELTYPE then
         call jump( syt_disp(j) );
      else if syt_type(j) = FORWARDTYPE then
         do;
            i = findac;
            call emit( inst_mov_r32_m32, i, syt_base(j),syt_disp(j) );
            call emit( inst_add_r32_r32, i, PBR );
            call emit( inst_jmp_r32, i );
            bases(i) = AVAIL;
         end;
      else
         do;
            call error('Target of GO TO is not a label',1);
            i = findac;
            call emit( inst_lea_r32_m32, i, syt_base(j),syt_disp(j) );
            call emit( inst_jmp_r32, i );
            bases(i) = AVAIL;
         end;
   end;

 /*  <GO TO> ::= GO TO    */
      ;
 /*  <GO TO> ::= GOTO    */
      ;
 /*  <DECLARATION STATEMENT> ::= DECLARE <DECLARATION ELEMENT>    */
      ;

 /*  <DECLARATION STATEMENT> ::= <DECLARATION STATEMENT> , <DECLARATION ELEMENT>
          */
      ;

 /*  <DECLARATION ELEMENT> ::= <TYPE DECLARATION>    */
   do;
      if ps_type(mp) = CHRTYPE then
         dsp = newdsp ;
      else
         do;
            dp = newdp ;
         end;
   end;

 /*  <DECLARATION ELEMENT> ::= <IDENTIFIER> LITERALLY <STRING>    */
      if top_macro >= MACRO_LIMIT then
         call error('Macro table overflow',1);
      else
         do;
            top_macro = top_macro + 1;
            i = length(ps_name(mp));
            j = macro_index(i);
            do l = 1 to top_macro - j;
               k = top_macro - l;
               macro_name(k+1) = macro_name(k);
               macro_text(k+1) = macro_text(k);
            end;
            macro_name(j) = ps_name(mp);
            macro_text(j) = ps_name(sp);
            do j = i to 255;
               macro_index(j) = macro_index(j)+1;
            end;
         end;

 /*  <TYPE DECLARATION> ::= <IDENTIFIER SPECIFICATION> <TYPE>    */
   call tdeclare(0);

 /*  <TYPE DECLARATION> ::= <BOUND HEAD> <NUMBER> ) <TYPE>    */
   call tdeclare(ps_fxval(mpp1));

 /*  <TYPE DECLARATION> ::= <TYPE DECLARATION> <INITIAL LIST>    */
      ;

 /*  <TYPE> ::= FIXED    */
   ps_type(mp) = FIXEDTYPE ;

 /*  <TYPE> ::= CHARACTER    */
   ps_type(mp) = CHRTYPE ;

 /*  <TYPE> ::= LABEL    */
   ps_type(mp) = FORWARDTYPE ;

 /*  <TYPE> ::= <BIT HEAD> <NUMBER> )    */
      if ps_fxval(mpp1) <= 8 then ps_type(mp) = BYTETYPE;
      else if ps_fxval(mpp1) <= 16 then ps_type(mp) = HALFWORD;
      else if ps_fxval(mpp1) <= 32 then ps_type(mp) = FIXEDTYPE;
      else ps_type(mp) = CHRTYPE;

 /*  <BIT HEAD> ::= BIT (   */
      ;

 /*  <BOUND HEAD> ::= <IDENTIFIER SPECIFICATION> (   */
      ;

 /*  <IDENTIFIER SPECIFICATION> ::= <IDENTIFIER>    */
   do;
      ps_xreg(mp) = 1;
      i = ps_fxloc(mp);
      ps_fxloc(mp) = casep;
      if casep >= CASELIMIT then
         call error(dclrm,1);
      else
         casep = casep + 1;
      casestack(casep) = enter (ps_name(mp), 0, 0, i);
   end;

 /*  <IDENTIFIER SPECIFICATION> ::= <IDENTIFIER LIST> <IDENTIFIER> )    */
   do;
      ps_xreg(mp) = ps_xreg(mp) + 1;
      if casep >= CASELIMIT then
         call error(dclrm, 1);
      else
         casep = casep + 1;
      casestack(casep) = enter (ps_name(mpp1), 0, 0, ps_fxloc(mpp1));
   end;

 /*  <IDENTIFIER LIST> ::= (   */
   do;
      ps_xreg(mp) = 0;
      ps_fxloc(mp) = casep;
   end;

 /*  <IDENTIFIER LIST> ::= <IDENTIFIER LIST> <IDENTIFIER> ,    */
   do;
      ps_xreg(mp) = ps_xreg(mp) + 1;
      if casep >= CASELIMIT then
         call error(dclrm, 1);
      else
         casep = casep + 1;
      casestack(casep) = enter (ps_name(mpp1), 0, 0, ps_fxloc(mpp1));
   end;

 /*  <INITIAL LIST> ::= <INITIAL HEAD> <CONSTANT> )    */
   call setinit ;

 /*  <INITIAL HEAD> ::= INITIAL (   */
   if ps_xreg(mp-1) = 1 then
      itype = ps_type(mp-1);    /*  INFORMATION FROM  <TYPE DECLARATION>  */
   else
      do;
         call error('INITIAL may not be used with identifier list');
         itype = 0;
      end;


 /*  <INITIAL HEAD> ::= <INITIAL HEAD> <CONSTANT> ,    */
   call setinit;

 /*  <ASSIGNMENT> ::= <VARIABLE> <REPLACE> <EXPRESSION>    */
   call genstore(mp,sp);

 /*  <ASSIGNMENT> ::= <LEFT PART> <ASSIGNMENT>    */
   call genstore(mp,sp);

 /*  <REPLACE> ::= =    */
   ;

 /*  <LEFT PART> ::= <VARIABLE> ,    */
   ;

 /*  <EXPRESSION> ::= <LOGICAL FACTOR>    */
      ;
 /*  <EXPRESSION> ::= <EXPRESSION> | <LOGICAL FACTOR>    */
   call arithemit(OR);

 /*  <LOGICAL FACTOR> ::= <LOGICAL SECONDARY>    */
      ;

 /*  <LOGICAL FACTOR> ::= <LOGICAL FACTOR> & <LOGICAL SECONDARY>    */
   call arithemit(AND);

 /*  <LOGICAL SECONDARY> ::= <LOGICAL PRIMARY>    */
   if ps_type(mp) = CONDITION then call condtoreg(mp, ps_reg(mp));

 /*  <LOGICAL SECONDARY> ::= ~ <LOGICAL PRIMARY>    */
   do;
      call movestacks (sp, mp);
      if ps_type(mp) = CONDITION then
         do;
            if (ps_reg(mp) & "01") = 0 then
               call condtoreg(mp, ps_reg(mp) | "01");
            else
               call condtoreg(mp, ps_reg(mp) & "FE");
         end;
      else
         do;
            if ps_type(mp) = CONSTANT then
               ps_fxval(mp) = ~ ps_fxval(mp);
            else
               do;
                  call forceaccumulator (mp);
                  call emit( inst_not_r32, ps_reg(mp) );
               end;
         end;
   end;

 /*  <LOGICAL PRIMARY> ::= <STRING EXPRESSION>    */
      ;

 /*  <LOGICAL PRIMARY> ::= <STRING EXPRESSION> <RELATION> <STRING EXPRESSION>
         */
   do;
      call arithemit(CMP);
      bases(ps_reg(mp)) = AVAIL;
      ps_reg(mp) = ps_reg(mpp1);
      ps_type(mp) = CONDITION;
   end;

 /*  <RELATION> ::= =    */
   ps_reg(mp) = CC_NE;

 /*  <RELATION> ::= <    */
   ps_reg(mp) = CC_GE;

 /*  <RELATION> ::= >    */
   ps_reg(mp) = CC_LE;

 /*  <RELATION> ::= ~ =    */
   ps_reg(mp) = CC_E;

 /*  <RELATION> ::= ~ <    */
   ps_reg(mp) = CC_L;

 /*  <RELATION> ::= ~ >    */
   ps_reg(mp) = CC_G;

 /*  <RELATION> ::= < =    */
   ps_reg(mp) = CC_G;

 /*  <RELATION> ::= > =    */
   ps_reg(mp) = CC_L;

 /*  <STRING EXPRESSION> ::= <ARITHMETIC EXPRESSION>    */
      ;

 /*  <STRING EXPRESSION> ::= <STRING EXPRESSION> || <ARITHMETIC EXPRESSION>
         */
   do; /* CATENATE TWO STRINGS */
      call forcedescript(mp);
      call emit( inst_mov_m32_r32, SBR,a2, ps_reg(mp) );
      bases(ps_reg(mp)) = AVAIL;
      call forcedescript(sp);
      call emit( inst_mov_m32_r32, SBR,b2, ps_reg(sp) );
      bases(ps_reg(sp)) = AVAIL;
      call callsub(catentry,3,mp);
      ps_type(mp) = DESCRIPT;
   end;

 /*  <ARITHMETIC EXPRESSION> ::= <TERM>    */
      ;
 /*  <ARITHMETIC EXPRESSION> ::= <ARITHMETIC EXPRESSION> + <TERM>    */
   call arithemit(ADD);

 /*  <ARITHMETIC EXPRESSION> ::= <ARITHMETIC EXPRESSION> - <TERM>    */
   call arithemit(SUB);

 /*  <ARITHMETIC EXPRESSION> ::= + <TERM>    */
   call movestacks(mpp1,mp);

 /*  <ARITHMETIC EXPRESSION> ::= - <TERM>    */
   do;
      call movestacks(mpp1, mp);
      if ps_type(mp) = CONSTANT then ps_fxval(mp) = - ps_fxval(mp);
      else
         do;
            call forceaccumulator(mp);
            call emit( inst_neg_r32,  ps_reg(mp) );
         end;
   end;

 /*  <TERM> ::= <PRIMARY>    */
      ;

 /*  <TERM> ::= <TERM> * <PRIMARY>    */
   call arithemit(IMUL);

 /*  <TERM> ::= <TERM> / <PRIMARY>    */
   do;
      if (ps_type(sp) = CONSTANT & ps_type(mp) = CONSTANT) then
         ps_fxval(mp) = ps_fxval(mp) / ps_fxval(sp);
      else
         call divide_code( 1 ); /*  DIVIDE IS FUNNY */
   end;

 /*  <TERM> ::= <TERM> MOD <PRIMARY>    */
   do;
      if (ps_type(sp) = CONSTANT & ps_type(mp) = CONSTANT) then
         ps_fxval(mp) = ps_fxval(mp) mod ps_fxval(sp);
      else
         call divide_code( 0 ); /*  DIVIDE IS FUNNY */
   end;

 /*  <PRIMARY> ::= <CONSTANT>    */
      ;
 /*  <PRIMARY> ::= <VARIABLE>    */
      if ps_fxval(mp) = 3 & ps_xreg(mp) ~= NOREG then
         /* FINISH OFF THE FUNCTION BYTE */
         do;
            if ps_type(mp) = CHRTYPE & length(ps_name(mp)) = 0 then
               // BYTE(''[,*])
               do;
                  ps_type(mp) = CONSTANT;
                  ps_fxval(mp) = 0;
               end;
            else
               if ps_cnt(mp) = 1 then
                  do;
                     if ps_type(mp) = CHRTYPE then
                        // BYTE('...')
                        do;
                           ps_type(mp) = CONSTANT;
                           ps_fxval(mp) = byte(ps_name(mp));
                        end;
                     else
                        // BYTE(VAR)
                        do;
                           ps_type(mp) = ACCUMULATOR;
                           i = ps_reg(mp);
                           call emit( inst_and_r32_imm32, i, "FFFFFF");
                           j = pp;
                           call branch( CC_E, 0 );
                           call emit( inst_mov_r8_m8, i, i,0 );
                           call emit( inst_movzx_r32_r8, i, i );
                           call fixbfw( j, pp );
                        end;
                  end;
               else if ps_cnt(mp) = 2 then
                  do;
                     if ps_type(mp) = CHRTYPE then
                        // BYTE('...',*)
                        do;
                           if ps_xreg(mp) ~= 0 then
                              // BYTE('...',VAR)
                              do;
                                 call forcedescript (mp);
                                 ps_type(mp) = ACCUMULATOR;
                                 i = ps_reg(mp);
                                 call emit( inst_and_r32_imm32, i, "00FFFFFF" );
                                 call emit( inst_mov_r8_Xx1m8, i, ps_xreg(mp), i,0 );
                                 call emit( inst_movzx_r32_r8, i, i );
                                 bases(ps_xreg(mp)) = AVAIL;
                              end;
                           else
                              // BYTE('...',CONST)
                              do;
                                 ps_type(mp) = CONSTANT;
                                 if length(ps_name(mp)) <= ps_pp(mp) then
                                    // BYTE('...',CONST-GREATER-THEN-LENGTH('...'))
                                    ps_fxval(mp) = 0;
                                 else
                                    // BYTE('...',CONST)
                                    ps_fxval(mp) = byte(ps_name(mp),ps_pp(mp));
                              end;
                        end;
                     else
                        // BYTE(VAR,*)
                        do;
                           i = ps_reg(mp);
                           call emit( inst_and_r32_imm32, i, "00FFFFFF" );
                           j = pp;
                           call branch( CC_E, 0 );
                           if ps_xreg(mp) ~= 0 then
                              // BYTE(VAR,VAR)
                              do;
                                 call emit( inst_mov_r8_Xx1m8, i, ps_xreg(mp), i,0 );
                                 bases(ps_xreg(mp)) = AVAIL;
                              end;
                           else
                              // BYTE(VAR,CONST)
                              call emit( inst_mov_r8_m8, i, i,ps_pp(mp) );
                           call emit( inst_movzx_r32_r8, i, i );
                           call fixbfw( j, pp );
                           ps_type(mp) = ACCUMULATOR;
                        end;
                  end;
         end;

 /*  <PRIMARY> ::= ( <EXPRESSION> )    */
   call movestacks(mpp1, mp);
 /*  <VARIABLE> ::= <IDENTIFIER>    */
   do;      /* FIND THE IDENTIFIER IN THE SYMBOL TABLE */
      call id_lookup(mp);
      // Syntactical sugar to allow symbolic names as the first four arguments to INLINE
      if mp > 0 then
         if parse_stack(mp-1) = subscript_head & ps_fxval(mp-1) = 10 /*INLINE*/ & ps_cnt(mp-1) < 4 then
            do;
               ps_type(mp) = CHRTYPE;
               return;
            end;
      if ps_fxloc(mp) = -1 then
         call undeclared_id(mp);
   end;

 /*  <VARIABLE> ::= <SUBSCRIPT HEAD> <EXPRESSION> )    */
   do;  /* EITHER A PROCEDURE CALL OR ARRAY OR BUILT IN FUNCTION */
      ps_cnt(mp) = ps_cnt(mp) + 1;
      i = ps_fxval(mp);

      if i < 6 then
      do case i;

         /* CASE  0  */

         do;      /* SUBS | CALL */
            if syt_type(ps_fxloc(mp)) = LABELTYPE | syt_type(ps_fxloc(mp)) = CHAR_PROC_TYPE  then
               do;
                  call stuff_parameter;
                  call forceaccumulator(mp);
               end;
            else
               do;      /* SUBSCRIPTED VARIABLE */
                  if ps_cnt(mp) > 1 then
                     call error ('Multiple subscripts not allowed');
                  if ps_type(mpp1) = CONSTANT then
                     do;
                        if ps_fxval(mpp1) ~= 0 then
                           do;
                              /* CONSTANT SUBSCRIPT */
                              ps_xreg(mp) = NOREG;
                              ps_fxval(mp) = ps_fxval(mpp1);
                           end;
                     end;
                  else
                     do;
                        call forceaccumulator (mpp1);
                        if ps_type(mpp1) ~= ACCUMULATOR then
                           call error('String not allowed as a subscript', 1);
                        ps_xreg(mp) = ps_reg(mpp1);
                     end;
               end;
         end;

         /* CASE  1  */

         do;  /* BUILT IN FUNCTION: LENGTH */
            call forcedescript (mpp1);
            /* Code sequence from GNU's super-optimizer: it's longer, but there are no jumps */
            call emit( inst_mov_r32_r32, EAX, ps_reg(mpp1) );
            call emit( inst_shr_r32_imm8, ps_reg(mpp1), 24 );
            call emit( inst_neg_r32, EAX );
            call emit( inst_adc_r32_imm8, ps_reg(mpp1), 0 );
            ps_reg(mp) = ps_reg(mpp1);  /* RECORD CONTAINING ACCUMULATOR */
            ps_type(mp) = ACCUMULATOR;
         end;

         /* CASE  2  */

         /* BUILT-IN FUNCTION SUBSTR */
         do;
            if ps_cnt(mp) = 2 then
               do;
                  if ps_type(mpp1) = CONSTANT then
                     call emit( inst_sub_r32_imm32, ps_reg(mp), shl(ps_fxval(mpp1), 24) - ps_fxval(mpp1) );
                  else
                     do;
                        call forceaccumulator (mpp1);
                        call emit( inst_add_r32_r32, ps_reg(mp), ps_reg(mpp1) ); /* ALR BASE */
                        call emit( inst_shl_r32_imm8, ps_reg(mpp1), 24 );
                        call emit( inst_sub_r32_r32, ps_reg(mp), ps_reg(mpp1) );
                        bases(ps_reg(mpp1)) = AVAIL;
                     end;
                  i = pp;
                  call branch (CC_NC, 0);  /* WE MAY NOW HAVE NEGATIVE LENGTH */
                  /* NULL DESCRIPTOR */
                  call emit( inst_sub_r32_r32, ps_reg(mp), ps_reg(mp) );
                  /* NULL DESCRIPTOR */
                  call fixbfw (i, pp);
               end;
            else
               do;         /* THREE ARGUMENTS */
                  if ps_type(mpp1) = CONSTANT & ps_fxval(mpp1) <= 0 then
                     call emit( inst_sub_r32_r32, ps_reg(mp), ps_reg(mp) );
                  else
                     do;
                        if ps_pp(mp) ~= 0 then
                           call emit( inst_lea_r32_m32, ps_reg(mp), ps_reg(mp),ps_pp(mp) );
                        if ps_xreg(mp) ~= 0 then
                           call emit( inst_add_r32_r32, ps_reg(mp), ps_xreg(mp) );
                        call emit( inst_and_r32_imm32, ps_reg(mp), "FFFFFF");
                        bases(ps_xreg(mp)) = AVAIL;
                        if ps_type(mpp1) ~= CONSTANT then
                           do;
                              call forceaccumulator (mpp1);
                              call emit( inst_dec_r32, ps_reg(mpp1) );
                              i = pp;
                              call branch(CC_GE, 0);
                              call emit( inst_mov_r32_r32, ps_reg(mpp1), ps_reg(mp) );
                              j = pp;
                              call jump( 0 );
                              call fixbfw( i, pp );
                              call emit( inst_shl_r32_imm8, ps_reg(mpp1), 24 );
                              call fixbfw( j, pp );
                              call emit( inst_xor_r32_r32, ps_reg(mp), ps_reg(mpp1) ); /* | INTO D */
                              bases(ps_reg(mpp1)) = AVAIL;
                           end;
                        else
                           do;
                              i = ps_fxval(mpp1) - 1;
                              if i > 0 then
                                 call emit( inst_or_r32_imm32, ps_reg(mp), shl(i,24) );
                           end;
                     end;
               end;
            ps_type(mp) = DESCRIPT;
         end;

         /* CASE  3  */

         do;      /* BUILT IN FUNCTION BYTE */
            if ps_cnt(mp) = 1 then
               do;
                  ps_xreg(mp) = 0;
                  if ps_type(mpp1) = CHRTYPE then
                     do;
                        ps_type(mp) = CHRTYPE;
                        ps_name(mp) = ps_name(mpp1);
                     end;
                  else
                     do;
                        call forcedescript(mpp1);
                        if ps_reg(mpp1) = EAX then
                           do;
                              ps_reg(mp) = findac;
                              call emit( inst_mov_r32_r32, ps_reg(mp), EAX);
                           end;
                        else
                           ps_reg(mp) = ps_reg(mpp1);
                        ps_type(mp) = DESCRIPT;
                    end;
               end;
            else if ps_cnt(mp) = 2 then
               do;
                  if ps_type(mpp1) = CONSTANT then
                     do;
                        ps_xreg(mp) = 0;
                        ps_pp(mp) = ps_fxval(mpp1);
                     end;
                  else
                     do;
                        call forceaccumulator(mpp1);
                        ps_xreg(mp) = ps_reg(mpp1);
                     end;
               end;
            else
               call error('BYTE called with more than two arguments');
         end;

         /* CASE  4  */

         call shift_code(SLL);        /*  shl  */

         /* CASE  5  */

         call shift_code(SRL);        /*  shr  */

      end;     /* OF CASE STATEMENT */

      else if 6 <= i & i <= 8 then    /* INPUT, OUTPUT, FILE */
         do;
            if ps_type(mpp1) = CONSTANT then
               do;
                  /* Constant subscript; should be a small integer */
                  if ps_cnt(mp) = 1 then  /* should only be INPUT or OUTPUT */
                     ps_reg(mp) = NOREG;
                  else                    /* should only be FILE */
                     ps_xreg(mp) = NOREG;
                  ps_pp(mp) = ps_fxval(mpp1);
               end;
            else
               do;
                  target_register = EDX;
                  call forceaccumulator (mpp1);
                  target_register = -1;;
                  if ps_cnt(mp) = 1 then
                     ps_reg(mp) = ps_reg(mpp1);
                  else
                     ps_xreg(mp) = ps_reg(mpp1);
               end;
         end;

      else if i = 10 then
         call emit_inline(TRUE);
      else if i = 19 then    /*  BUILTIN  FUNCTION  ADDR   */
         do;
            ps_reg(mp) = findac;
            call force_address(mpp1,ps_reg(mp));
            ps_type(mp) = ACCUMULATOR;
         end;
      else
         do;
            call forceaccumulator (mpp1);
            if ps_cnt(mp) = 1 then ps_reg(mp) = ps_reg(mpp1);
            else ps_xreg(mp) = ps_reg(mpp1);
         end;

   end;     /* OF PRODUCTION */

 /*  <SUBSCRIPT HEAD> ::= <IDENTIFIER> (   */
   do;
      call id_lookup(mp);
      if ps_fxloc(mp) < 0 then
         call undeclared_id(mp);
   end;

 /*  <SUBSCRIPT HEAD> ::= <SUBSCRIPT HEAD> <EXPRESSION> ,    */
   do;      /* BUILT IN FUNCTION OR PROCEDURE CALL */
      ps_cnt(mp) = ps_cnt(mp) + 1;
      if ps_fxval(mp) = 0 then
         do;      /* NOT BUILT IN FUNCTION */
            if syt_type(ps_fxloc(mp)) = LABELTYPE | syt_type(ps_fxloc(mp)) = CHAR_PROC_TYPE  then
               call stuff_parameter;
            else
               call error('IDENTIFIER(arg...) is not a function!', 2);
         end;
      else if ps_fxval(mp) = 2 | ps_fxval(mp) = 3 then
         do;      /* SUBSTR OR BYTE */
            if ps_cnt(mp) = 1 then
               do;
                  if ps_type(mpp1) = CHRTYPE & ps_fxval(mp) = 3 then
                     do;
                        ps_type(mp) = CHRTYPE;
                        ps_name(mp) = ps_name(mpp1);
                     end;
                  else
                     do;
                        call forcedescript (mpp1);
                        if ps_reg(mpp1) = EAX then
                           do;
                              ps_reg(mp) = findac;
                              call emit( inst_mov_r32_r32, ps_reg(mp),  EAX );
                           end;
                        else ps_reg(mp) = ps_reg(mpp1);
                     end;
               end;
            else if ps_cnt(mp) = 2 then
               do;
                  if ps_type(mpp1) = CONSTANT then
                     do;
                        ps_xreg(mp) = 0;
                        ps_pp(mp) = ps_fxval(mpp1);
                     end;
                  else
                     do;
                        call forceaccumulator (mpp1);
                        ps_xreg(mp) = ps_reg(mpp1);
                        ps_pp(mp) = 0;
                     end;
               end;
            else call error ('Too many arguments to SUBSTR | BYTE');
         end;
      else if ps_fxval(mp) = 4 | ps_fxval(mp) = 5 then
         do;  /*  SHR  |  SHL  */
            if ps_type(mpp1) = CONSTANT then
               do;
                  ps_type(mp) = CONSTANT;
                  ps_pp(mp) = ps_fxval(mpp1);
               end;
            else
               do;
                  call forceaccumulator(mpp1);
                  ps_reg(mp) = ps_reg(mpp1);
               end;
         end;
      else if ps_fxval(mp) = 10 then
         call emit_inline(FALSE);
      else if ps_fxval(mp) = 8 then
         do;      /* FILE */
            if ps_cnt(mp) = 1 then
               do;
                  if ps_type(mpp1) = CONSTANT then
                     do;
                        /* Constant subscript; should be 1 to 4 */
                        if ps_fxval(mpp1) = 0 | (ps_fxval(mpp1) > (255 - NOREG)) then
                           call error('Illegal reference to FILE(' || ps_fxval(mpp1) || ',*) pseudo array', 1);
                        ps_reg(mp) = NOREG + ps_fxval(mpp1);
                     end;
                  else
                     do;
                        target_register = ECX;
                        call forceaccumulator (mpp1);
                        target_register = -1;
                        ps_reg(mp) = ps_reg(mpp1);
                     end;
               end;
            else call error ('Too many arguments for ' || syt_name(ps_fxloc(mp)));
         end;
      else if ps_fxval(mp) >= 9 then
         do;      /* SOME SORT OF MONITOR CALL */
            call forceaccumulator (mpp1);
            if ps_cnt(mp) = 1 then ps_reg(mp) = ps_reg(mpp1);
            else call error ('Too many arguments for ' || syt_name(ps_fxloc(mp)));
         end;
      else;      /* RESERVED FOR OTHER BUILT IN FUNCTIONS */
   end;

 /*  <CONSTANT> ::= <STRING>    */
   ps_type(mp) = CHRTYPE;

 /*  <CONSTANT> ::= <NUMBER>    */
   ps_type(mp) = CONSTANT;

   end;  /* OF CASE SELECTION ON PRODUCTION NUMBER */
end synthesize;




  /*              SYNTACTIC PARSING FUNCTIONS                              */


right_conflict:
   procedure (left) bit(1);
      declare left fixed;
      /*  THIS PROCEDURE IS TRUE IF TOKEN IS ~ A LEGAL RIGHT CONTEXT OF LEFT*/
      return ("C0" & shl(byte(C1(left), shr(token,2)), shl(token,1) & "06")) = 0;
   end right_conflict;


recover:
   procedure;
      /* IF THIS IS THE SECOND SUCCESSIVE CALL TO RECOVER, DISCARD ONE SYMBOL */
      if ~ failsoft then call scan;
      failsoft = FALSE;
      do while ~ stopit(token);
         call scan;  /* TO FIND SOMETHING SOLID IN THE TEXT  */
      end;
      do while right_conflict (parse_stack(sp));
         if sp > 2 then sp = sp - 1;  /* AND IN THE STACK  */
         else call scan;  /* BUT DON'T GO TOO FAR  */
      end;
      if text_used > 1 then
         output = 'Resume:' || pad(x1,text_used-1) || vbar;
      else
         output = 'Resume:|';
   end recover;

stacking:
   procedure bit(1);  /* STACKING DECISION FUNCTION */
      count#stack = count#stack + 1;
      do FOREVER;    /* UNTIL RETURN  */
         do case shr(byte(C1(parse_stack(sp)),shr(token,2)),shl(3-token,1)&6)&3;

            /*  CASE 0  */
            do;    /* ILLEGAL SYMBOL PAIR  */
               call error('Illegal symbol pair: ' || V(parse_stack(sp)) || x1 || V(token), 1);
               call stack_dump;
               call recover;
            end;

            /*  CASE 1  */

            return TRUE;      /*  STACK TOKEN  */

            /*  CASE 2  */

            return FALSE;     /* DON'T STACK IT YET  */

            /*  CASE 3  */

            do;      /* MUST CHECK TRIPLES  */
               j = shl(parse_stack(sp-1), 16) + shl(parse_stack(sp), 8) + token;
               i = -1;  k = NC1TRIPLES + 1;  /* BINARY SEARCH OF TRIPLES  */
               do while i + 1 < k;
                  l = shr(i+k, 1);
                  if C1TRIPLES(l) > j then k = l;
                  else if C1TRIPLES(l) < j then i = l;
                  else return TRUE;  /* IT IS A VALID TRIPLE  */
               end;
               return FALSE;
            end;

         end;    /* OF DO CASE  */
      end;   /*  OF DO FOREVER */
   end stacking;

pr_ok:
   procedure(prd) bit(1);
      /* DECISION PROCEDURE FOR CONTEXT CHECK OF EQUAL OR IMBEDDED RIGHT PARTS*/
      declare (h, i, j, prd) fixed;
      do case CONTEXT_CASE(prd);

         /*  CASE 0 -- NO CHECK REQUIRED  */

         return TRUE;

         /*  CASE 1 -- RIGHT CONTEXT CHECK  */

         return ~ right_conflict (HDTB(prd));

         /*  CASE 2 -- LEFT CONTEXT CHECK  */

         do;
            h = HDTB(prd) - NT;
            i = parse_stack(sp - PRLENGTH(prd));
            do j = LEFT_INDEX(h-1) to LEFT_INDEX(h) - 1;
               if LEFT_CONTEXT(j) = i then return TRUE;
            end;
            return FALSE;
         end;

         /*  CASE 3 -- CHECK TRIPLES  */

         do;
            h = HDTB(prd) - NT;
            i = shl(parse_stack(sp - PRLENGTH(prd)), 8) + token;
            do j = TRIPLE_INDEX(h-1) to TRIPLE_INDEX(h) - 1;
               if CONTEXT_TRIPLE(j) = i then return TRUE;
            end;
            return FALSE;
         end;

      end;  /* OF DO CASE  */
   end pr_ok;


  /*                     ANALYSIS ALGORITHM                                  */



reduce:
   procedure;
      declare (i, j, prd) fixed;
      /* PACK THE TOP FOUR TOKENS ON THE PARSE STACK INTO ONE WORD (J)  */
#ifdef NOINLINE
      do i = sp - 4 to sp - 1;
         j = shl(j, 8) + parse_stack(i);
      end;
#else
      i = addr(parse_stack(sp-4));
      call inline( MOV,R32,M32,NONE, EAX, i );
      call inline( MOV,R32,M32,NONE, EAX, EAX,0 );
      call inline( BSWAP,R32,NONE,NONE, EAX );
      call inline( MOV,M32,R32,NONE, j, EAX );
#endif

      do prd = PR_INDEX(parse_stack(sp)-1) to PR_INDEX(parse_stack(sp)) - 1;
         if (prmask(PRLENGTH(prd)) & j) = PRTB(prd) then
            if pr_ok(prd) then
            do;  /* AN ALLOWED REDUCTION */
               mp = sp - PRLENGTH(prd) + 1; mpp1 = mp + 1;
               i = PRDTB(prd);
               if 0 ~= i then
                  call synthesize(i);
               ps_name(mpp1+1),ps_name(mpp1) = '';  /* PURGE UNNEEDED STRINGS */
               sp = mp;
               parse_stack(sp) = HDTB(prd);
               return;
            end;
      end;

      /* LOOK UP HAS FAILED, ERROR CONDITION */
      call error('No production is applicable',1);
      call stack_dump;
      failsoft = FALSE;
      call recover;
   end reduce;

compilation_loop:
   procedure;

      compiling = TRUE;
      stackmax = 0;
      do while compiling;     /* ONCE AROUND FOR EACH PRODUCTION (REDUCTION)  */
         do while stacking;
            sp = sp + 1;
            if sp > stackmax then
               stackmax = sp;
            if sp = STACKSIZE then
               do;
                  call error ('Stack overflow *** COMPILATION ABORTED ***', 2);
                  return;   /* THUS ABORTING COMPILATION */
               end;
            parse_stack(sp) = token;
            ps_name(sp) = bcd;
            ps_fxval(sp) = number_value;
            ps_fxloc(sp) = card_count;
            ps_pp(sp) = pp;
            call scan;
         end;

         call reduce;
      end;     /* OF DO WHILE COMPILING  */
   end compilation_loop;


loader:
   procedure;

      /*  WRITE OUT A LOAD FILE OF COMPILED CODE & DATA
         ASSUMES CODE ON  FILE(CODEFILE, J)    J = 0 TO CODEMAX
         ASSUMES DATA ON  FILE(DATAFILE, J)   J = 0 TO DATAMAX
         ASSUMES DESCRIPTORS ON FILE(STRINGFILE,J)   J = 0 TO STRNGBLK - 1
         ASSUMES STRINGS ON FILE(STRINGFILE,J)   J = STRNGBLK ...
         OUTPUT  ON FILE(BINARYFILE, J)  J = 0 TO CODEMAX+DATAMAX+1
         ASSUMES THAT BINARYFILE = CODEFILE    */


      /*  PUT SOME CONTROL INFORMATION IN THE FIRST 60 BYTES OF THE
         FIRST BLOCK OF CODE.  CONSECUTIVE WORDS OF THIS CONTROL
         INFORMATION CONTAIN:

            1  # OF BYTES OF PROGRAM
            2  # OF BYTES OF DATA
            3  # OF BLOCKS OF PROGRAM
            4  # OF BLOCKS OF DATA
            5  # OF BYTES PER BLOCK
            6  # OF BYTES ACTUALLY FILLED IN THE LAST CODE BLOCK
            7  # OF BYTES ACTUALLY FILLED IN THE LAST DATA BLOCK

         THE FILE IS FORMATTED:

            1  CODEMAX+1 BLOCKS OF PROGRAM
               (AND CONTROL INFORMATION AT HEAD OF FIRST BLOCK)
            2  DATAMAX+1 BLOCKS OF DATA AND STRINGS
      */

      declare (i, j) fixed;
      declare blockcnt fixed;  /* CUMMULATIVE BLOCK COUNTER DURING LOAD */

      control(byte('E')) = FALSE;
      EJECT_PAGE;
      dp = bases(SBR);
      call fixwholedataword (basedata, dp);

      /* COPY COMPILED STRING DESCRIPTORS TO THE PROGRAM DATA AREA */
      dsporg = 0;
      dsplim = DISKBYTES;
      file(STRINGFILE,curdsblk) = desc;    /* WRITE OUT CURRENT BLOCK */
      curdsblk = 0;
      desc = file(STRINGFILE,curdsblk);    /* READ IN FIRST BLOCK */

      do i = 0 to dsp by 4;
         if i >= dsplim then
            do;
               curdsblk = curdsblk + 1;
               desc = file(STRINGFILE,curdsblk);   /* READ IN NEXT BLOCK */
               dsporg = dsporg + DISKBYTES;
               dsplim = dsplim + DISKBYTES;
            end;
         call emitDataword( descmax(shr(i-dsporg,2) + 1) );
      end;
      call fixwholedataword(basedata+4, dp);

      /* COPY COMPILED CHARACTER STRINGS TO THE PROGRAM DATA AREA */
      chporg = 0;
      chplim = DISKBYTES;
      file(STRINGFILE,strngblk + cursblk) = strings;    /* WRITE OUT CURRENT BLOCK */
      cursblk = 0;
      strings = file(STRINGFILE,strngblk + cursblk);    /* READ IN FIRST BLOCK */

      do i = 0 to chp-1 ;
         if i >= chplim then
            do;
               cursblk = cursblk + 1;
               strings = file(STRINGFILE,strngblk + cursblk);   /* READ IN NEXT BLOCK */
               chporg = chporg + DISKBYTES;
               chplim = chplim + DISKBYTES;
            end;
         call emitByte(strings(i-chporg));
      end;

      call fixwholedataword(basedata+8, dp);

      call insert_code_fixups;

      code = file(CODEFILE,0);        /*  READ IN FIRST CODE RECORD  */

      codemax(1) = DISKBYTES*(codemax+1);
      codemax(2) = DISKBYTES*(datamax+1);
      codemax(3) = codemax + 1;
      codemax(4) = datamax + 1;
      codemax(5) = DISKBYTES;
      if severe_errors > 0 then if ~ control(byte('Z')) then
         do;
            code(60) = "C3"; /* RET */
            output = '########  Execution of this program will be inhibited.';
         end;
      j = pp - codemax(1) + DISKBYTES;    /*  PORTION ACTUALLY  USED  */
      /* FORCES REMAINDER TO WORD BOUNDARY  */
      j = (j + 3) & "FFFFFC";
      codemax(6) = j;
        /* PORTION OF THE LAST DATA RECORD WHICH WAS ACTUALLY USED  */
      codemax(7) = (dp - codemax(2) + (DISKBYTES + 3)) & "FFFFFC" ;


      output = '*  File control block  ' || codemax(1) || x4 ||
               codemax(2) || x4 || codemax(3) || x4 || codemax(4) || x4 ||
               codemax(5) || x4 || codemax(6) || x4 || codemax(7);

      file(BINARYFILE,0) = code;   /* WRITE FIRST RECORD TO BINARY FILE */

      blockcnt = codemax + 1;

      file(DATAFILE,curdblk) = data;  /* WRITE OUT CURRENT DATA ARRAY */


      /*  WRITE OUT THE COMPILE DATA ARRAY  */

      do j = 0 to datamax;
         data = file(DATAFILE,j);
         file(BINARYFILE, blockcnt)  =  data ;
         blockcnt = blockcnt + 1;
      end;

      output = '*  Load file written.';

   end loader;


print_summary:
   procedure;
      declare i fixed;
      call print_date_and_time ('End of compilation ', date, time);
      output = '';
      output = card_count || ' cards containing ' || statement_count ||
                                                   ' statements were compiled.';
      if error_count = 0 then output = 'No errors were detected.';
      else if error_count > 1 then
         output = error_count || ' errors (' || severe_errors ||
                                                      ' severe) were detected.';
      else if severe_errors = 1 then output = 'One severe error was detected.';
         else output = 'One error was detected.';
      if previous_error > 0 then
         output = 'The last detected error was on line ' || previous_error || period;
      output = pp || ' bytes of program, ' || dp-dsp-chp || ' of data, ' || dsp
               || ' (of ' || MAXDESC * 4 || ') descriptors, ' || chp
               || ' of strings.  Total core requirement'
               || x1 || pp + dp || ' bytes.';
      if control(byte('D')) then call dumpit;
      DOUBLE_SPACE;
      clock(3) = time;
      do i = 1 to 3;   /* WATCH OUT FOR MIDNIGHT */
         if clock(i) < clock(i-1) then clock(i) = clock(i) +  (24 * 60 * 60 * 100);
      end;
      call print_time ('Total time in compiler   ', clock(3) - clock(0), TRUE);
      call print_time ('Set up time              ', clock(1) - clock(0), TRUE);
      call print_time ('Actual compilation time  ', clock(2) - clock(1), TRUE);
      call print_time ('Post-compilation time    ', clock(3) - clock(2), TRUE);
      if clock(2) > clock(1) then   /* WATCH OUT FOR CLOCK BEING OFF */
      output = 'Compilation rate: ' || (100*card_count)/(clock(2)-clock(1)) ||
                                                           ' cards per second.';
   end print_summary;

main_procedure:
   procedure;
      clock(0) = time;  /* KEEP TRACK OF TIME IN EXECUTION */
      call initialization;

      /* CLOCK(1) GETS SET IN GETCARD */
      call compilation_loop;

      clock(2) = time;
      call loader;

      /* CLOCK(3) GETS SET IN PRINT_SUMMARY */
      call print_summary;

   end main_procedure;

#ifdef DEBUG
control(byte('E')) = TRUE;
control(byte('B')) = TRUE;
#endif

call main_procedure;
return severe_errors;

/* vi: set sw=3 ai sm expandtab: */
